function AutoSaver_saveLoop()
{
	cancel($CityRPG::AutosaverAutosaver::SaveLoop);
	if($CityRPG::Autosaver::SaveTime < 1)
	{
		$CityRPG::Autosaver::SaveTime = 1;
	}
	if($CityRPG::Autosaver::SaveFile $= "")
	{
		$CityRPG::Autosaver::SaveFile = "autosave";
	}
	AutoSaver_saveBricks(fileBase($CityRPG::Autosaver::SaveFile),$CityRPG::Autosaver::SaveEvents,$CityRPG::Autosaver::SaveOwnership);
	$CityRPG::Autosaver::SaveLoop = schedule($CityRPG::Autosaver::SaveTime * 60000,0,"AutoSaver_saveLoop");
}
//Modified version of Randy's saveBricks function
function AutoSaver_saveBricks(%name,%events,%ownership)
{
	if(%name $= "" || %events $= "" || %ownership $= "" || (%events !$= 1 && %events !$= 0) || (%ownership !$= 1 && %ownership !$= 0))
	{
		echo("Auto Saver Error: Incorrect usage.");
		return;
	}
	%path = "saves/" @ MissionInfo.saveName @ "/" @ %name @ ".bls";
	if(!isWriteableFileName(%path))
	{
		echo("Auto Saver Error: Cannot save to file: " @ %path);
		return;
	}
	%file = new FileObject();
	%file.openForWrite(%path);
	%file.writeLine("This is a Blockland save file.  You probably shouldn't modify it cause you'll screw it up.");
	%file.writeLine("1"); // What does this mean?
	%file.writeLine(%desc);
	for(%i=0;%i<64;%i++)
		%file.writeLine(getColorIDTable(%i));
	%bricks = 0;
	for(%i=0;%i<mainBrickGroup.getCount();%i++)
		%bricks += mainBrickGroup.getObject(%i).getCount();
	%file.writeLine("Linecount " @ %bricks);
	for(%d=0;%d<2;%d++)
	{
		for(%i=0;%i<mainBrickGroup.getCount();%i++)
		{
			%group = mainBrickGroup.getObject(%i);
			for(%a=0;%a<%group.getCount();%a++)
			{
				%brick = %group.getObject(%a);
				if(!(%d ^ %brick.isBasePlate()))
					continue;
				if(%brick.getDataBlock().hasPrint)
				{
					%texture = getPrintTexture(%brick.getPrintId());
					%path = filePath(%texture);
					%underscorePos = strPos(%path, "_");
					%name = getSubStr(%path, %underscorePos + 1, strPos(%path, "_", 14) - 14) @ "/" @ fileBase(%texture);
					if($printNameTable[%name] !$= "")
					{
						%print = %name;
					}
				}
				%file.writeLine(%brick.getDataBlock().uiName @ "\" " @ %brick.getPosition() SPC %brick.getAngleID() SPC %brick.isBasePlate() SPC %brick.getColorID() SPC %print SPC %brick.getColorFXID() SPC %brick.getShapeFXID() SPC %brick.isRayCasting() SPC %brick.isColliding() SPC %brick.isRendering());
				if(%ownership && %brick.isBasePlate() && !$Server::LAN)
					%file.writeLine("+-OWNER " @ getBrickGroupFromObject(%brick).bl_id);
				if(%events)
				{
					if(%brick.getName() !$= "")
						%file.writeLine("+-NTOBJECTNAME " @ %brick.getName());
					for(%b=0;%b<%brick.numEvents;%b++)
					{
						%targetClass = %brick.eventTargetIdx[%b] >= 0 ? getWord(getField($InputEvent_TargetListfxDTSBrick_[%brick.eventInputIdx[%b]], %brick.eventTargetIdx[%b]), 1) : "fxDtsBrick";
						%paramList = $OutputEvent_parameterList[%targetClass, %brick.eventOutputIdx[%b]];
						%params = "";
						for(%c=0;%c<4;%c++)
						{
								if(firstWord(getField(%paramList, %c)) $= "dataBlock" && isObject(%brick.eventOutputParameter[%b, %c + 1]))
									%params = %params TAB %brick.eventOutputParameter[%b, %c + 1].getDataBlock();
								else
									%params = %params TAB %brick.eventOutputParameter[%b, %c + 1];
						}
						%file.writeLine("+-EVENT" TAB %b TAB %brick.eventEnabled[%b] TAB %brick.eventInput[%b] TAB %brick.eventDelay[%b] TAB %brick.eventTarget[%b] TAB %brick.eventNT[%b] TAB %brick.eventOutput[%b] @ %params);
					}
				}
				if(isObject(%brick.emitter))
					%file.writeLine("+-EMITTER " @ %brick.emitter.emitter.uiName @ "\" " @ %brick.emitterDirection);
				if(%brick.getLightID() >= 0)
					%file.writeLine("+-LIGHT " @ %brick.getLightID().getDataBlock().uiName @ "\" "); // Not sure if something else comes after the name
				if(isObject(%brick.item))
					%file.writeLine("+-ITEM " @ %brick.item.getDataBlock().uiName @ "\" " @ %brick.itemPosition SPC %brick.itemDirection SPC %brick.itemRespawnTime);
				if(isObject(%brick.audioEmitter))
					%file.writeLine("+-AUDIOEMITTER " @ %brick.audioEmitter.getProfileID().uiName @ "\" "); // Not sure if something else comes after the name
				if(isObject(%brick.vehicleSpawnMarker))
					%file.writeLine("+-VEHICLE " @ %brick.vehicleSpawnMarker.uiName @ "\" " @ %brick.reColorVehicle);
			}
		}
	}
	%file.close();
	%file.delete();
	echo("Auto Saver: "@%bricks@" bricks saved to "@%path@" successfully.");
	messageall('', '\c6Auto Saver saved \c3%1 \c6bricks to \c3%2 \c6successfully.', %bricks, %path);
}
function serverCmdStartAutoSaver(%client)
{
	if(%client.isSuperAdmin)
	{
		cancel($CityRPG::Autosaver::SaveLoop);
		$CityRPG::Autosaver::SaveLoop = schedule($CityRPG::Autosaver::SaveTime * 60000,0,"AutoSaver_saveLoop");
		messageAll('',"\c3" @ %client.getPlayerName() @ "\c6 has started the auto saver.");
	}
	else
	{
		messageClient(%client,'',"\c6Only \c0Super Admins\c6 may start the auto saver.");
	}
}
function serverCmdStopAutoSaver(%client)
{
	if(%client.isSuperAdmin)
	{
		cancel($CityRPG::Autosaver::SaveLoop);
		messageAll('',"\c3" @ %client.getPlayerName() @ "\c6 has stopped the auto saver.");
	}
	else
	{
		messageClient(%client,'',"\c6Only \c0Super Admins\c6 may stop the auto saver.");
	}
}
