// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia
// Description			:	Employment Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGEmploymentBrickData : brick2x4FData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Admin";
	
	uiName = "Employment Brick";
	
	CityRPGBrickType = 2;
	CityRPGBrickAdmin = true;
	
	triggerDatablock = CityRPGInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPGEmploymentBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%client.getWantedLevel())
	{
		messageClient(%client, '', "\c6The service refuses to serve you.");
		return;
	}
	
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c6Welcome to the Employment Office");
			messageClient(%client, '', '\c6- Your Current Job is: \c3%1', %client.getJobSO().name);
			messageClient(%client, '', "\c61 \c3- Apply For a New Job");
			messageClient(%client, '', "\c62 \c3- List Of Jobs");
			messageClient(%client, '', "\c60 \c3- Exit");
		
			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if(strReplace(%input, "1", "") !$= %input || strReplace(%input, "one", "") !$= %input)
		{
			%client.stage = 1.1;
			messageClient(%client, '', "\c6What job do you want to apply for?");
			return;
		}
	}
	
	if(mFloor(%client.stage) == 1)
	{
		if(%client.stage == 1.1)
		{
			// %job = %job @ (%job2 !$= "" ? " " @ %job2 @ (%job3 !$= "" ? " " @ %job3 @ (%job4 !$= "" ? " " @ %job4 @ (%job5 !$= "" ? " " @ %job5 : "") : "") : "") : "");
			
			for(%a = 1; %a <= JobSO.getJobCount(); %a++)
			{
				if(%input $= strLwr(JobSO.job[%a].name))
				{
					%foundJob = true;
					
					if(%a == CityRPGData.getData(%client.bl_id).valueJobID)
					{
						messageClient(%client, '', "\c6You are already" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6!");
					}
					else
					{
						if(JobSO.job[%a].law && getWord(CityRPGData.getData(%client.bl_id).valueJailData, 0) == 1)
						{
							messageClient(%client, '', "\c6You don't have a clean criminal record. You can't become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
						}
						else
						{
							if(mFloor(JobSO.job[%a].education) > 0)
							{
								if(CityRPGData.getData(%client.bl_id).valueEducation < JobSO.job[%a].education)
								{
									messageClient(%client, '', "\c6You are not educated enough to get this job.");
								}
								else
								{
									if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
									{
										messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
									}
									else
									{
										%gotTheJob = true;
										messageClient(%client, '', "\c6Congratulations, you are now" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
										CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
										%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
									}
								}
							}
							else
							{
								if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
								{
									messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
									messageClient(%client, '', "\c6Thanks, come again.");
									%client.stage = "";
								}
								else
								{
									%gotTheJob = true;
									messageClient(%client, '', "\c6You have made your own initiative to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
									CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
									messageClient(%client, '', "\c6Thanks, come again.");
									%client.stage = "";
								}
							}
						}
					}
					
					if(%gotTheJob)
					{					
						CityRPGData.getData(%client.bl_id).valueJobID = %a;
						CityRPGData.getData(%client.bl_id).valueJobEXP = 0;
						
						if(isObject(%client.player))
						{
							serverCmdunUseTool(%client);
							%client.player.giveDefaultEquipment();
							%client.applyBodyColors();
							%client.applyBodyParts();
						}
						
						%client.SetInfo();
					}
				}
			}
			
			if(!%foundJob)
				messageClient(%client, '', "\c6No such job as \c3" @ %input @ "\c6.");
				messageClient(%client, '', "\c6Thanks, come again.");
				%client.stage = "";
			}
		}
		
		if(strReplace(%input, "2", "") !$= %input || strReplace(%input, "two", "") !$= %input)
		{
			for(%a = 1; %a <= JobSO.getJobCount(); %a++)
			{
				messageClient(%client, '', "\c3" @ JobSO.job[%a].name SPC "\c6- Inital Investment: \c3" @ JobSO.job[%a].invest SPC "- \c6Pay: \c3" @ JobSO.job[%a].pay SPC "- \c6Required Education: \c3" @ JobSO.job[%a].education);
				messageClient(%client, '', JobSO.job[%a].helpline);
				messageClient(%client, '', "\c6Thanks, come again.");
				%client.stage = "";
			}
		
		if(strReplace(%input, "0", "") !$= %input || strReplace(%input, "zero", "") !$= %input)
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		return;
	}
}
