// ============================================================
// Project				:	peopleRP
// Author				:	Iban
// Description			:	Bounty Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGLaborBrickData : brick2x4FData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Admin";
	
	uiName = "Labor Brick";
	 	
	CityRPGBrickType = 2;
	CityRPGBrickAdmin = true;
	
	triggerDatablock = CityRPGInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPGLaborBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c6Welcome! Please type the number corresponding to the options below.");
			if(((getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1)) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 2)) > 0)
			{
				messageClient(%client, '', "\c6- You have \c3" @ getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) @ " \c6Resources and \c3" @ getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) @ "\c6 pieces of Plastic.");
			}
			
			messageClient(%client, '', "\c31 \c6- Sell Resources.");
			messageClient(%client, '', "\c32 \c6- Buy Resources.");
			messageClient(%client, '', "\c33 \c6- Buy Plastic.");
			if(CityRPGData.getData(%client.bl_id).valuepower != 1) { messageClient(%client, '', "\c34 \c6- Pay Electric Bill."); }
			messageClient(%client, '', "\c30 \c6- Exit.");
						
			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if(strReplace(%input, "1", "") !$= %input || strReplace(%input, "one", "") !$= %input)
		{
			%client.buyResources();
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
			return;
		}
		
		if(strReplace(%input, "2", "") !$= %input || strReplace(%input, "two", "") !$= %input)
		{
			%client.stage = 1.2;
			
			messageClient(%client, '', "\c6Please enter the amount of resources you wish to buy.");
			
			return;
		}
		
		if(strReplace(%input, "3", "") !$= %input || strReplace(%input, "three", "") !$= %input)
		{
			%client.stage = 1.3;
			
			messageClient(%client, '', "\c6Please enter the amount of Plastic you wish to buy.");
			
			return;
		}
		if(strReplace(%input, "4", "") !$= %input || strReplace(%input, "four", "") !$= %input)
		{
			if(CityRPGData.getData(%client.bl_id).valuepower == 1)
			{
				messageClient(%client, '', "\c3" @ %text SPC "\c6is not a valid option!");
				return;
			}
			%client.stage = 1.4;
			
			messageClient(%client, '', "\c6Your light bill is \c3$" @ $CityRPG::prices::lights @ "\c6. Type \c3yes \c6to confirm payment or \c3no to reject the payment.");
			
			return;
		}
		messageClient(%client, '', "\c3" @ %text SPC "\c6is not a valid option!");
		
		return;
	}
	
	if(mFloor(%client.stage) == 1)
	{
		if(%client.stage == 1.2)
		{
			if(mFloor(%input) < 1)
			{
				messageClient(%client, '', "\c6Please enter a valid amount of resources to buy.");
				return;
			}
			
			if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor(%input * $CityRPG::prices::resourcePrice))
			{
				CityRPGData.getData(%client.bl_id).valueMoney -= mFloor(%input * $CityRPG::prices::resourcePrice);
				%totalResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
				if(%input % 2)
				{
					%resource1 = (mFloor(%totalResources / 2) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + 1);
					%resource2 = (mFloor(%totalResources / 2) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1));
				}
				else
				{
					%resource1 = (%totalResources / 2) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 0);
					%resource2 = (%totalResources / 2) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
				}
				CityRPGData.getData(%client.bl_id).valueResources = %resource1 SPC %resource2;
				messageClient(%client, '', "\c6You bought \c3" @ mFloor(%input) @ "\c6 Resources for \c3$" @ mFloor(%input * $CityRPG::prices::resourcePrice) @ "\c6!");
				%client.SetInfo();
			}
			else
			{
				messageClient(%client, '', "\c6You Dont Have Enough Money On Hand.");
			}
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
		}
		
		if(%client.stage == 1.3)
		{
			if(mFloor(%input) < 1)
			{
				messageClient(%client, '', "\c6Please enter a valid amount of Plastic to buy.");
				return;
			}
			
			if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor(%input * $CityRPG::prices::resourcePrice))
			{
				CityRPGData.getData(%client.bl_id).valueMoney -= mFloor(%input * $CityRPG::prices::resourcePrice);
				CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) + mFloor(%input));
				messageClient(%client, '', "\c6You bought \c3" @ mFloor(%input) @ "\c6 Pieces Of Plastic for \c3$" @ mFloor(%input * $CityRPG::prices::resourcePrice) @ "\c6!");
				%client.SetInfo();
			}
			else
			{
				messageClient(%client, '', "\c6You Dont Have Enough Money On Hand.");
			}
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
		}
		if(%client.stage == 1.4)
		{
			if(%input $= "yes")
			{
				if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor($CityRPG::prices::lights))
				{
					CityRPGData.getData(%client.bl_id).valueMoney -= mFloor($CityRPG::prices::lights);
					CityRPGData.getData(%client.bl_id).valuepower = 1;
					messageClient(%client, '', "\c6You have paid your electric bill for the month of \c3%1", CalendarSO.nameOfMonth[CalendarSO.month]);
					PowerSO.tick(%client);
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					return;
				}
				else
				{
					messageClient(%client, '', "\c6You can't afford your electric bill");
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					return;
				}
			}
			else
			{
					messageClient(%client, '', "\c6You have refused to pay you electric bill.");
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					return;
			}
		}
		%client.SetInfo();
		return;
	}
}
