// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia
// Description			:	School Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGSchoolBrickData : brick2x4FData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Admin";
	
	uiName = "School Brick";
	
	CityRPGBrickType = 2;
	CityRPGBrickAdmin = true;
	
	triggerDatablock = CityRPGInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPGSchoolBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%client.getWantedLevel())
	{
		messageClient(%client, '', "\c6The service refuses to serve you.");
		return;
	}
	
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c6Welcome! What you like to do in our fine school?");
			if(CityRPGData.getData(%client.bl_id).valueEducation >= 0)
			{
				if(CityRPGData.getData(%client.bl_id).valueEducation >= 6) { %extra = " Which is the highest level we can offer you."; } else { %extra = "."; }
				messageClient(%client, '', "\c6- Your have a level \c3" @ CityRPGData.getData(%client.bl_id).valueEducation @ " Education" @ %extra);
			}
		
		messageClient(%client, '', "\c61 \c3- Enroll");
		messageClient(%client, '', "\c60 \c3- Exit");
		
			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if(strReplace(%input, "1", "") !$= %input || strReplace(%input, "one", "") !$= %input)
		{
			%price = ((CityRPGData.getData(%client.bl_id).valueEducation + 1) * 225);
			
			if(CityRPGData.getData(%client.bl_id).valueEducation < 6)
			{
				if(!CityRPGData.getData(%client.bl_id).valueStudent)
				{
					if(CityRPGData.getData(%client.bl_id).valueMoney >= %price)
					{
						CityRPGData.getData(%client.bl_id).valueStudent = CityRPGData.getData(%client.bl_id).valueEducation + 1;
						CityRPGData.getData(%client.bl_id).valueMoney -= %price;
						
						messageClient(%client, '', "\c6You are now enrolled.");
						%client.setInfo();
					}
					else
					{
						messageClient(%client, '', "\c6It costs \c3$" @ %price SPC "\c6to get enrolled. You do not have enough money.");
					}
				}
				else
				{
					messageClient(%client, '', "\c6Don't get too far ahead of yourself. You're already enrolled for this course.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6The University of Blockland cannot further your education any more.");
			}
			
			return;
		}
		
		if(strReplace(%input, "0", "") !$= %input || strReplace(%input, "zero", "") !$= %input)
		{
			messageClient(%client, '', "\c6Thanks, come again.");
			
			%client.stage = "";
		}
		return;
	}
}
