// ============================================================
// Project				:	CityRPG
// Author				:	Iban & JJstorm
// Description			:	Code used by all walks of life.
// ============================================================
// Table of Contents
// 1. Game CityRPG Functions
// 2. Brick CityRPG Functions
// 3. Client CityRPG Functions
// 4. Trigger Bullshit
// 5. Client->Server Commands
// 6. Local Misc. Functions
// 7. Misc. Shit Functions
// ============================================================

// ============================================================
// Section 1 : Game CityRPG Functions
// ============================================================

function CityRPG_AddDemerits(%blid, %demerits)
{
	%demerits = mFloor(%demerits);
	%currentDemerits = CityRPGData.getData(%blid).valueDemerits;
	%maxStars = CityRPG_GetMaxStars();
	
	CityRPGData.getData(%blid).valueDemerits += %demerits;
	
	if(CityRPGData.getData(%blid).valueDemerits >= $CityRPG::pref::demerits::demoteLevel && JobSO.job[CityRPGData.getData(%blid).valueJobID].law == true)
	{		
		CityRPGData.getData(%blid).valueJobID = 1;
		CityRPGData.getData(%blid).valueJailData = 1 SPC 0;
		
		%client = findClientByBL_ID(%blid);
		
		if(isObject(%client))
		{
			messageClient(%client, '', "\c6You have been demoted to" SPC CityRPG_DetectVowel(JobSO.job[1].name) SPC "\c3" @ JobSO.job[1].name @ "\c6.");
			
			%client.setInfo();
			
			if(isObject(%client.player))
			{
				serverCmdunUseTool(%client);
				
				%client.player.giveDefaultEquipment();
			}
		}
	}
	
	if(%client = findClientByBL_ID(%blid))
	{
		%client.setInfo();
		
		if(%client.getWantedLevel())
		{
			%ticks = %client.getWantedLevel();
			
			if(%ticks > %maxStars)
			{
				if(%maxStars == 3 || %maxStars == 6)
					messageAll('', '\c6Criminal \c3%1\c6 has obtained a level \c3%2\c6 wanted level. Police vehicles have upgraded.', %client.name, %ticks);
			}
		}
	}
}

function CityRPG_AssembleEvents()
{
	exec("Add-Ons/GameMode_JJstormsCityRPG/events.cs");
}

function CityRPG_BootUp()
{
	if(!isObject(CityRPGData))
	{
		new scriptObject(CityRPGData)
		{
			class = Sassy;
			dataFile = "config/server/JJstorms CityRPG/Data/Data.dat";
		};
		export("$CityRPG::*", "config/server/JJstorms CityRPG/prefs.cs");
		
		%newFile = "Add-Ons/GameMode_JJstormsCityRPG/jobs/*";
		%config = "config/server/RP_Core/data/jobs/";
		
		// Transfer data to a new file
		if (!isFile(%file))
		{
			GameTransferFile(%newFile, %config);
		}
		
		if(!isObject($DamageType::Starvation))
			AddDamageType("Starvation", '\c6 - %1 died of starvation.', '\c6 - %1 died of starvation.', 0.5, 1);
		
		if(!CityRPGData.loadedSaveFile)
		{
			CityRPGData.addValue("bank", "0");
			CityRPGData.addValue("loan", "0");
			CityRPGData.addValue("money", $CityRPG::pref::players::startingCash);
			CityRPGData.addValue("bounty", "0");
			CityRPGData.addValue("demerits", "0");
			CityRPGData.addValue("depot", "");
			CityRPGData.addValue("education", "0");
			CityRPGData.addValue("drive", "0");
			CityRPGData.addValue("gender", "ambig");
			CityRPGData.addValue("hunger", "6");
			CityRPGData.addValue("jailData", "0 0");
			CityRPGData.addValue("jobEXP", "1");
			CityRPGData.addValue("jobID", "1");
			CityRPGData.addValue("lotData", "0");
			CityRPGData.addValue("name", "noName");
			CityRPGData.addValue("outfit", "none none none none whitet whitet skin bluejeans blackshoes");
			CityRPGData.addValue("reincarnated", "0");
			CityRPGData.addValue("resources", "0 0 0");
			CityRPGData.addValue("student", "0");
			CityRPGData.addValue("sickness", "0");
			CityRPGData.addValue("light", "0");
			CityRPGData.addValue("power", "0");
			CityRPGData.addValue("business", "none");
			CityRPGData.addValue("tools", "");
			$CityRPG::server::updated = 1;
		}
		else
		{
			for(%a = 1; %a <= CityRPGData.dataCount; %a++)
			{
				if(CityRPGData.data[%a].valueJobID > JobSO.getJobCount() || CityRPGData.data[%a].valueJobID < 0)
				{
					CityRPGData.data[%a].valueJobID = 1;
				}
			}
		}
		
		
		CityRPG_AssembleEvents();

		// Start Time
		CalendarSO.date = 0;
		CityRPGData.lastTickOn = $Sim::Time;
		CityRPGData.scheduleTickmin = schedule($CityRPG::tick::speed * 1000, false, "CityRPG_Tickmin");
		saveprefs();
		loadprefs();

		// Autosaver
		cancel($AutoSaver::SaveLoop);
		$AutoSaver::SaveLoop = schedule($AutoSaver::SaveTime * 60000,0,"AutoSaver_saveLoop");
	}
	else
	{
		for(%a = 1; %a <= CityRPGData.dataCount; %a++)
		{
			if(CityRPGData.data[%a].valueJobID > JobSO.getJobCount() || CityRPGData.data[%a].valueJobID < 0)
			{
				CityRPGData.data[%a].valueJobID = 1;
			}
		}
	}
	
	if(!isObject(CityRPGHelp))
	{
		new scriptObject(CityRPGHelp)
		{
			class = Hellen;
		};
	}
	
	if(!isObject(CityRPGMini))
	{
		CityRPG_BuildMinigame();
	}
}

function CityRPG_BuildMinigame()
{	
	if(isObject(CityRPGMini))
	{		
		for(%i = 0;%i < ClientGroup.getCount();%i++)
		{
			%subClient = ClientGroup.getObject(%i);
			CityRPGMini.removeMember(%subClient);
		}
		
		CityRPGMini.delete();
	}
	else
	{
		for(%i = 0;%i < ClientGroup.getCount();%i++)
		{
			%subClient = ClientGroup.getObject(%i);
			%subClient.minigame = NULL;
		}
	}
	
	new scriptObject(CityRPGMini)
	{
		class = miniGameSO;
		
		brickDamage = true;
		brickRespawnTime = 20000;
		colorIdx = -1;
		
		enableBuilding = true;
		enablePainting = true;
		enableWand = true;
		fallingDamage = true;
		inviteOnly = false;
		
		points_plantBrick = 0;
		points_breakBrick = 0;
		points_die = -1;
		points_killPlayer = 1;
		points_killSelf = -1;
		
		playerDatablock = playerNoJet;
		respawnTime = 5;
		selfDamage = true;
		
		playersUseOwnBricks = false;
		useAllPlayersBricks = true;
		useSpawnBricks = false;
		VehicleDamage = true;
		vehicleRespawnTime = 20000;
		weaponDamage = true;
		
		numMembers = 0;
		
		// Special:
		vehicleRunOverDamage = false;
	};
	
	for(%i = 0;%i < ClientGroup.getCount();%i++)
	{
		%subClient = ClientGroup.getObject(%i);
		CityRPGMini.addMember(%subClient);
	}
	
	CityRPGMini.playerDatablock.maxTools = 7;
}

function CityRPG_BuildSpawns()
{
	$CityRPG::temp::spawnPoints = "";
	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%brickGroup = mainBrickGroup.getObject(%i);
		if(isObject(%brickGroup))
		{
			for(%j = 0; %j < %brickGroup.getCount(); %j++)
			{
				%brick = %brickGroup.getObject(%j);
				if(%brick.getDatablock().CityRPGBrickType == 3)
				{
					$CityRPG::temp::spawnPoints = (!$CityRPG::temp::spawnPoints ? %brick : $CityRPG::temp::spawnPoints SPC %brick);
				}
			}
		}
	}
}

function CityRPG_DetectVowel(%word)
{
	%letter = strLwr(getSubStr(%word, 0, 1));
	
	if(%letter $= "a" || %letter $= "e" || %letter $= "i" || %letter $= "o" || %letter $= "u")
		return "an";
	else
		return "a";	
}

function CityRPG_FindSpawn(%search, %id)
{
	%search = strlwr(%search);
	%fullSearch = %search @ (%id ? " " @ %id : "");
	
	for(%a = 0; %a < getWordCount($CityRPG::temp::spawnPoints); %a++)
	{
		%brick = getWord($CityRPG::temp::spawnPoints, %a);
		
		if(isObject(%brick))
		{
			%spawnData = strLwr(%brick.getDatablock().spawnData);
			
			if(%search $= %spawnData && %spawnData $= "personalspawn")
			{
				%ownerID = getBrickGroupFromObject(%brick).bl_id;
				
				if(%fullSearch $= (%spawnData SPC %ownerID))
					%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
			}
			else if(%fullSearch $= %spawnData)
				%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
		}
		else
			$CityRPG::temp::spawnPoints = strreplace($CityRPG::temp::spawnPoints, %brick, "");
	}
	
	if(%possibleSpawns !$= "")
	{
		%spawnBrick = getWord(%possibleSpawns, getRandom(0, getWordCount(%possibleSpawns) - 1));
		%cords = vectorSub(%spawnBrick.getWorldBoxCenter(), "0 0" SPC (%spawnBrick.getDatablock().brickSizeZ - 3) * 0.1) SPC getWords(%spawnBrick.getTransform(), 3, 6);
		return %cords;
	}
	else
		return false;	
}

function CityRPG_GetMaxStars()
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		%theirStars = %subClient.getWantedLevel();
		if(%theirStars > %maxStars)
			%maxStars = %theirStars;
	}
	
	return (%maxStars $= "" ? 0 : %maxStars);
}

function CityRPG_GetMostWanted()
{
	%maxStars = CityRPG_GetMaxStars();
	for(%a = 0; %a < Clientgroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		if(%subClient.getWantedLevel() == %maxStars)
			%mostWanted = %subClient;
	}
	
	return (isObject(%mostWanted) ? %mostWanted : 0);
}

function CityRPG_illegalAttackTest(%atkr, %vctm)
{
	if(isObject(%atkr) && isObject(%vctm) && %atkr.getClassName() $= "GameConnection" && %vctm.getClassName() $= "GameConnection")
	{
		if(%atkr != %vctm)
		{				
			if(CityRPGData.getData(%vctm.bl_id).valueBounty && %atkr.getJobSO().bountyClaim)
				return false;
			else if(!%vctm.getWantedLevel())
				return true;
		}
	}
	
	return false;
}
function CityRPG_TickMonth()
{
	CalendarSO.month++;
	CalendarSO.day = 1;
	if(CalendarSO.month > CalendarSO.numOfMonths)
	{
		CityRPG_TickYear();
	}
	
	CityRPG_DoTickLoop(1, CalendarSO.Hour, 1);
}

function CityRPG_TickYear()
{
	CalendarSO.month = 1;
	CalendarSO.year++;
}

function CityRPG_Tick()
{
	CalendarSO.date++;
	$CityRPG::temp::calendar::datumdate = CalendarSO.date;
	CalendarSO.day++;
	$CityRPG::temp::calendar::datumday = CalendarSO.day;
	
	if(CalendarSO.day > CalendarSO.daysInMonth[CalendarSO.month])
	{
		CityRPG_TickMonth();
	}
	
	CityRPGData.lastTickOn = $Sim::Time;
	
	CalendarSO.getDate(%client);

	CityRPG_BuildSpawns();
	
	//if(isFunction("dediSave"))
	//	dediSave("CityRPG_TickSave", "File was saved at the start of a tick.", true, true);
	
	$CityRPG::enviro::FogIntensity = "";
	
	StockMarket.tick();
	
	CityRPGData.saveData();
	CitySO.saveData();
	daytickloop(1);
}

function CityRPG_TickHour()
{
	CalendarSO.hour++;
	$CityRPG::temp::calendar::datumhour = CalendarSO.hour;
	
	if(CalendarSO.hour > 24) {
		CalendarSO.hour = 1;
	}
	if(CalendarSO.hour == 2)
	{
		CityRPG_Tick();
	}

	%hour = CalendarSO.hour;
	if(%hour > 12)
	{
		%hourdisplay = (%hour -= 12);
	}
	else
	{
		%hourdisplay = %hour;
	}
	
	// Fixes AM/PM for first time start up
	if(!CalendarSO.hour) { CalendarSO.hourampm = "AM"; }
	
	if(CalendarSO.hour >= 12) {
		CalendarSO.hourampm = "PM";
	} else {
		CalendarSO.hourampm = "AM";
	}
	
	//Time Display
	messageall('','\c6 - \c3%1\c6:\c300 %2', %hourdisplay, CalendarSO.hourampm);
	
	DaySO.getday();
	saveprefs();
	loadprefs();
	varcap(1);
	CityRPG_DoTickLoop(1, %hour);
	
	// Unlimited Bricks
	$Server::Brickcount = 0;
}

function CityRPG_TickMin()
{
	if(CityRPGData.scheduleTickMin)
		cancel(CityRPGData.scheduleTickMin);

	CityRPGData.scheduleTickMin = schedule($CityRPG::tick::speed * 1000, false, "CityRPG_Tickmin");
	CalendarSO.min++;
	$CityRPG::temp::calendar::datummin = CalendarSO.min;
	varcap(1);
	mintickloop();
	
	if(CalendarSO.min >= 60) {
		CityRPG_TickHour();
		CalendarSO.min = 0;
	}
}

function CityRPG_DoTickLoop(%loop, %loopbr, %hour, %month)
{
	%client = findClientByBL_ID(CityRPGData.data[%loop].ID);
	
	if(%month != 1 || %month $= "")
	{
		if(%client.hasSpawnedOnce)
		{
			%client.tick();
		}
		
		if(getWord(CityRPGData.data[%loop].valueJailData, 1))
		{
			CityRPGData.data[%loop].valueJailData = 1 SPC (getWord(CityRPGData.data[%loop].valueJailData, 1) - 1);
			
			if(isObject(%client))
			{
				if(!getWord(CityRPGData.getData(CityRPGData.data[%loop].ID).valueJailData, 1))
				{
					messageClient(%client, '', "\c6 - You got out of prison.");
					%client.buyResources();
					%client.spawnPlayer();
				}
			}
		}
		dayevents(%client, %hour);
	}
	else
	{
		if(isObject(%client))
		{
			PowerSO.tick(%client);
			CityRPGData.getData(%client.bl_id).valuepower = 0;
		}
	}
	%time = (($CityRPG::tick::speed * 60000) / CityRPGData.dataCount);
	if(%loop < CityRPGData.dataCount)
	{
		%loop++;
	}
	if(isObject(%client))
	{
		if(%loopbr < %client.brickgroup.getcount())
		{
			%loopbr++;
		}
	}
	schedule(%time, false, "CityRPG_DoTickLoop", %loop, %loopbr, %hour, %month);
}

function daytickloop(%loopday)
{
	if(isObject(%client = findClientByBL_ID(CityRPGData.data[%loopday].ID)))
	{
		%client.tickday();
	}

	%tickerday = (1000 / CityRPGData.dataCount);
	if(%loopday < CityRPGData.dataCount) {
		schedule(%tickerday, false, "daytickloop", (%loopday + 1));
	}
}

function mintickloop(%loopc)
{
	if(%loopc < 0 || %loopc $= "") { %loopc = 0; }
	
	%client = findclientbybl_id(CityRPGData.data[%loopc].ID);
	if(isObject(%client))
	{
			PowerSO.tick(%client);
	}
	%timemin = mFloor(1000 / CityRPGData.dataCount);
	if(%loopc < CityRPGData.dataCount)
	{
		%loopc++;
	}
	schedule(%timemin, false, "mintickloop", %loopc);
}

function varcap(%capID)
{
	for(%capID=1;%capID<CityRPGData.dataCount;%capID++)
	{
		// Wallet Money cap
		if(CityRPGData.data[%capID].valuemoney > $CityRPG::pref::MaxMoney || CityRPGData.data[%capID].valuemoney < 0)
		{
			CityRPGData.data[%capID].valuemoney = $CityRPG::pref::MaxMoney;
		}
		// Bank Money cap
		if(CityRPGData.data[%capID].valuebank > $CityRPG::pref::bank::MaxMoney)
		{
			CityRPGData.data[%capID].valuebank = $CityRPG::pref::bank::MaxMoney;
		}
		// Hunger cap
		if(CityRPGData.data[%capID].valuehunger < 1)
		{
			CityRPGData.data[%capID].valuehunger = 1;
		}
		%client = findClientByBL_ID(CityRPGData.data[%capID].ID);
		if(%client.HasSpawnedOnce) { %client.SetInfo(); }
	}
}

function messageAllOfJob(%job, %type, %message)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		if(%subClient.getJobSO().id == %job)
		{
			messageClient(%subClient, %type, %message);
			%sent++;
		}
	}
	
	return (%sent !$= "" ? %sent : 0);
}

// ============================================================
// Section 2 : Brick CityRPG Functions
// ============================================================
function fxDTSBrick::handleCityRPGBrickCreation(%brick, %data)
{
	if(!isObject(%brick.trigger))
	{
		%datablock = %brick.getDatablock();
		
		%trigX = getWord(%datablock.triggerSize, 0);
		%trigY = getWord(%datablock.triggerSize, 1);
		%trigZ = getWord(%datablock.triggerSize, 2);
		
		if(mFloor(getWord(%brick.rotation, 3)) == 90)
			%scale = (%trigY / 2) SPC (%trigX / 2) SPC (%trigZ / 2);
		else
			%scale = (%trigX / 2) SPC (%trigY / 2) SPC (%trigZ / 2);
			
		
		%brick.trigger = new trigger()
		{
			datablock = %datablock.triggerDatablock;
			position = getWords(%brick.getWorldBoxCenter(), 0, 1) SPC getWord(%brick.getWorldBoxCenter(), 2) + ((getWord(%datablock.triggerSize, 2) / 4) + (%datablock.brickSizeZ * 0.1));
			rotation = "1 0 0 0";
			scale = %scale;
			polyhedron = "-0.5 -0.5 -0.5 1 0 0 0 1 0 0 0 1";
			parent = %brick;
		};
		
		%boxSize = getWord(%scale, 0) / 2.5 SPC getWord(%scale, 1) / 2.5 SPC getWord(%scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
			%brick.trigger.getDatablock().onEnterTrigger(%brick.trigger, %player);
		
		if(%brick.getDatablock().CityRPGBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes += %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned++;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
				getBrickGroupFromObject(%brick).client.SetInfo();
		}
	}
}

function fxDTSBrick::handleCityRPGBrickDelete(%brick, %data)
{
	if(isObject(%brick.trigger))
	{
		for(%a = 0; %a < clientGroup.getCount(); %a++)
		{
			%subClient = ClientGroup.getObject(%a);
			if(isObject(%subClient.player) && %subClient.CityRPGTrigger == %brick.trigger)
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, clientGroup.getObject(%a).player, true);
		}
		
		%boxSize = getWord(%brick.trigger.scale, 0) / 2.5 SPC getWord(%brick.trigger.scale, 1) / 2.5 SPC getWord(%brick.trigger.scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, %player);
		
		%brick.trigger.delete();
		
		if(%brick.getDatablock().CityRPGBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes -= %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned--;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
				getBrickGroupFromObject(%brick).client.SetInfo();
			
			if(%brick.getName() !$= "")
			{
				%data = CityRPGData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData;
				
				%newData = getWord(%data, 0) - 1;
				
				for(%a = 1; %a < getWordCount(%data); %a++)
				{
					if(%cancelNext)
					{
						%cancelNext = false;
						continue;
					}
					
					%newData = %newData SPC getWord(%data, %a);
					
					if(%a % 2 == 0)
						continue;
					
					%newBrick = "_" @ getWord(%data, %a);
					if(isObject(%newBrick) && %newBrick $= %brick.getName())
					{
						%found = true;
						
						%newData = getWords(%newData, 0, getWordCount(%newData) - 2);
						
						%cancelNext = true;
					}
				}
				
				if(%found)
				{
					CityRPGData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = %newData;
				}
			}
		}
	}	
}

function fxDTSBrick::transferLot(%brick, %targetBG)
{
	%ownerBG = getBrickGroupFromObject(%brick);
	
	if(%brick.tran || !isObject(%brick))
		return;
	
	if(isObject(%ownerBG))
		%ownerBG.remove(%brick);
	
	%targetBG.add(%brick);
	%brick.tran = 1;
	%brick.transferLot(%targetBG);
	
	for(%i = 0; %i < %brick.getNumUpBricks(); %i++)
	{
		%target = %brick.getUpBrick(%i);
		if(isObject(%target))
			%target.transferLot(%targetBG);
	}
}

// Labor Functions
function fxDTSBrick::onChop(%this, %client)
{
	if(%this.resources > 0 && !%this.isFakeDead())
	{
		if(getRandom(1, 100) > (95 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
		{
			%this.resources--;
			
			if(%this.resources)
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained.", 1);
			else
			{
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained, however you killed the tree in the process.", 3);
				%this.fakeKillBrick(getRandom(-10, 10) SPC getRandom(-10, 10) SPC getRandom(0, 10), getRandom(120, 180));
				%this.resources = %this.getDatablock().resources;
			}
			
			CityRPGData.getData(%client.bl_id).valueResources = (getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + 1) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
			%client.SetInfo();
			
			if(%client.getJobSO().laborer)
				CityRPGData.getData(%client.bl_id).valueJobEXP++;
		}
	}
}

function fxDTSBrick::onMine(%this, %client)
{
	if(isObject(%this) && isObject(%client))
	{
		if(%this.hasOre && %this.resources == 0)
			%this.resources = %this.getDatablock().resources;
		
		if(%this.resources > 0)
		{
			%this.hasOre = true;
			if(getRandom(1, 100) > (90 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
			{
				%this.resources--;
				
				if(getRandom(1, 100) > 100 - CityRPGData.getData(%client.bl_id).valueEducation)
					%gemstone = true;
				
				if(%gemstone)
				{
					%value = getRandom(5, 50);
					commandToClient(%client, 'centerPrint', "\c1Gemstone obtained.", 1);
					messageClient(%client, '', "\c6You extracted a gem from the rock worth \c3$" @ %value @ "\c6.");
					CityRPGData.getData(%client.bl_id).valueMoney += %value;
				}
				else
				{
					if(!%this.resources)
					{
						commandToClient(%client, 'centerPrint', "\c6You have emptied this rock of its resources!", 3);
						%this.adjustColorOnOreContent();
					}
					else
						commandToClient(%client, 'centerPrint', "\c6Minerals obtained.", 1);
					
					CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) + 1);
				}
				
				if(%client.getJobSO().laborer)
					CityRPGData.getData(%client.bl_id).valueJobEXP++;
				
				%client.SetInfo();
			}
		}
	}
}

function fxDTSBrick::onwrench(%this, %client)
{
	if(isObject(%this) && isObject(%client))
	{
		if(%this.hasOre && %this.resources == 0)
			%this.resources = %this.getDatablock().resources;
		
		if(%this.resources > 0)
		{
			%this.hasOre = true;
			if(getRandom(1, 70) > (90 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
			{
				%this.resources--;
				
				if(getRandom(1, 100) > 100 - CityRPGData.getData(%client.bl_id).valueEducation)
					%gemstone = true;
				
				if(%gemstone)
				{
					%value = getRandom(5, 50);
					commandToClient(%client, 'centerPrint', "\c1You found a defect .", 1);
					messageClient(%client, '', "\c6You found a defect and were awarded \c3$" @ %value @ "\c6.");
					CityRPGData.getData(%client.bl_id).valueMoney += %value;
				}
				else
				{
					if(!%this.resources)
					{
						commandToClient(%client, 'centerPrint', "\c6The item has moved down thr line.", 3);
						%this.adjustColorOnOreContent();
					}
					else
						commandToClient(%client, 'centerPrint', "\c6You finished what ever you are makeing.", 1);
					
					CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) + 1);
				}
				
				if(%client.getJobSO().laborer)
					CityRPGData.getData(%client.bl_id).valueJobEXP++;
				
				%client.SetInfo();
			}
		}
	}
}

// ============================================================
// Section 3 : Client CityRPG Functions
// ============================================================
function gameConnection::arrest(%client, %cop)
{
	if(%ticks = %client.getWantedLevel())
	{
		%copSO = CityRPGData.getData(%cop.bl_id);
		%robSO = CityRPGData.getData(%client.bl_id);
		
		if(!getWord(%robSO.valueJailData, 1))
		{
			if(%client.player.currTool)
				serverCmddropTool(%client, %client.player.currTool);
		}
		
		%ticks += getWord(%robSO.valueJailData, 1);
		%reward = mFloor($CityRPG::prices::jailingBonus * %ticks);
		%copSO.valueMoney += %reward;
		
		commandToClient(%client, 'messageBoxOK', "You've been Jailed by" SPC %cop.name @ "!", 'You have been jailed for %1 tick%2.\nToo bad, so sad.\n\nYou may either wait out your jail time in game and possibly earn money by laboring, or you may leave the server and return when your time is up.\nThe choice is yours.\n\nYou may make 1 phone call.', %ticks, %ticks == 1 ? "" : "s");
		commandToClient(%cop, 'centerPrint', "\c6You have jailed \c3" @ %client.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ". You were rewarded \c3$" @ %reward @ "\c6.", 5);
		
		%robSO.valueJailData = 1 SPC %ticks;
		%robSO.valueDemerits = 0;
		
		%cop.SetInfo();
		
		if(%client.getJobSO().law)
		{
			messageClient(%client, '', "\c6You have been demoted to" SPC CityRPG_DetectVowel(JobSO.job[1].name) SPC "\c3" @ JobSO.job[1].name SPC "\c6due to your jailing.");
			%robSO.valueJobID = 1;
		}
		
		if(%cop.getJobSO().law)
			%copSO.valueJobEXP++;
		
		if(%robSO.valueBounty > 0)
		{
			messageClient(%cop, '', "\c6Wanted man was apprehended successfully. His bounty money has been wired to your bank account.");
			%copSO.valueBank += %robSO.valueBounty;
			%robSO.valueBounty = 0;
		}
		
		if(%robSO.valueHunger < 3)
			%robSO.valueHunger = 3;
		
		if(isObject(%client.player.tempBrick))
			%client.player.tempBrick.delete();
		
		%client.spawnPlayer();
		
		if(%ticks == CityRPG_GetMaxStars())
		{
			%maxWanted = CityRPG_GetMostWanted();
			
			if(%maxWanted)
				messageAll('', '\c6The \c3%1-star\c6 criminal \c3%2\c6 was arrested by \c3%5\c6, but \c3%3-star\c6 criminal \c3%4\c6 is still at large!', %ticks, %client.name, %maxWanted.getWantedLevel(), %maxWanted.name, %cop.name);
			else
				messageAll('', '\c6With the apprehension of \c3%1-star\c6 criminal \c3%2\c6 by \c3%3\c6, the City returns to a peaceful state.', %ticks, %client.name, %cop.name);
		}
		else
			messageAll('', '\c3%1\c6 was jailed by \c3%2\c6 for \c3%3\c6 ticks.', %client.name, %cop.name, %ticks);
	}
}

function gameConnection::buyResources(%client)
{
	%totalResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
	
	if(mFloor(%totalResources * $CityRPG::prices::resourcePrice) > 0)
	{	
		%product = mFloor(%totalResources * $CityRPG::prices::resourcePrice);
		
		if(%client.getJobSO().laborer && !getWord(CityRPGData.getData(%client.bl_id).valueJobID, 1))
		{
			%product *= getRandom(1.5 + (CityRPGData.getData(%client.bl_id).valueEducation / 12), 2.0 + (CityRPGData.getData(%client.bl_id).valueEducation / 12));
			%product = mFloor(%product);
		}
		
		if(!getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		{
			CityRPGData.getData(%client.bl_id).valueMoney += %product;
			messageClient(%client, '', "\c6The state has bought all of your resources for \c3$" @ %product @ "\c6.");
		}
		else
		{
			CityRPGData.getData(%client.bl_id).valueBank += %product;
			messageClient(%client, '', '\c6The state has set aside \c3$%1\c6 for when you get out of Prison.', %product);
		}
		
		CitySO.lumber += getWord(CityRPGData.getData(%client.bl_id).valueResources, 0);
		CitySO.minerals += getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
		
		CityRPGData.getData(%client.bl_id).valueResources = "0 0";
		
		%client.SetInfo();	
	}
	else
	{
		messageClient(%client, '', '\c6You Have No Resources to Sell');
	}
}

function gameConnection::doIPKTest(%client) 
{
	if($CityRPG::pref::idlekicker == 1) {
		
		if(isObject(%client))
		{
			if(isObject(%client.player))
			{
				if(%client.player.lasPos $= %client.player.getPosition() && %client.player.lasPos)
				{
					if(($sim::Time - %client.lastSpokeOn) > 60000)
						%client.minutesIdle += 1;
				}
				else
				{
					%client.player.lasPos = %client.player.getPosition();
					%client.minutesIdle = 0;
				}
			}
			else
			{
				if(%client.hasBeenDead)
					if(($sim::Time - %client.lastSpokeOn) > 60000)
						%client.minutesIdle += 1;
				else
				{
					if(%client.hasSpawnedOnce)
					{
						%client.hasBeenDead = true;
						%client.minutesIdle = 0;
					}
				}
			}
		}
	
		if(%client.minutesIdle >= 6)
		{
			%name = %client.name;
			%client.delete("Sorry, you have been kicked for being 6 minutes idle.");
			messageAll('', '\c1%1 has been kicked after being idle for %2 minutes.', %name, 6);
		}
		else
		{
			CityRPGData.scheduleidlekicker = %client.schedule(60000, "doIPKTest");
		}
	}
}

function servercmdidle(%client) {
	
	if(!%client.isAdmin){ messageclient(%client, '', '\c6You must be admin to use this command.'); return; }
	
	if($CityRPG::pref::idlekicker == 1) {
		$CityRPG::pref::idlekicker = 0;
		messageall('','\c3%1 \c6has disabled the servers idle kicker.',%client.name);
	}
	else
	{
		$CityRPG::pref::idlekicker = 1;
		messageall('','\c3%1 \c6has enabled the servers idle kicker.',%client.name);
	}
}
function gameConnection::setInfo(%client)
{
	CityRPGData.getData(%client.bl_id).valueMoney = mFloor(CityRPGData.getData(%client.bl_id).valueMoney);
	CityRPGData.getData(%client.bl_id).valueName = %client.name;
	
	if(isObject(%client.player))
	{		
		%client.player.setShapeName("foobar");
		%client.player.setShapeNameColor("foobar");
		%client.player.setShapeNameDistance(24);
		
		%client.setGameBottomPrint();
	}
}

function gameConnection::setGameBottomPrint(%client)
{
	// Font
	%mainFont = "<font:Candara:16>";
	%client.CityRPGPrint = %mainFont;
	
	// Job
	if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		%jobName = "Convict";
	else if(CityRPGData.getData(%client.bl_id).valueStudent)
		%jobName = "Student" SPC %client.getJobSO().name;
	else
		%jobName = %client.getJobSO().name;
	
	%client.CityRPGPrint = %client.CityRPGPrint @ "<bitmap:" @ Person.textureName @ ">\c6Job: \c3" @ %jobName;
	
	// Money
	
	// Money Suffixes
	if(%client.getCashString() >= 1000 && %client.getCashString() < 1000000) { %dmoney = getSubStr(CityRPGData.getdata(%client).valuemoney, 0, strlen(CityRPGData.getdata(%client).valuemoney) - 3) @ "K"; }
	else if(%client.getCashString() >= 1000000 && %client.getCashString() < 1000000000) { %dmoney = getSubStr(CityRPGData.getdata(%client).valuemoney, 0, strlen(CityRPGData.getdata(%client).valuemoney) - 6) @ "M"; }
	else { %dmoney = %client.getCashString(); }
	%client.CityRPGPrint = %client.CityRPGPrint SPC " <bitmap:" @ Money.textureName @ ">\c6Money:" SPC %dmoney;
	
	// Salary
	if(%client.getSalary() > 0)
		%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Income: <color:336600>$" @ %client.getSalary();
	
	// Taxes
	if(%client.brickGroup.taxes > 0)
		%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Taxes: <color:ff3300>$" @ %client.brickGroup.taxes;
	
	// Resources
	if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) || %client.getJobSO().laborer || getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) > 0 || getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) > 0)
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) > 0)
			%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Lumber: \c3" @ (strlen(getWord(CityRPGData.getData(%client.bl_id).valueResources, 0)) > 0 ? getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) : 0);
		
		if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) > 0)
			%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Ore: \c3" @ (strlen(getWord(CityRPGData.getData(%client.bl_id).valueResources, 1)) > 0 ? getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) : 0);
	}
	
	// Hunger
	%hexColor = $CityRPG::food::color[CityRPGData.getData(%client.bl_id).valueHunger];
	%hungerName = $CityRPG::food::state[CityRPGData.getData(%client.bl_id).valueHunger];
	%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Hunger: <color:" @ %hexColor @ ">" @ %hungerName;
	
	// Wanted Level
	if(CityRPGData.getData(%client.bl_id).valueDemerits >= $CityRPG::pref::demerits::wantedLevel)
	{
		%client.CityRPGPrint = %client.CityRPGPrint @ " \c6Wanted:";
		%stars = %client.getWantedLevel();
		%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6";
		
		for(%a = 0; %a < %stars; %a++) {
			%client.CityRPGPrint = %client.CityRPGPrint @ "*";
		}
		
		%client.CityRPGPrint = %client.CityRPGPrint @ "\c7";
		for(%a = %a; %a < 6; %a++)
			%client.CityRPGPrint = %client.CityRPGPrint @ "*";
		
		%client.CityRPGPrint = %client.CityRPGPrint;
	}
	
	// Lot Info
	if(isObject(%client.CityRPGLotBrick)) %client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Owner: <color:fff000>" @ getBrickGroupFromObject(%client.CityRPGLotBrick).name;	
		
	// Printing
	if(%client.hasRPG)
	{
		%data = CityRPGData.getData(%client.bl_id);
		if(%data.valuesickness != 0) { %sickness = %data.valuesickness SPC $CityRPG::Pref::SicknessName[%data.valuesickness]; } else { %sickness = %data.valuesickness SPC "Healthy"; }
		%hungercolor = $CityRPG::food::color[CityRPGData.getData(%client.bl_id).valuehunger];
		%hungerstate = $CityRPG::food::state[CityRPGData.getData(%client.bl_id).valuehunger];
		%onebigstat = %data.valuemoney SPC %data.valuebank SPC %data.valueloan SPC %data.valuemoney + %data.valuebank SPC %data.valuelotdata SPC %data.valuegender SPC %client.getJobSO().tmHexColor SPC %client.getJobSO().name SPC %data.valuejobexp SPC %data.valueeducation SPC %hungercolor SPC %hungerstate SPC %data.valuestudent SPC getword(%data.valuejailData, 0) SPC %client.getwantedlevel() SPC %data.valuedemerits SPC getword(%data.valuejailData, 1) SPC %data.valuebounty SPC %data.valuepower SPC %data.valuedrive SPC %data.valuelight SPC %data.valuereincarnated SPC %sickness SPC %data.valuebusiness;
		commandtoClient(%client, 'JJGUI_UpdateAll', %onebigstat);
	}
	// else
	// {
		commandToClient(%client, 'bottomPrint', %client.CityRPGPrint, 0, true);
	// }
	
	return %client.CityRPGPrint;
}

function gameConnection::tick(%client)
{
	// I know I have never short-declared the client's scriptobject previously.
	// However, the tick occures far too often for it to be neglected.
	// Each "getData" runs through a small script. Because it appears 22 times in this function
	// I feel that it should get it's own special 2-letter variable.
	
	if(!findclientbyname(%client.name))
	{
		return;
	}
	
	%so = CityRPGData.getData(%client.bl_id);
	
	// ==== Jail ==== \\
	if(getWord(%so.valueJailData, 1))
	{
		if(%ticks = getWord(%so.valueJailData, 1) > 1)
		{
			%daysLeft = (getWord(%so.valueJailData, 1) - 1);
			
			if(%daysLeft > 1)
				%daySuffix = "s";
				
			messageClient(%client, '', '\c6 - You have \c3%1\c6 hour%2 left in Prison.', %daysLeft, %daySuffix);
		}
		
		if(%so.valueHunger > 3)
			%so.valueHunger--;
		else
			%so.valueHunger = 3;
	}
	// Jail overrides most of the benefits that go along with ticks.
	// Everything in the above if will occur only if the person is in jail, and should explicitly affect only prisoners.
	// All the code below this will affect everyone currently logged in that is out of jail.

	// ==== Statute of Limitations ==== \\
	if(%so.valueDemerits > 0)
	{
		if(%so.valueDemerits >= $CityRPG::pref::demerits::reducePerTick)
			%so.valueDemerits -= $CityRPG::pref::demerits::reducePerTick;
		else
			%so.valueDemerits = 0;
		
		messageClient(%client, '', '\c6 - You have had your demerits reduced to \c3%1\c6 due to <a:en.wikipedia.org/wiki/Statute_of_limitations>Statute of Limitations</a>\c6.', %so.valueDemerits);
	}
	// Sickness
	sickness(%client, "common");
	
	%client.SetInfo();
}

function gameConnection::tickday(%client)
{
	%so = CityRPGData.getData(%client.bl_id);
	
	if(getWord(%so.valueJailData, 1))
	{
		return;
	}
	else
	{
		// Code that only affects people whom have spawned.
		if(findclientbyname(%client.name))
		{
			// ==== Hunger ==== \\
			if(%so.valueHunger > 0) { %so.valueHunger--; }
			
			if(isObject(%client.player))
			{
				%client.player.setScale("1 1 1");
			}
			
			if(%so.valueHunger == 1)
			{
				commandToClient(%client, 'messageBoxOK', "You are starving to death!", "You're close to starvation!\nIf you do not eat before the next tick, you will die!");
			}
			else if(%so.valueHunger <= 0)
			{
				if(isObject(%client.player))
				{
					%client.player.damage(%client.player, "0 0 0", (%client.player.getDatablock().maxDamage * 3), $DamageType::Starvation);
					%so.valueHunger = 3;
				}
				return;
			}
			
			// ==== Loan ==== \\
			if(%so.valueloan > 0)
			{
				if($CityRPG::pref::bank::LoanDayPay > %so.valueLoan) { %loaddeduct = %so.valueLoan; } else { %loaddeduct = $CityRPG::pref::bank::LoanDayPay; }
				if(%so.valuemoney >= $CityRPG::pref::bank::LoanDayPay)
				{
					%so.valuemoney -= %loaddeduct;
					%so.valueLoan -= %loandeduct;
					messageClient(%client, '', "\c6 - \c3$" @ %loaddeduct @ " \c6Was stolen from you by loan sharks.");
				}
				else if(%so.valuebank >= $CityRPG::pref::bank::LoanDayPay)
				{
					%so.valuebank -= %loaddeduct;
					%so.valueLoan -= %loaddeduct;
					messageClient(%client, '', "\c6 - \c3$" @ %loaddeduct @ " \c6Was deducted from your bank account to pay your loan.");
				}
				else
				{
					CityRPG_AddDemerits(%client.bl_id, $CityRPG::demerits::RefuseLoan);
					commandToClient(%target, 'centerPrint', "\c6You have committed a crime:  [\c3Not Paying Loan\c6]", 5);
				}
			}
			else
			{
				%so.valueLoan = 0;
			}
			
			// ==== Bank ==== \\
			if(CityRPGData.data[%loop].valuebank > 0)
			{
				CityRPGData.data[%loop].valuebank = mFloor(CityRPGData.data[%loop].valueBank * $CityRPG::tick::interest);
				
				if(isObject(%client))
					messageClient(%client, '', "\c6 - The bank is giving interest.");
			}
		}
	}

	// Functions that only affect non-students.
	if(!%so.valueStudent)
	{
		// ==== Pay ==== \\
		if(%client.getSalary() > 0)
		{
			%sum = (%client.getSalary() - %client.brickGroup.taxes);
			
			if(%sum > 0)
			{
				%so.valueBank += %sum;
				messageClient(%client, '', "\c6 - Your paycheck of \c3$" @ %sum SPC "\c6has been deposited into your account.");
			}
			else if(%sum <= 0)
				messageClient(%client, '', "\c6 - You did not receive a paycheck due to your taxes.");
				
			if(%sum * 0.1 >= 1 && getRandom(0, 20) == 20)
			{
				%bonus = mFloor(%sum * getRandom(0.1, 0.25));
				%so.valueBank += %bonus;
				messageClient(%client, '', '\c6 - You also recieved a \c3$%1\c6 bonus along with your paycheck!', %bonus);
			}
		}
	}
	else
	{
		%so.valueStudent--;
		
		if(!%so.valueStudent)
		{
			%so.valueEducation++;
			messageClient(%client, '', '\c6 - \c2You graduated\c6, receiving a level \c3%1\c6 diploma!', %so.valueEducation);
		}
		else
		{
			messageClient(%client, '', '\c6 - Have only \c3%1\c6 days left until you graduate.', %so.valueStudent);
		}
	}

	// Sickness
	sickness(%client, "common");
	
	%client.SetInfo();
}

function serverCmdIHaveRPG(%client, %CRPGVersion)
{
	if(%CRPGVersion >= $CityRPG::client::version)
	{
		%client.hasRPG = 1;
		echo(%client.name @ " Has the currect client CityRPG");
	}
	else
	{
		messageclient(%client, '', '\c6You Have \c3Client_JJstormsCityRPG v%1\c6, you need \c3v%2 \c6to play in this CityRPG.', %CRPGVersion, $CityRPG::client::version);
		echo(%client.name @ " Has the wrong client CityRPG");
	}
}

function gameConnection::checkVersions(%client)
{
	if(%client.hasRPG != 1 || %client.hasRPG $= "")
	{
		%mtop = "Missing JJstorms CityRPG Client!";
		%mmid = "You need to download <a:jjstorm.net/#act=vt76&page=1>JJstorms CityRPG Client " @ $CityRPG::client::Version @"</a>, then you can spawn.";
		%mbottom = "JJstorms CityRPG Client adds: textures, models and sounds so you view the CityRPG correctly.";
		%mextra = "--Thanks JJstorm";
		%message = %mtop NL " " NL %mmid NL " " NL %mbottom NL " " NL %mextra;
		%client.delete(%message);
		messageall('','\c3%1 \c6doesnt have the CityRPG client', %client.name);
		echo(%client.name @ " doesnt have the CityRPG client");
	}
}

function gameConnection::applyForcedBodyColors(%client)
{
	if(isObject(CityRPGData.getData(%client.bl_id)))
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			%outfit = "none none none none jumpsuit jumpsuit skin jumpsuit jumpsuit";
		else if(%client.getJobSO().outfit !$= "")
			%outfit = %client.getJobSO().outfit;
		else if(CityRPGData.getData(%client.bl_id).valueoutfit $= "custom custom custom custom custom custom custom custom custom")
			%outfit = "none none none none whitet whitet skin bluejeans blackshoes";
		else
			%outfit = CityRPGData.getData(%client.bl_id).valueOutfit;
	}
	
	if(%outfit !$= "")
	{
		%client.accentColor		= ClothesSO.getColor(%client, getWord(%outfit, 0));
		%client.hatColor		= ClothesSO.getColor(%client, getWord(%outfit, 1));
		
		%client.packColor		= ClothesSO.getColor(%client, getWord(%outfit, 2));
		%client.secondPackColor		= ClothesSO.getColor(%client, getWord(%outfit, 3));
		
		%client.chestColor		= ClothesSO.getColor(%client, getWord(%outfit, 4));
		
		%client.rarmColor		= ClothesSO.getColor(%client, getWord(%outfit, 5));
		%client.larmColor		= ClothesSO.getColor(%client, getWord(%outfit, 5));
		%client.rhandColor		= ClothesSO.getColor(%client, getWord(%outfit, 6));
		%client.lhandColor		= ClothesSO.getColor(%client, getWord(%outfit, 6));
		
		%client.hipColor		= ClothesSO.getColor(%client, getWord(%outfit, 7));
		
		%client.rlegColor		= ClothesSO.getColor(%client, getWord(%outfit, 8));
		%client.llegColor		= ClothesSO.getColor(%client, getWord(%outfit, 8));
		
		%client.applyBodyColors();
	}
}

function gameConnection::applyForcedBodyParts(%client)
{
	if(isObject(CityRPGData.getData(%client.bl_id)))
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			%outfit = "none none none none jumpsuit jumpsuit skin jumpsuit jumpsuit";
		else if(%client.getJobSO().outfit !$= "")
			%outfit = %client.getJobSO().outfit;
		else if(CityRPGData.getData(%client.bl_id).valueoutfit $= "custom custom custom custom custom custom custom custom custom")
			%outfit = "none none none none whitet whitet skin bluejeans blackshoes";
		else
			%outfit = CityRPGData.getData(%client.bl_id).valueOutfit;
	}
	
	if(%outfit !$= "")
	{
		%client.accent		= ClothesSO.getNode(%client, getWord(%outfit, 0));
		%client.hat		= ClothesSO.getNode(%client, getWord(%outfit, 1));
		
		%client.pack		= ClothesSO.getNode(%client, getWord(%outfit, 2));
		%client.secondPack	= ClothesSO.getNode(%client, getWord(%outfit, 3));
		
		%client.chest		= ClothesSO.getNode(%client, getWord(%outfit, 4));
		
		%client.rarm		= ClothesSO.getNode(%client, getWord(%outfit, 5));
		%client.larm		= ClothesSO.getNode(%client, getWord(%outfit, 5));
		%client.rhand		= ClothesSO.getNode(%client, getWord(%outfit, 6));
		%client.lhand		= ClothesSO.getNode(%client, getWord(%outfit, 6));
		
		%client.hip		= ClothesSO.getNode(%client, getWord(%outfit, 7));
		
		%client.rleg		= ClothesSO.getNode(%client, getWord(%outfit, 8));
		%client.lleg		= ClothesSO.getNode(%client, getWord(%outfit, 8));
		
		%client.faceName 	= ClothesSO.getDecal(%client, "face", getWord(%outfit, 9));
		%client.decalName 	= ClothesSO.getDecal(%client, "chest", getWord(%outfit, 10));
		
		%client.applyBodyParts();
	}
}

// Get Functions
function gameConnection::getCashString(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueMoney >= 0)
		%money = "\c3$" @ CityRPGData.getData(%client.bl_id).valueMoney;
	else
		%money = "\c0($" @ strreplace(CityRPGData.getData(%client.bl_id).valueMoney, "-", "")  @ ")";
	
	return %money;
}

function gameConnection::getJobSO(%client)
{
	return JobSO.job[%client.getJobID()];
}

function gameConnection::getJobID(%client)
{
	return CityRPGData.getData(%client.bl_id).valueJobID;	
}

function gameConnection::getSalary(%client)
{
	return mFloor(%client.getJobSO().pay * (((CityRPGData.getData(%client.bl_id).valueEducation - %client.getJobSO().education) / 8) + 1));
}

function gameConnection::getWantedLevel(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueDemerits >= $CityRPG::pref::demerits::wantedLevel)
	{
		%div = CityRPGData.getData(%client.bl_id).valueDemerits / $CityRPG::pref::demerits::wantedLevel;
		
		if(%div <= 3)
			return 1;
		else if(%div <= 8)
			return 2;
		else if(%div <= 14)
			return 3;
		else if(%div <= 21)
			return 4;
		else if(%div <= 29)
			return 5;
		else
			return 6;
	}
	else
		return 0;
}

// Sell Functions
function gameConnection::sellFood(%client, %sellerID, %servingID, %foodName, %price, %profit, %payment)
{
	if(CityRPGData.getData(%client.bl_id).value[%payment] >= %price)
	{
		if(CityRPGData.getData(%client.bl_id).valueHunger < 6)
		{
			%portionName = strreplace($CityRPG::portion[%servingID], "_", " ");
					
			if(JobSO.job[CityRPGData.getData(%sellerID).valueJobID].sellFood)
			{				
				CityRPGData.getData(%client.bl_id).valueHunger += %servingID;
				CityRPGData.getData(%client.bl_id).value[%payment] -= %price;
				
				%addhealth = %servingID * 16;
				if(%client.player.getDamageLevel() <= 0) { %healthregained = "."; }
				if(%client.player.getDamageLevel() < %addhealth)
				{
					%client.player.setHealth(%client.player.dataBlock.maxDamage);
					%healthregained = " and regained \c3100% \c6health.";
				}
				else
				{
					%client.player.addHealth(%addhealth);
					%healthregained = " and regained \c3" @ %addhealth @ "\c6 health.";
				}
				
				messageClient(%client, '', '\c6You consume %1 \c3%2\c6 serving of \c3%3\c6 %4, %5', CityRPG_DetectVowel(%portionName), %portionName, %foodName, %healthregained);
				
				if(%profit)
				{
					if(isObject(%seller = findClientByBL_ID(%sellerID)))
					{
						messageClient(%seller, '', '\c6You just gained \c3$%1\c6 for providing \c3%3\c6 to \c3%2\c6.', %profit, %client.name, %foodName);
						CityRPGData.getData(%sellerID).value[%payment] += %profit;
					}
				}
				
				%client.player.setScale("1 1 1");
				%client.setInfo();
				%client.player.serviceOrigin.onTransferSuccess(%client);
			}
			else
				messageClient(%client, '', "\c6This vendor is not liscensed to sell food.");
		}
		else
			messageClient(%client, '', "\c6You are too full to even think about buying any more food.");
	}
	else
		messageClient(%client, '', "\c6You don't have enough money to buy this food.");
}

function gameConnection::sellItem(%client, %sellerID, %itemID, %price, %profit, %payment)
{
	if(isObject(%client.player) && CityRPGData.getData(%client.bl_id).value[%payment] >= %price)
	{
		if(JobSO.job[CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueJobID].sellItems)
		{							
			for(%a = 0; %a < %client.player.getDatablock().maxTools; %a++)
			{
				if(!isObject(%obj.tool[%a]) || %obj.tool[%a].getName() !$= $CityRPG::prices::weapon::name[%itemID])
				{
					if(%freeSpot $= "" && %client.player.tool[%a] $= "") { %freeSpot = %a; }
				}
				else
				{
					%alreadyOwns = true;
				}
			}
			
			if(%freeSpot !$= "" && !%alreadyOwns)
			{
				CityRPGData.getData(%client.bl_id).value[%payment] -= %price;
				CityRPGData.getData(%sellerID).valueBank += %profit;
				CitySO.minerals -= $CityRPG::prices::weapon::mineral[%itemID];
	
				%client.player.tool[%freeSpot] = $CityRPG::prices::weapon::name[%itemID].getID();
				messageClient(%client, 'MsgItemPickup', "", %freeSpot, %client.player.tool[%freeSpot]);
				
				messageClient(%client, '', "\c6You have accepted the item's fee of \c3$" @ %price @ "\c6!");
				%client.setInfo();
				
				if(%client.player.serviceOrigin.getGroup().client)
					messageClient(%client.player.serviceOrigin.getGroup().client, '', '\c6You gained \c3$%1\c6 selling \c3%2\c6 an item.', %profit, %client.name);
						
				%client.player.serviceOrigin.onTransferSuccess(%client);
			}
			else if(%alreadyOwns)
				messageClient(%client, '', "\c6You don't need another\c3" SPC $CityRPG::prices::weapon::name[%itemID].uiName @ "\c6.");
			else if(%freeSpot $= "")
				messageClient(%client, '', "\c6You don't have enough space to carry this item!");
		}
		else
			messageClient(%client, '', "\c6This vendor is not liscensed to sell items.");
	}
}

function gameConnection::sellZone(%client, %brick, %price, %payment)
{
	if(isObject(%brick) && %brick.getClassName() $= "fxDTSBrick" && CityRPGData.getData(%client.bl_id).value[%payment] >= %price)
	{
		if(%client.brickGroup.lotsOwned < $CityRPG::pref::realestate::maxLots)
		{
			%brick.setDatablock(%brick.getDatablock().CityRPGMatchingLot);
			%client.brickGroup.add(%brick);
			%brick.handleCityRPGBrickCreation();
			
			messageClient(%client, '', '\c6You have purchased a \c3%1\c6 for $%2', %brick.getDatablock().uiName, %price);
			CityRPGData.getData(%client.bl_id).value[%payment] -= %price;
			
			%client.setInfo();
		}
		else
			messageClient(%client, '', "\c6You already own enough lots.");
	}
}

function gameConnection::sellClothes(%client, %brick, %item, %price, %payment)
{
	if(isObject(%client.player) && CityRPGData.getData(%client.bl_id).value[%payment] >= %price)
	{
		if(JobSO.job[CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueJobID].sellClothes)
		{
			messageClient(%client, '', "\c6Enjoy the new look!");
			CityRPGData.getData(%client.bl_id).value[%payment] -= %price;
			ClothesSO.giveItem(%client, %item);
			
			%client.applyForcedBodyColors();
			%client.applyForcedBodyParts();
			
			%client.setInfo();
		}
		else
			messageClient(%client, '', "\c6This vendor is not liscensed to sell clothes.");
	}
}

function gameConnection::sellLight(%client, %brick, %price, %payment)
{
	if(isObject(%client.player) && CityRPGData.getData(%client.bl_id).value[%payment] >= %price)
	{
		if(CityRPGData.getData(%client.bl_id).valuelight == 1)
		{
			messageClient(%client, '', "\c6You've Already Bought A Light");
			return;
		}
		else
		{
			messageClient(%client, '', "\c6Enjoy the new light!");
			CityRPGData.getData(%client.bl_id).value[%payment] -= %price;
			CityRPGData.getData(%client.bl_id).valuelight = 1;
			
			servercmdlight(%client);
			
			%client.setInfo();
			return;
		}
	}
}

// Output Events
function gameConnection::messageBoxOK(%this, %arg1, %arg2, %client)
{
	if(%arg1 $= "" || %arg2 $= "")
	{
		return;
	}
	
	commandToClient(%client,'messageBoxOK',%arg1,%arg2);
}

function player::giveDefaultEquipment(%this)
{
	if(!getWord(CityRPGData.getData(%this.client.bl_id).valueJailData, 1))
	{
		if(CityRPGData.getData(%this.client.bl_id).valueTools $= "")
		{
			%tools = ($CityRPG::pref::giveDefaultTools ? $CityRPG::pref::defaultTools @ " " : "") @ %this.client.getJobSO().tools;
			CityRPGData.getData(%this.client.bl_id).valueTools = "";
		}
		else
			%tools = CityRPGData.getData(%this.client.bl_id).valueTools;
		
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(!isObject(getWord(%tools, %a)))
			{
				%this.tool[%a] = "";
				messageClient(%this.client, 'MsgItemPickup', "", %a, 0);
			}
			else
			{	
				%this.tool[%a] = nameToID(getWord(%tools, %a));
				messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(getWord(%tools, %a)));
			}
			
		}
	}
	else
	{
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(isObject($CityRPG::demerits::jail::item[%a]))
			{
				%tool = $CityRPG::demerits::jail::item[%a];
			}
			else
			{
				%tool = "";	
			}
			
			%this.tool[%a] = nameToID(%tool);
			messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(%tool));
		}
	}
}

// ============================================================
// Section 4 : Trigger Bullshit
// ============================================================
function CityRPGLotTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	parent::onEnterTrigger(%this, %trigger, %obj);
	
	if(!isObject(%obj.client))
	{
		if(isObject(%obj.getControllingClient()))
			%client = %obj.getControllingClient();
		else
			return;
	}
	else
		%client = %obj.client;
	
	%trigger.parent.onEnterLot(%obj);
	
	%client.CityRPGTrigger = %trigger;
	%client.CityRPGLotBrick = %trigger.parent;
	
	%client.SetInfo();
}

function CityRPGLotTriggerData::onLeaveTrigger(%this, %trigger, %obj)
{
	if(!isObject(%obj.client))
	{
		if(isObject(%obj.getControllingClient()))
			%client = %obj.getControllingClient();
		else
			return;
	}
	else
		%client = %obj.client;
	
	%trigger.parent.onLeaveLot(%obj);
	
	%client.CityRPGTrigger = "";
	%client.CityRPGLotBrick = "";
	
	%client.SetInfo();
}

function CityRPGInputTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	%obj.client.CityRPGTrigger = %trigger;
	
	%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, true, "");
}

function CityRPGInputTriggerData::onLeaveTrigger(%this, %trigger, %obj, %a)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	if(%obj.client.CityRPGTrigger == %trigger)
	{
		%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, false, "");
		
		%obj.client.CityRPGTrigger = "";
	}
}

// ============================================================
// Section 5 : Client->Server Commands
// ============================================================

// Section 5.1 : General Commands
function serverCmdhelp(%client, %section, %term)
{	
	if(!isObject(CityRPGHelp))
	{
		echo("CityRPG :: Creating new Hellen on Request.");
		new scriptObject(CityRPGHelp)
		{
			class = Hellen;
		};
	}
	
	if(%section $= "")
	{
		CityRPGHelp.displayHelp(%client, "main");
		
		if(%client.isAdmin)
			CityRPGHelp.displayHelp(%client, "main_adminline");
	}
	else
	{
		if(%term)
			messageClient(%client, '', "\c6You must specify a term. Usage: \c3/help [section] [term]\c6.");
		else
		{
			%query = %section @ "_" @ %term;
			
			if(%section $= "list")
			{
				if(%term $= "lots")
				{
					messageClient(%client, '', "\c6This is a list of lots you can plant.");
					
					for(%a = 0; %a < datablockGroup.getCount(); %a++)
					{
						%datablock = datablockGroup.getObject(%a);
						
						if(%datablock.CityRPGBrickType == 1)
						{
							messageClient(%client, '', "\c3" @ %datablock.uiName SPC "\c6- Size: \c3" @ %datablock.brickSizeX @ "x" @ %datablock.brickSizeY SPC "\c6Cost: \c3" @ %datablock.initialPrice SPC "\c6Tax: \c3" SPC %datablock.taxAmount);
						}
					}
				}
				else if(%term $= "items")
				{
					messageClient(%client, '', "\c6This is a list of item prices.");
					
					for(%a = 1; isObject($CityRPG::prices::weapon::name[%a]); %a++)
					{
						messageClient(%client, '', "\c3" @ $CityRPG::prices::weapon::name[%a].uiName SPC "\c6- \c3$" @ $CityRPG::prices::weapon::price[%a]);
					}
				}
				else if(%term $= "food")
				{
					messageClient(%client, '', "\c6This is a list of all food stuff.");
					for(%a = 12; %a > 0; %a--)
					{
						messageClient(%client, '', '\c3%1\c6 - \c3$%2', $CityRPG::food::name[%a], mFloor((%a) * 4));
					}
				}
				else
					messageClient(%client, '', "\c6You did not request a real list.");
			}
			else
			{
				if(!CityRPGHelp.displayHelp(%client, %query))
				{
					messageClient(%client, '', "\c6Help doc '\c3" @ %query @ "\c6' does not exist\c6!");
				}
			}
		}
	}
}

function serverCmdYes(%client, %bank)
{
	if(strlwr(%bank) $= "bank") { %payment = "bank"; }
	if(%bank $= "") { %payment = "money";}
	if(isObject(%client.player) && isObject(%client.player.serviceOrigin))
	{
		if(mFloor(VectorDist(%client.player.serviceOrigin.getPosition(), %client.player.getPosition())) < 16)
		{
			if(CityRPGData.getData(%client.bl_id).value[%payment] >= %client.player.serviceFee)
			{
				%ownerBL_ID = %client.player.serviceOrigin.getGroup().bl_id;
				switch$(%client.player.serviceType)
				{
					case "service":
						CityRPGData.getData(%client.bl_id).value[%payment] -= %client.player.serviceFee;
						CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueBank += %client.player.serviceFee;
						
						messageClient(%client, '', "\c6You have accepted the service fee of \c3$" @ %client.player.serviceFee @ "\c6!");
						%client.setInfo();
						
						if(%client.player.serviceOrigin.getGroup().client)
							messageClient(%client.player.serviceOrigin.getGroup().client, '', "\c3" @ %client.name @ "\c6 has wired you \c3$" @ %client.player.serviceFee @ "\c6 for a service.");
					
						%client.player.serviceOrigin.onTransferSuccess(%client);
						
					case "food":
						%client.sellFood(%ownerBL_ID, %client.player.serviceSize, %client.player.serviceItem, %client.player.serviceFee, %client.player.serviceMarkup, %payment);
						
					case "item":
						%client.sellItem(%ownerBL_ID, %client.player.serviceItem, %client.player.serviceFee, %client.player.serviceMarkup, %payment);
						
					case "zone":
						%client.sellZone(%client.player.serviceOrigin, %client.player.serviceFee, %payment);
						
					case "clothes":
						%client.sellClothes(%client.player.serviceOrigin, %client.player.serviceItem, %client.player.serviceFee, %payment);
						
					case "light":
						%client.sellLight(%client.player.serviceOrigin, %client.player.serviceFee, %payment);
				}
			}
			else
			{
				messageClient(%client, '', "\c6You cannot afford this service.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6You are too far away from the service to purchase it!");
		}
	}
	else
	{
		messageClient(%client, '', "\c6You have no active tranfers that you may accept!");
	}
	
	%client.player.serviceType = "";
	%client.player.serviceFee = "";
	%client.player.serviceMarkup = "";
	%client.player.serviceItem = "";
	%client.player.serviceSize = "";
	%client.player.serviceOrigin = "";
}

function serverCmdNo(%client)
{
	if(isObject(%client.player.serviceOrigin))
	{
		messageClient(%client, '', "\c6You have rejected the service fee!");
		
		%client.player.serviceOrigin.onTransferDecline(%client);
		
		%client.player.serviceType = "";
		%client.player.serviceFee = "";
		%client.player.serviceMarkup = "";
		%client.player.serviceItem = "";
		%client.player.serviceSize = "";
		%client.player.serviceOrigin = "";
	}
	else
		messageClient(%client, '', "\c6You have no active tranfers that you may decline!");
}

function Player::GetObjectFromPOW(%player, %mask)
{
	%mask = %mask || $TypeMasks::all;
	%point = %player.getEyePoint();
	%obj = containerRayCast(%point, vectorAdd(vectorScale(vectorNormalize(%player.getEyeVector()), 4), %point), %mask, %player);
	return firstWord(%obj);
}

function serverCmdgiveMoney(%client, %money)
{
	%money = mFloor(%money);
	
	if(%money > 0)
	{
		if((CityRPGData.getData(%client.bl_id).valueMoney - %money) >= 0)
		{
			if(isObject(%client.player))
			{
			
			%player = %client.player;
			
			// Player exists
			if (isObject(%player))
				%obj = %player.GetObjectFromPOW($TypeMasks::PlayerObjectType);
				
				%target = %obj.client;
				
				if((isObject(%obj) && (%obj.getType() & $TypeMasks::PlayerObjectType) && isObject(%obj.client)))
				{
					messageClient(%client, '', "\c6You give \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
					messageClient(%target, '', "\c3" @ %client.name SPC "\c6has given you \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%client.bl_id).valueMoney -= %money;
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%client.SetInfo();
					%target.SetInfo();
				}
				else
				{
					messageClient(%client, '', "\c6You must be looking at and be in a reasonable distance of the player in order to give them money.");
					return;
				}
			}
			else
			{
				messageClient(%client, '', "\c6Spawn first before you use this command.");
				return;
			}
		}
		else
		{
			messageClient(%client, '', "\c6You don't have that much money to give.");
			return;
		}
	}
	else
	{
		messageClient(%client, '', "\c6You must enter a valid amount of money to give.");
		return;
	}
}

function serverCmdjobs(%client, %job, %job2, %job3, %job4, %job5)
{
	if(%job !$= "")
	{
		// Concat Job Words
		%job = %job @ (%job2 !$= "" ? " " @ %job2 @ (%job3 !$= "" ? " " @ %job3 @ (%job4 !$= "" ? " " @ %job4 @ (%job5 !$= "" ? " " @ %job5 : "") : "") : "") : "");
		
		for(%a = 1; %a <= JobSO.getJobCount(); %a++)
		{
			if(strlwr(%job) $= strLwr(JobSO.job[%a].name))
			{
				%foundJob = true;
				
				if(%a == CityRPGData.getData(%client.bl_id).valueJobID)
				{
					messageClient(%client, '', "\c6You are already" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6!");
				}
				else
				{
					if(JobSO.job[%a].law && getWord(CityRPGData.getData(%client.bl_id).valueJailData, 0) == 1)
					{
						messageClient(%client, '', "\c6You don't have a clean criminal record. You can't become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
					}
					else
					{
						if(mFloor(JobSO.job[%a].education) > 0)
						{
							if(CityRPGData.getData(%client.bl_id).valueEducation < JobSO.job[%a].education)
							{
								messageClient(%client, '', "\c6You are not educated enough to get this job.");
							}
							else
							{
								if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
								{
									messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
								}
								else
								{
									%gotTheJob = true;
									messageClient(%client, '', "\c6Congratulations, you are now" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
									CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
								}
							}
						}
						else
						{
							if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
							{
								messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
							}
							else
							{
								%gotTheJob = true;
								messageClient(%client, '', "\c6You have made your own initiative to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
								CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
							}
						}
					}
				}
				
				if(%gotTheJob)
				{					
					CityRPGData.getData(%client.bl_id).valueJobID = %a;
					CityRPGData.getData(%client.bl_id).valueJobEXP = 0;
					
					if(isObject(%client.player))
					{
						serverCmdunUseTool(%client);
						%client.player.giveDefaultEquipment();
						%client.applyBodyColors();
						%client.applyBodyParts();
					}
					
					%client.SetInfo();
				}
			}
		}
		
		if(!%foundJob)
			messageClient(%client, '', "\c6No such job as \c3" @ %job @ "\c6. Type \c3/help list jobs\c6 to see a list of the jobs.");
	}
	else
		messageClient(%client, '', "\c6Type \c3/help list jobs\c6 to see a list of jobs.");
}

function serverCmdreset(%client, %name)
{
	if(%client.isAdmin && %name !$= "")
	{
		%target = findclientbyname(%name);
		%extra = " by \c3" @ %client.name @ "\c6";
	}
	else
	{
		%target = %client;
		%extra = ".";
	}
	if(CityRPGData.getData(%target.bl_id).valueMoney >= $CityRPG::prices::reset)
	{
		messageClient(%target, '', '\c6Your account has been reset%1.', %extra);
		
		CityRPGData.removeData(%target.bl_id);
		CityRPGData.addData(%target.bl_id);
		
		if(isObject(%target.player))
		{
			%target.spawnPlayer();
		}
	}
	else
		messageClient(%target, '', "\c6You need at least \c3$" @ $CityRPG::prices::reset SPC "\c6to do that.");
}

function serverCmdpardon(%client, %name)
{
	if(%client.getJobSO().canPardon || %client.isAdmin)
	{		
		if(%name !$= "")
		{
			%target = findClientByName(%name);
			
			if(isObject(%target))
			{
				if(getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1))
				{
					%cost = $CityRPG::pref::demerits::pardonCost * getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1);
					if(CityRPGData.getData(%client.bl_id).valueMoney >= %cost || %client.isAdmin)
					{
						if(%client.isAdmin || %target != %client)
						{
							CityRPGData.getData(%client.bl_id).valueMoney -= (%client.isAdmin ? 0 : %cost);
							CityRPGData.getData(%target.bl_id).valueJailData = getWord(CityRPGData.getData(%target.bl_id).valueJailData, 0) SPC 0;
							
							if(%target != %client)
							{
								messageClient(%client, '', "\c6You have let\c3" SPC %target.name SPC "\c6out of prison.");
								messageClient(%target, '', "\c3" @ %client.name SPC "\c6has issued you a pardon.");
							}
							else
							{
								messageClient(%client, '', "\c6You have pardoned yourself.");
							}
							
							%target.buyResources();
							%target.spawnPlayer();
							%client.SetInfo();
						}
						else
						{
							messageClient(%client, '', "\c6The extent of your legal corruption only goes so far. You cannot pardon yourself.");
						}
					}
					else
					{
						messageClient(%client, '', "\c6You need at least \c3$" @ %cost SPC "\c6to pardon someone.");
					}
				}
				else
				{
					messageClient(%client, '', "\c6That person is not a convict.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6That person does not exist.");
			}
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
		}
	}
	else
	{
		messageClient(%client, '', "\c6You can't pardon people.");
	}
}

function serverCmdclearrecord(%client, %name)
{
	if(%client.getJobSO().canPardon || %client.isAdmin)
	{		
		if(%name !$= "")
		{
			%target = findClientByName(%name);
			
			if(isObject(%target))
			{
				if(getWord(CityRPGData.getData(%target.bl_id).valueJailData, 0))
				{
					%cost = $CityRPG::pref::demerits::recordShredCost;
					if(CityRPGData.getData(%client.bl_id).valueMoney >= %cost || %client.isAdmin)
					{
							CityRPGData.getData(%target.bl_id).valueJailData = "0" SPC getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1);
							if(%target != %client)
							{
								messageClient(%client, '', "\c6You have ran\c3" SPC %target.name @ "\c6's criminal record through a paper shredde.");
								messageClient(%target, '', "\c3It seems your criminal record has simply vanished...");
								
								if(!%client.isAdmin)
									CityRPGData.getData(%client.bl_id).valueMoney -= %cost;
							}
							else
								messageClient(%client, '', "\c6You have erased your criminal record.");
							
							%target.spawnPlayer();
							%client.setInfo();
					}
					else
					{
						messageClient(%client, '', "\c6You need at least \c3$" @ %cost SPC "\c6to erase someone's record.");
					}
				}
				else
				{
					messageClient(%client, '', "\c6That person does not have a criminal record.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6That person does not exist.");
			}
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
		}
	}
	else
	{
		messageClient(%client, '', "\c6You can't pardon people.");
	}
}

function serverCmdcrims(%client)
{
	if(%client.getJobSO().law && isObject(%client.player))
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%subClient = ClientGroup.getObject(%i);
			if(%client != %subClient)
			{
				if(isObject(%subClient.player) && %subClient.getWantedLevel())
				{
					%sCpos = %subClient.player.getPosition();
					%cPos = %client.player.getPosition() ;
					
					%dist[%count++] = VectorDist(%subClient.player.getPosition(), %client.player.getPosition());
					%target[%count] = %subClient;
				}
			}
		}
		
		if(%count)
		{
			%cPos = %client.player.getPosition();
			%cX = getWord(%cPos, 0);
			%cY = getWord(%cPos, 1);
			
			for(%a = 1; %a <= %count; %a++)
			{
				%scPos = %target[%a].player.getPosition();
				%scX = getWord(%scPos, 0);
				%scY = getWord(%scPos, 1);
				
				%xDif = mFloor(%cX - %scX);
				%yDif = mFloor(%cY - %scY);
				
				if(%xDif > 0 && %yDif < 0)
					%loc = "Northwest";
				else if(%xDif == 0 && %yDif < 0)
					%loc = "North";
				else if(%xDif < 0 && %yDif < 0)
					%loc = "Northeast";
				else if(%xDif > 0 && %yDif == 0)
					%loc = "West";
				else if(%xDif < 0 && %yDif == 0)
					%loc = "somewhere";
				else if(%xDif > 0 && %yDif == 0)
					%loc = "East";
				else if(%xDif > 0 && %yDif > 0)
					%loc = "Southwest";
				else if(%xDif == 0 && %yDif > 0)
					%loc = "South";
				else if(%xDif < 0 && %yDif > 0)
					%loc = "Southeast";
				
				messageClient(%client, '', "\c3" @ %target[%a].name SPC "\c6is\c3" SPC mFloor(%dist[%a] * 2) SPC "\c6bricks\c3" SPC %loc SPC "\c6of you.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6No criminals!");
		}
	}
}

function serverCmdFaceNorth(%client)
{
	if(isObject(%client.player))
		%client.player.setTransform(%client.player.getPosition() SPC "0 0 0 0");
}

function serverCmdReincarnate(%client, %do)
{
	if(!CityRPGData.getData(%client.bl_id).valueReincarnated)
	{
		if(%do $= "accept")
		{
			if((CityRPGData.getData(%client.bl_id).valueMoney + CityRPGData.getData(%client.bl_id).valueBank) >= 100000)
			{
				CityRPGData.removeData(%client.bl_id);
				CityRPGData.addData(%client.bl_id);
				CityRPGData.getData(%client.bl_id).valueReincarnated = 1;
				CityRPGData.getData(%client.bl_id).valueEducation = 8;
				
				if(isObject(%client.player))
				{
					%client.spawnPlayer();
				}
				
				messageAllExcept(%client, '', '\c3%1\c6 has been reincarnated!', %client.name);
				messageClient(%client, '', "\c6You have been reincarnated.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6Reincarnation is a method for those who are on top to once again replay the game.");
			messageClient(%client, '', "\c6It costs $100,000 to Reincarnate yourself. Your account will almost completely reset.");
			messageClient(%client, '', "\c6The perks of doing this are...");
			messageClient(%client, '', "\c6 - You will start with a level 8 education (+2 maximum)");
			messageClient(%client, '', "\c6 - Your name will be yellow by default and orange if you are wanted.");
			messageClient(%client, '', "\c6Type \c3/reincarnate accept\c6 to start anew!");
		}
	}
	else
		messageClient(%client, '', "\c6One cannot be thrice born.");
}

function serverCmdSexChange(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueGender !$= "Female")
		CityRPGData.getData(%client.bl_id).valueGender = "Female";
	else
		CityRPGData.getData(%client.bl_id).valueGender = "Male";
	
	%client.gender = CityRPGData.getData(%client.bl_id).valueGender;
	%client.redoAvatar = true;
	
	%client.applyForcedBodyParts();
	%client.applyForcedBodyColors();
	
	messageClient(%client, '', '\c6You are now \c3%1\c6.', CityRPGData.getData(%client.bl_id).valueGender);
}

// Section 5.2 : Admin Commands
function serverCmdgrantMoney(%client, %name, %money)
{
	if(%client.isAdmin)
	{
		%money = mFloor(%money);
		
		if(%money > 0)
		{
			if(%name !$= "")
			{
				if(isObject(%target = findClientByName(%name)))
				{
					if(%target != %client)
					{
						messageClient(%client, '', "\c6You granted \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
						messageClient(%target, '', '\c3%1 \c6has granted you \c3$%2\c6.', %client.name, %money);
					}
					else
						messageClient(%client, '', "\c6You granted yourself \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%target.SetInfo();
				}
				else
					messageClient(%client, "\c6The name you entered could not be matched up to a person.");
			}
			else if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					messageClient(%client, '', "\c6You granted \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
					messageClient(%target, '', "\c3" @ %client.name @"\c3 has granted you \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%target.SetInfo();
				}
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		}
		else
			messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmdgrantplastic(%client, %name, %plastic)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
	%plastic = mFloor(%plastic);
		
	if(!%plastic > 0)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of plastic to grant.");
		return;
	}

	if(%name !$= "")
	{
		if(isObject(%target = findClientByName(%name)))
		{
			if(%target != %client)
			{
				messageClient(%client, '', "\c6You granted \c3" @ %plastic @ " \c6pieces of plastic to \c3" @ %target.name @ "\c6.");
				messageClient(%target, '', "\c3" @ %client.name @ "\c6 has granted you \c3" @ %plastic @ " \c6pieces of plastic. ");
			}
			else
				messageClient(%client, '', "\c6You granted yourself \c3" @ %plastic @ "\c6 plastic.");
			
			CityRPGData.getData(%target.bl_id).valueResources = getword(CityRPGData.getData(%target.bl_id).valueResources, 0) SPC getword(CityRPGData.getData(%target.bl_id).valueResources, 1) SPC (getword(CityRPGData.getData(%target.bl_id).valueResources, 2) + %plastic);
			
			%target.SetInfo();
		}
		else
			messageClient(%client, "\c6The name you entered could not be matched up to a person.");
	}
}

function serverCmdgranteducation(%client, %name, %education)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
	%education = mFloor(%education);
		
	if(!%education > 0)
	{
		messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}

	if(%name !$= "")
	{
		if(isObject(%target = findClientByName(%name)))
		{
			if(%target != %client)
			{
				messageClient(%client, '', "\c6You granted \c3" @ %education @ " \c6education to \c3" @ %target.name @ "\c6.");
				messageClient(%target, '', "\c3" @ %client.name @ "\c6 has granted you \c3" @ %education @ " \c6education. ");
			}
			else
				messageClient(%client, '', "\c6You granted yourself \c3" @ %education @ "\c6 education.");
			
			CityRPGData.getData(%target.bl_id).valueEducation += %education;
			
			%target.SetInfo();
		}
		else
			messageClient(%client, "\c6The name you entered could not be matched up to a person.");
	}
}

function serverCmdsetjob(%client, %name, %jobID)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
	%jobID = mFloor(%jobID);
		
	if(%jobID <= 0 || %jobID > JobSO.getJobCount())
	{
		messageClient(%client, '', "\c6No Such JobID");
		return;
	}

	if(%name !$= "")
	{
		if(isObject(%target = findClientByName(%name)))
		{
			if(%target != %client.name)
			{
				messageClient(%client, '', "\c6You set \c3" @ %target.name @ "s\c6 job to \c3" @ JobSO.job[%jobID].name @ "\c6.");
				messageClient(%target, '', "\c3" @ %client.name @ "\c6 has set your job to \c3" @ JobSO.job[%jobID].name @ "\c6. ");
			}
			else
			{
				messageClient(%target, '', "\c6You set your job to " @ JobSO.job[%jobID].name @ "\c6.");
			}
			CityRPGData.getData(%target.bl_id).valuejobID = %jobID;
			%target.SetInfo();
			%target.spawnplayer();
		}
		else
			messageClient(%client, "\c6The name you entered could not be matched up to a person.");
	}
}

function serverCmddeductMoney(%client, %name, %money)
{
	if(%client.isAdmin)
	{
		%money = mFloor(%money);
		
		%moneycheck = (%money + CityRPGData.getData(%target.bl_id).valuemoney);
		
		if(%moneycheck >= 0)
		{
			if(%money > 0)
			{
				if(isObject(%target = findClientByName(%name)))
				{
					if(%target != %client)
					{
						messageClient(%client, '', "\c6You deducted \c3$" @ %money @ "\c6from \c3" @ %target.name @ "\c6.");
						messageClient(%target, '', "\c3" @ %client.name @ "\c6 has deducted \c3$" @ %money @ "\c6 from you.");
					}
					else
					{
						messageClient(%client, '', "\c6You have deducted \c3$" @ %money @ "\c6 from yourself.");
					}
					
					CityRPGData.getData(%target.bl_id).valueMoney -= %money;
					
					%target.SetInfo();
				}
				else
				{
					messageClient(%client, '', "\c6Enter a valid player's name.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
			}
		}
		else
		{
			messageClient(%client, '', "\c3%1/c6, does not have that much money on hand.", %client.name);
		}
	}
	else
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
	}
}

function serverCmdforcehour(%client)
{
	if(%client.isAdmin)
	{
		messageAll(%client, '\c3%1 \c6has forced an hour to pass.', %client.name);
		CityRPG_tickhour();
		CalendarSO.min = 0;
		return;
	}
	else
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
}

function serverCmdforceday(%client)
{
	if(%client.isAdmin)
	{
		CalendarSO.hour = 2;
		CalendarSO.min = 0;
		CityRPG_Tick();
		DaySO.getday();
		messageAll(%client, '\c3%1 \c6has forced 1 day to pass.', %client.name);
	}
	else
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
}

function serverCmdforcenight(%client)
{
	if(%client.isAdmin)
	{
		if(CalendarSO.hour >= 20 || CalendarSO.hour <= 1)
		{
			CityRPG_Tick();
		}
		
		CalendarSO.hour = 20;
		CalendarSO.min = 0;
		DaySO.getday();
		messageAll(%client, '\c3%1 \c6has forced nightfall.', %client.name);
	}
	else
	{
		messageClient(%client, '', "\c6You must be admin to use the this command.");
		return;
	}
}

function serverCmdDate(%client)
{
	%day = CalendarSO.day;
	
	// If the second number from last is a "1" (e.g. 12 or 516), the suffix will always be "th"
	if(strlen(%day) > 1 && getSubStr(%day, (strlen(%day) - 2), 1) $= "1")
	{
		%suffix = "th";
	}
	// If not, it can either be "st," "nd," "rd," or "th," depending on the last numeral.
	else
	{
		switch(getSubStr(%day, (strlen(%day) - 1), 1))
		{
			case 1: %suffix = "st";
			case 2: %suffix = "nd";
			case 3: %suffix = "rd";
			default: %suffix = "th";
		}
	}
	
	// Date
	messageClient(%client, '', '\c6Todays Date is: \c3%1\c6 the \c3%2\c6%4, \c3%3\c6', CalendarSO.nameOfMonth[CalendarSO.month], CalendarSO.day, CalendarSO.year, %suffix);
	
	// Current Weather
	%dwforecast = $CityRPG::enviro::CurrWeather;
	if(%dwforecast $= "snow" || %dwforecast $= "rain") { %dforecast = $CityRPG::enviro::CurrWeather @ "y"; } else { %dforecast = "clear"; }
	messageClient(%client, '', '\c6 - With a \c3%1 forecast', %dforecast);
	
	// Current Time
	if(CalendarSO.hourAMPM $= "") { if(CalendarSO.hour >= 12) { %AMPM = "PM"; } else { %AMPM = "AM"; } } else { %AMPM = CalendarSO.hourAMPM; }
	if(CalendarSO.Min < 10) { %min = "0" @ CalendarSO.Min; } else { %min = CalendarSO.Min; }
	if(CalendarSO.hour > 12) { %hour = (CalendarSO.hour - 12); } else { %hour = CalendarSO.hour; }
	if(CalendarSO.hour == 0) { %hour = 12; }
	messageClient(%client, '', '\c6 - Current Time is: \c3%1\c6:\c3%2 \c6%3', %hour, %Min, CalendarSO.HourAMPM);
}
function serverCmdaddDemerits(%client, %dems, %name)
{
	if(%client.isAdmin)
	{
		%dems = mFloor(%dems);
		
		if(%dems > 0)
		{
			if(%name !$= "")
			{
				if(isObject(%target = findClientByName(%name)))
				{
					commandToClient(%target, 'centerPrint', "\c6You have committed a crime:  [\c3Angering an admin\c6]", 5);
					messageClient(%client, '', '\c6User \c3%1 \c6was given \c3%2\c6 demerits.', %target.name , %dems);
					CityRPG_AddDemerits(%target.bl_id, %dems);
				}
				else
					messageClient(%client, "\c6The name you entered could not be matched up to a person.");
			}
			else if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					commandToClient(%target, 'centerPrint', "\c6You have committed a crime:  [\c3Angering a Badmin\c6]", 5);
					messageClient(%client, '', '\c6User \c3%1 \c6was given \c3%2\c6 demerits.', %target.name , %dems);
					CityRPG_AddDemerits(%target.bl_id, %dems);
				}
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		}
		else
			messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmdrainMoney(%client, %bills)
{
	if(%client.isAdmin)
	{
		%bills = mFloor(%bills);
		
		if(%bills > 0)
		{
			if(%bills > 250)
				%bills = 250;
			
			messageAll('', "\c6It's raining \c2money\c6 near \c3" @ %client.name @ "\c6!");
			
			for(%i = 0; %i <= %bills; %i++)
			{
				%cash = new Item()
				{
					datablock = cashItem;
					value = mFloor(getRandom(1, 5));
					canPickup = false;
				};
				%randomPosition = setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 100);
				%randomPosition = setWord(%randomPosition, 0, getRandom(getWord(%randomPosition, 0) - 32, getWord(%randomPosition, 0) + 32));
				%randomPosition = setWord(%randomPosition, 1, getRandom(getWord(%randomPosition, 1) - 32, getWord(%randomPosition, 1) + 32));
				
				%randomTime = getRandom(1, 30) * 1000;
				
				%cash.schedule(%randomTime,"setTransform", %randomPosition);
				MissionCleanup.schedule(%randomTime + 1, "add", %cash);
				%cash.schedule(%randomTime + 2, "setShapeName", ("$" @ %cash.value));
			}
		}
		else
			messageClient(%client, '', "\c6Please enter a valid number.");
	}
	else
		messageClient(%client, '', "\c6You need to be an Admin to use this function.");
}

function serverCmdresetUser(%client, %name)
{
	if(%client.isAdmin)
	{
		if(%name !$= "")
		{
			if(isObject(%target = findClientByName(%name)))
			{
				messageClient(%target, '', "\c6Your account was reset by an admin.");
				messageClient(%client, '', "\c3" @ %target.name @ "\c6's account was reset.");
				
				CityRPGData.removeData(%target.bl_id);
				CityRPGData.addData(%target.bl_id);
				
				if(isObject(%target.player))
				{
					%target.player.delete();
					%target.spawnPlayer();
				}
			}
			else
				messageClient(%client, '', "\c6That person does not exist.");
		}
		else
			messageClient(%client, '' , "\c6Please enter a name.");	
	}	
}

function serverCmdstats(%client, %page, %name)
{
	if(%client.isAdmin && %name !$= "")
		%target = findClientByName(%name);
	else
		%target = %client;
	
	if(isObject(%target))
	{
		if(%page $= "") { %page = "1"; }
		%stat = CityRPGData.getData(%target.bl_id);
		if(%page == 1)
		{
			%string = "Job:" SPC "\c3" @ JobSO.job[%stat.valueJobID].name;
			%string = %string @ "\n" @ "Job EXP:" SPC "\c3" @ %stat.valueJobEXP;
			%string = %string @ "\n" @ "Money in Wallet:" SPC "\c3" @ %stat.valueMoney;
			%string = %string @ "\n" @ "Money in Bank:" SPC "\c3" @ %stat.valueBank;
			%string = %string @ "\n" @ "Loan to pay back:" SPC "\c3" @ %stat.valueLoan;
			%string = %string @ "\n" @ "Net Worth:" SPC "\c3" @ (%stat.valueMoney + %stat.valueBank);
			%string = %string @ "\n" @ "Arrest Record:" SPC "\c3" @ (getWord(%stat.valueJailData, 0) ? "Yes" : "No");
			%string = %string @ "\n" @ "Ticks left in Jail:" SPC "\c3" @ getWord(%stat.valueJailData, 1);
			%string = %string @ "\n" @ "Total Demerits:" SPC "\c3" @ %stat.valueDemerits;
			%string = %string @ "\n" @ "Education:" SPC "\c3" @ %stat.valueEducation;
			%string = %string @ "\n" @ "Hunger Level:" SPC "\c3" @ %stat.valueHunger;
			%string = %string @ "\n" @ "Resources:" SPC "\c3" @ getWord(%stat.valueResources, 0) SPC getWord(%stat.valueResources, 1) SPC getWord(%stat.valueResources, 2);
			%string = %string @ "\n" @ "\c5View page 2 stats type: /stats 2";
		}
		else if(%page == 2)
		{
			if(%stat.valuedrive == 1) { %yn = "Yes"; } else { %yn = "No"; }
			%string = "Has A Driver License:" SPC "\c3" @ %yn;
			if(%stat.valuelight == 1) { %ny = "Yes"; } else { %ny = "No"; }
			%string = %string @ "\n" @ "Has Lamp: " @ %ny;
			if(%stat.valuepower == 1) { %yn1 = "Yes"; } else { %yn1 = "No"; }
			%string = %string @ "\n" @ "Paid Power Bill: " @ %yn1;
			if(%stat.valuereincarnated == 1) { %yn2 = "Yes"; } else { %yn2 = "No"; }
			%string = %string @ "\n" @ "Has Reincarnated: " @ %yn2;
			%string = %string @ "\n" @ "Business: " @ %stat.valuebusiness;
			if($CityRPG::Pref::SicknessName[%stat.valuesickness] > 0) { %sickness = $CityRPG::Pref::SicknessName[%stat.valuesickness]; } else { %sickness = "None"; }
			%string = %string @ "\n" @ "Sickness: " @ %sickness;
			%string = %string @ "\n" @ "Outfit: " @ %stat.valueoutfit;
			if(%stat.valueStudent == 1) { %yn3 = "Yes"; } else { %yn3 = "no"; }
			%string = %string @ "\n" @ "Student: " @ %yn3;
			%string = %string @ "\n" @ "Lots Owned: " @ %stat.valuelotdata;
			%string = %string @ "\n" @ "Bounty: " @ %stat.valuebounty;
			%string = %string @ "\n" @ "Gender: " @ %stat.valuegender;
			%string = %string @ "\n" @ "\c5View page 1 stats type: /stats 1";
		}
		else
		{
			messageClient(%client, '', '\c3%1 \c6is not a valid page', %page);
			return;
		}
		%bricks = %target.brickgroup.getcount();
		%title = "Name: " @ %target.name @ "(" @ %target.bl_id @ ")" @ " | Bricks: " @ %bricks;
		commandToClient(%client, 'MessageBoxOK', %title, %string);
	}
	else
		messageClient(%client, '', "\c6Either you did not enter or the person specified does not exist.");
}

function serverCmdcleardems(%client, %name)
{
	if(%client.isAdmin)
	{
		if(%name $= "") { %target = %client; } else { %target = findClientByName(%name); }
			if(CityRPGData.getData(%client.bl_id).valueDemerits > 0)
			{
				CityRPGData.getData(%target.bl_id).valueDemerits = 0;
				messageClient(%target, '', '\c6%1 \c3cleared your demerits.', %client.name);
				%client.setInfo();
				
				if(!%client.isSuperAdmin)
					messageAll(%client, '', '\c3%1\c6 is a cheater!', %client.name);
			}
			else
				messageClient(%client, '', "You are not wanted!");
		}
}

function serverCmdedithunger(%client, %name, %int)
{
	if(%client.isAdmin && mFloor(%int))
	{
		if(%name $= "") { %target = %client; } else { %target = findClientByName(%name); }
		%int = mFloor(%int);
		if(isObject(%target))
		{
			if(%int > 12)
				%int = 12;
			else if(%int < 1)
				%int = 1;
		}
		CityRPGData.getData(%target.bl_id).valueHunger = %int;
		%target.setGameBottomPrint();
		messageClient(%target, '', '\c3%1 \c6set your hunger to <color:%2>%3', %client.name, $CityRPG::food::color[%int], $CityRPG::food::state[%int]);
		messageClient(%client, '', '\c6You set \c3%1s \c6hunger to <color:%2>%3', %target.name, $CityRPG::food::color[%int], $CityRPG::food::state[%int]);
	}
}
function serverCmdeditstat(%client, %name, %stat, %number, %number2, %number3, %number4, %number5, %number6, %number7, %number8, %number9)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', '\c6You must be admin to use this command.');
		return;
	}
	if(isobject(findClientByName(%name)))
	{
		%stat = strlwr(%stat);
		// Bug Fixers
		if(%name $= "") { %target = %client; } else { %target = findClientByName(%name); }
		
		// Multi Vars
		if(%stat $= "jailData" || %stat $= "resources")
		{
			if(%stat $= "resources")
			{
				if(%number >= 0 && %number2 >= 0 && %number3 >= 0)
				{
					CityRPGData.getData(%target.bl_id).value[%stat] = %number SPC %number2 SPC %number3;
				}
			}
			else
			{
				if(%number >= 0 && %number2 >= 0)
				{
					CityRPGData.getData(%target.bl_id).value[%stat] = %number SPC %number2;
				}
			}
			messageClient(%target, '', '\c3%1 \c6altered your \c3%2 \c6stat to \c3%3 %4 %5', %client.name, %stat, %number, %number2, %number3);
			messageClient(%client, '', '\c6You altered \c3%1s %2 \c6stat to \c3%3 %4 %5', %target.name, %stat, %number, %number2, %number3);
			%target.SetInfo();
			return;
		}
		else
		// Outfit/Clothes
		if(%stat $= outfit)
		{
			if(%number $= "" || %number2 $= "" || %number3 $= "" || %number4 $= "" || %number5 $= "" || %number6 $= "" || %number7 $= "" || %number8 $= "" || %number9 $= "")
			{
				messageclient(%client, '', '\c6Incorrect amount of values');
				return;
			}
			CityRPGData.getData(%target.bl_id).value[%stat] = %number SPC %number2 SPC %number3 SPC %number4 SPC %number5 SPC %number6 SPC %number7 SPC %number8 SPC %number9;
			%target.applyForcedBodyColors();
			%target.applyForcedBodyParts();
			%outfitd = " " @ %number2 SPC %number3 SPC %number4 SPC %number5 SPC %number6 SPC %number7 SPC %number8 SPC %number9;
		}
		else
		// Numeric Data
		if(%stat $= "bank" || %stat $= "bounty" || %stat $= "demerits" || %stat $= "education" || %stat $= "hunger" || %stat $= "jobEXP" || %stat $= "jobID" || %stat $= "lotdata" || %stat $= "money" || %stat $= "loan")
		{
			if(%number >= 0)
			{
				CityRPGData.getData(%target.bl_id).value[%stat] = %number;
			}
			else
			{
				messageClient(%client, '', '\c6The \c3%1 \c6stat value can only be numbers.', %stat);
				return;
			}
		}
		else
		// 1/0 Data
		if(%stat $= "reincarnated" || %stat $= "student" || %stat $= "drive" || %stat $= "light" || %stat $= "power")
		{
			if(%number == 1 || %number == 0)
			{
				CityRPGData.getData(%target.bl_id).value[%stat] = %number;
			}
			else
			{
				messageClient(%client, '', '\c6The \c3%1 \c6stat value can only be \c31 \c6or \c30 ', %stat);
				return;
			}
		}
		else
		// Sickness
		if(%stat $= "sickness")
		{
			if(%number < ($CityRPG::Pref::NumofSicknesses + 1) && %number >= 0)
			{
				CityRPGData.getData(%target.bl_id).value[%stat] = %number;
				applysickness(%target);
				if(%number == 0) { %number = "Healthy"; } else { %number = $CityRPG::Pref::SicknessName[%number]; }
			}
			else
			{
				messageClient(%client, '', '\c3%1 \c6is not a valid sickness.', %number);
				return;
			}
		}
		else
		{
			messageClient(%client, '', '\c3%1 \c6is not a valid stat.', %stat);
			return;
		}
		if(%stat $= "money" || %stat $= "bank") { if(%number >= $CityRPG::pref::bank::MaxMoney) { %number = $CityRPG::pref::bank::MaxMoney; } else{ %number = %number; } }
		messageClient(%target, '', '\c3%1 \c6altered your \c3%2 \c6stat to \c3%3%4\c6.', %client.name, %stat, %number, %outfitd);
		messageClient(%client, '', '\c6You altered \c3%1s %2 \c6stat to \c3%3%4\c6.', %target.name, %stat, %number, %outfitd);
		varcap(1);
		%target.SetInfo();
		return;
	}
	else
	{
		messageClient(%client, '', '\c6Player is not online.');
		return;

	}
}

function serverCmdWeather(%client, %type, %amount)
{
	if(!%client.isAdmin)
	{
		return messageClient(%client, '', '\c6You need to be an admin to use this command.');
	}
	
	if(%amount !$= "") { %amount = mFloor(%amount); }
	
	if(%amount >= 0 && %type !$= "")
	{
		%radioname = $CityRPG::pref::radioname;
		%radiofreq = $CityRPG::pref::radiofreq;
		
		if(%type $= "clear" || %type $= "")
		{
			if(%amount > 0)
			{
				%ammount = ((51 - %amount) * 5);
				WeatherSO.generateweather(clear, %ammount);
				%extra = " with a fog intensity of \c3" @ %amount @ "\c6.";
			}
			else
			{
				WeatherSO.generateweather("clear", '');
				%extra = ".";
			}
			messageAll('','\c6[\c3%1 %2\c6]:\c3 %3 \c6Changed The Weather To,\c3 Clear\c6%4', %radioname, %radiofreq, %client.name, %extra);
			return;
		}
		else if(%type $= "snow" || %type $= "rain")
		{
			if(%amount > "50")
			{
				%amount = "50";
			}

			WeatherSO.generateWeather(%type, %amount);
			messageAll('','\c6[\c3%1 %2\c6]:\c3 %3 \c6Changed The Weather To,\c3 %4 \c6With An Intensity Of\c3 %5\c6.', %radioname, %radiofreq, %client.name, %type, %amount);
			return;

		}
		else
		{
			messageClient(%client, '', '\c6[\c0ERROR\c6]: \c3%1 \c6is not a valid weather type.', %type);
			return;
		}
	}
	else
	{
		messageClient(%client, '', '\c6[\c0ERROR\c6]: Please provide a weather type and a weather intensity.');
		return;
	}
}

// Section 5.3 : Redirect Functions
function serverCmdjob(%client, %job, %job2, %job3, %job4, %job5) { serverCmdjobs(%client, %job, %job2, %job3, %job4, %job5); }

// ============================================================
// Section 7 : Misc. Shit Functions
// ============================================================
function CityRPG_Exec(%name)
{
	if(!strLen(%name)) %name = "server";
		
	if(isFile("Add-Ons/Hack_CityRPG/" @ %name @ ".cs"))
	{
		messageAll('', "\c6Executing a CityRPG file. The server may crash.");
		
		if(isFunction("dediSave"))
			dediSave("CityRPG_preExecSave", "File was saved right before a file execution.", true, true);
		
		schedule(300, 0, "exec", "Add-Ons/Hack_CityRPG/" @ %name @ ".cs");
	}
	else
		echo("Sorry, 'Add-Ons/Hack_CityRPG/" @ %name @ ".cs' is not a real file.");
}

function getAvgPing(%client)
{
	for(%a = 0; %a < 5; %a++)
	{
		for(%b = 0; %b < ClientGroup.getCount(); %b++)
		{
			%subClient = ClientGroup.getObject(%b);
			%totalPing += %subClient.getPing();
			%pingCount++;
		}
	}
	
	%averagePing = %totalPing / %pingCount;
	
	messageAll('', "\c6Average Sever Ping is" SPC %averagePing);
}

function laggiestClients(%client)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%b);
		%totalPing = 0;
		
		for(%b = 0; %b < 5; %b++)
		{
			%totalPing += %subClient.getPing();
		}
		
		%ping[%a] = %totalPing / 5;
	}
	
	%highestPing = 0;
	
	for(%c = 0; %c < ClientGroup.getCount(); %c++)
	{
		%subClient = ClientGroup.getObject(%c);
		
		if(%ping[%c] > %highestPing)
		{
			%highestPing = %ping[%c];
			%laggiestClient = %subClient;
		}
	}
	
	messageAll('', "\c6The laggiest client is \c3" @ %subClient.name @ "\c6 with an average ping of 5 trials being \c3" @ %highestPing @ "\c6.");
}

function serverCmdGetIP(%client, %name)
{
	if(%client.isAdmin && isObject(%target = findClientByName(%name)))
		serverCmdmessageSent(%target, "\c3My IP Address is:" SPC %target.getRawIP());
}

function sendBricksFromTo(%new, %old)
{
	if(isObject(%new) && isObject(%old))
	{
		for(%a = (%old.getCount() - 1); %a >= 0; %a--)
		{
			if(isObject(%brick = %old.getObject(%a)))
			{
				%new.add(%brick);
			}
		}
		
		echo("Success.");
	}
}

function serverCmdMassEffect(%client)
{
	if(%client.isSuperAdmin)
	{
		while(ClientGroup.getCount())
		{
			%subClient = ClientGroup.getObject(0);
			%subClient.delete("\nOperation \"Mass Cleanse\" is in effect.\nClearing all Clients due to Emergency.");
		}
	}
}

function serverCmdRespawnAllPlayers(%client)
{
	if(%client.isAdmin)
	{
		messageAll('', '\c3%1\c5 respawned all players.', %client.name);
		
		for(%a = 0; %a < ClientGroup.getCount(); %a++)
			ClientGroup.getObject(%a).spawnPlayer();
	}
}


function servercmdWarn(%client, %user)
{
        if(%client.isSuperAdmin == false || %client.isAdmin == false)
	{	
		return;
	}
		if(%user !$= "")
	{
		%target = findClientByName(%user).player;
		%targetC = findClientByName(%user);
		%target.warn();
		messageClient(%client, '', '\c2%1\c6 has been warned.', %targetC.name);
		messageClient(%targetC, '', '\c6You have been seen breaking a rule by an \c5Admin\c6 or \c5Super Admin.', %user);
		messageClient(%targetC, '', '\c6Further abuse could result in a kick, or ban.', %user);
        }		
}
function saveprefs()
{
	export("$CityRPG::*", "config/server/JJstorms CityRPG/Prefs.cs");
	echo("CityRPG Prefs Saved");
}

function loadprefs()
{
	if(isfile("config/server/JJstorms CityRPG/Prefs.cs"))
	{
		exec("config/server/JJstorms CityRPG/Prefs.cs");
	}
	else
	{
		exec("Add-Ons/GameMode_JJstormsCityRPG/prefs.cs");
	}
	echo("CityRPG Prefs loaded");
}

function GameTransferFile(%source, %target)
{
	%source = findFirstFile(%source);
	if (!isFile(%source))
		return false;
	
	// Open files
	%streamFrom = new fileObject();
	%streamTo = new fileObject();
	%streamFrom.openForRead(%source);
	%streamTo.openForWrite(%target);
	
	// Transferring
	while (!%streamFrom.isEOF())
		%streamTo.writeLine(%streamFrom.readLine());
	
	// Close files
	%streamTo.close();
	%streamFrom.close();
	%streamTo.delete();
	%streamFrom.delete();
	
	// Control check
	if (!isWriteableFileName(findFirstFile(%target)))
	{
		error("GameTransferFile: \"" @ %target @ "\" was not correctly created");
		return false;
	}
	return true;
}
function servercmdreloaddata(%client) {
	
	if(%client.isSuperAdmin == false || %client.isAdmin == false)
	{	
		return;
	}
	else
	{
		exec("config/server/JJstorms CityRPG/Prefs.cs");
		exec("config/server/JJstorms CityRPG/prefs.cs");
		export("$CityRPG::*", "config/server/JJstorms CityRPG/Prefs.cs");
		CityRPGData.savedata();
		CityRPGData.loaddata();
		messageall('',' \c4+ \c6Prefs and User data have been reloaded by \c3%1',%client.name);
	}
}
function servercmddropcash(%client, %amount) {
	if(!isObject(%client)) { messageClient(%client, '', '\c6You must spawn before using this command'); return;}
	if(%amount $= "") {
		messageClient(%client, '', '\c6Enter a number.');
		return;
	}
	if(!getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1)) {
	
		if(CityRPGData.getData(%client.bl_id).valueMoney >= %amount) {
			if(%amount >= 1) {
				%cash = new Item()
				{
					datablock = cashItem;
					canPickup = false;
					value = %amount;
				};
				
				%cash.setTransform(setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 4));
				// %cash.setVelocity(VectorAdd(%client.player.getVelocity(),VectorScale(%client.player.getEyeVector() + 1, 10)));
				%cash.setVelocity(setWord(%client.player.getVelocity(), 2, getword(%client.player.getEyeVector(), 2) + 5));
				
				MissionCleanup.add(%cash);
				%cash.setShapeName("$" @ %cash.value);
				
				CityRPGData.getData(%client.bl_id).valueMoney -= %amount;
				%client.SetInfo();
			}
			else
			{
				messageClient(%client, '', '\c6Enter a valid number.');
				return;
			}
		}
		else
		{
			messageClient(%client, '', '\c6You dont have that much cash.');
			return;
		}
		
	}
	else
	{
		messageClient(%client, '', '\c6You cant drop cash while in Jail.');
	}
}

function servercmdsetholiday(%client, %hdai)
{
	if(%hdai $= "christmas" || %hdai $= "halloween" || %hdai $= "easter" || %hdai $= "thanksgiving")
	{
		$CityRPG::pref::holiday = %hdai;
		messageclient(%client, '', "\c6 Holiday Set to \c3" @ %hdai);
		return;		
	}
	else
	{
		messageclient(%client, '', "\c3" @ %hdai @ " \c3Isn't a valid holiday. Type /holiday to view list of holidays");
		return;
	}
	
	if(%hdai $= "" || %hdai $= " " || %hdai == 0 )
	{
		messageclient(%client, '', "\c3 Holidays:");
		messageclient(%client, '', "\c6 christmas");
		messageclient(%client, '', "\c6 halloween");
		messageclient(%client, '', "\c6 easter");
		messageclient(%client, '', "\c6 thanksgiving");
		return;
		
	}
}

function servercmdbrickcount(%client)
{
	%bricks = 0;
	for(%i=0;%i<mainBrickGroup.getCount();%i++) {
		%bricks += mainBrickGroup.getObject(%i).getCount();
	}
	messageclient(%client, '', '\c0%1 bricks', %bricks);
	return;
}

// CellPhone
function servercmdcall(%client, %number, %override)
{
	if($CityRPG::pref::cancall != 1)
	{
		messageclient(%client, '', '\c6Phone towers are currently down. Try again later.');
		return;
	}
	// Jailbirds get 1 phone call
	if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
	{
		if(%client.jailcallsmade >= 1)
		{
			messageclient(%client, '', "\c6You already made your phone call.");
			%client.call = 0;
			return;
		}
		else if(isObject(findclientbyBL_ID(%forth)) && findclientbyBL_ID(%forth).hasSpawnedonce)
		{
			%client.jailcallsmade = 1;
		}
	}

	// Answering/ignoring/ending a call or calling onCalled event
	if(strlwr(%number) $= "answer" || strlwr(%number) $= "end" || strlwr(%number) $= "brick" || strlwr(%number) $= "phonebook")
	{
		// Answer
		if(strlwr(%number) $= "answer")
		{
			if(%client.bl_idcalling !$= "")
			{
				%target = findclientbybl_id(%client.bl_idcalling);
				
				// Alert both people
				messageclient(%client, '', '\c6You answered the phone call from \c3%1. \c6To Hang up type \c3 /call end.', %target.name);
				messageclient(%target, '', '\c3%1 \c6answered your phone call. To Hang up type \c3 /call end.', %client.name);
				messageclient(%client, '', '\c6Use the normal chat to talk to \c3%1', %target.name);
				messageclient(%target, '', '\c6Use the normal chat to talk to \c3%1', %client.name);
				
				// Set call vars
				%client.call = 1;
				%target.call = 1;
				return;
			}
			else
			{
				messageclient(%client, '', "\c6No Call to be answered");
				return;
			}
		}
		else
		
		// End Call
		if(strlwr(%number) $= "end")
		{
			if(%client.bl_idcalling !$= "")
			{
				%target = findclientbybl_id(%client.bl_idcalling);
				
				if(%client.call = 1 && isObject(%target))
				{
					if(isObject(%client) && %override $= "")
					{
						messageclient(%target, '', '\c3%1 Ended the call', %client.name);
						messageclient(%client, '', "\c3You Ended the call");
					}
					else
					{
						messageclient(%target, '', "\c3Call Ended");
						messageclient(%client, '', "\c3Call Ended");
					}
				}
				else if(%client.call == 0 && isObject(%target))
				{
					messageclient(%target, '', "\c3Call Ignored");
					messageclient(%client, '', "\c3Call Ignored");
				}
			}
			else
			{
				messageclient(%client, '', "\c3No call to hang up on.");
				return;
			}
			
			%client.call = 0;
			%client.bl_idcalling = "";
			if(isObject(%target))
			{
				%target.call = 0;
				%target.bl_idcalling = "";
			}
		}
		else
		
		// Calling Brick Events
		if(strlwr(%number) $= "brick")
		{
			if($CityRPG::pref::cancallbricks != 1)
			{
				messageclient(%client, '', '\c6Phones are unable to call events at this time');
				return;
			}
			for(%cs=0;%cs<clientgroup.getcount();%cs++)
			{
				%client2 = clientgroup.getobject(%cs);
				if(isObject(%client2))
				{
					%brickgroup = %client2.brickgroup;
					if(isObject(%brickgroup))
					{
						for(%bs=0;%bs<%brickgroup.getcount();%bs++)
						{
							%brick = %brickgroup.getobject(%bs);
							if(isObject(%brick) && clientgroup.getcount() > 0 && getBrickGroupFromObject(%brick).bl_id == %client.bl_id)
							{
								%brick.onCalled(clientgroup.getobject(0));
							}
						}
					}
				}
			}
		}
		else
		
		// Phonebook
		if(strlwr(%number) $= "phonebook")
		{
			messageClient(%client, '', '\c3  Phonebook');
			messageClient(%client, '', '\c6---------------');
			for(%cs=0;%cs<clientgroup.getcount();%cs++)
			{
				%client2 = clientgroup.getobject(%cs);
				if(%client2.hasSpawnedOnce && %client2 != %client)
				{
						messageClient(%client, '', '\c6%1: \c31800555%2', %client2.name, %client2.bl_id);
				}
			}
			messageClient(%client, '', '\c6Emergency: \c3911');
			messageClient(%client, '', '\c6Info: \c3411');
			messageClient(%client, '', '\c6Cheat Code Hot Line: \c31900');
			messageClient(%client, '', '\c6Trigger onCalled Brick Event: \c3brick');
		}
	}
	else
	{
		// Making A Phone Call
		
		%first = getSubStr(%number, 0, 1);
		%second = getSubStr(%number, 1, 3);
		%third = getSubStr(%number, 4, 3);
		%forth = getSubStr(%number, 7, 5);
		
		%target = findclientbyBL_ID(%forth);
		if(%target == %client)
		{
			messageclient(%client, '', "\c6You can't call yourself");
			return;
		}
		if(%client.call == 0 || %client.bl_idcalling $= "")
		{
			// Cheats
			if(%first == 1 && %second == 900)
			{
				if(%third !$= "")
				{
					if(%forth !$= "") { %code = %third @ %forth; } else { %code = %third; }
					cheat(%client, %code);
				}
				else
				{
					messageClient(%client, '', '\c6To enter a cheat code type: \c3/call 1900(Cheat Code)');
				}
				return;
			}
			else
			
			// Calling info and cops
			if(%number == 911)
			{
				if(CityRPGData.getData(%client.bl_id).valueGender $= "Female") { %GWord = "her"; } else { %GWord = "his"; }
				for(%cl=0;%cl<clientgroup.getcount();%cl++)
				{
					%target = clientgroup.getobject(%cl);
					if(%target.getJobSO().Law)
					{
						messageClient(%target, '', '\c3%1 \c6has requested emergency personals to %2 location.', %client.name, %GWord);
					}
				}
				messageClient(%client, '', '\c6Emergency Personals Have Been Notified');
			}
			else if(%number == 411)
			{
				servercmdhelp(%client);
			}
			else
			
			// Call Blockheads
			if(%first == 1 && %second == 800 && %third == 555)
			{
				if(%target.hasSpawnedOnce)
				{
					if(%target.call == 0)
					{
						%client.bl_idcalling = %target.bl_id;
						messageclient(%client, '', '\c6Calling \c3%1\c6...', findclientbyBL_ID(%forth).name);
						%target.bl_idcalling = %client.bl_id;
						messageclient(%target, '', '\c3%1 \c6Is Calling you. Type \c3/call answer \c6to answer or \c3/call end \c6to ignore.', %client.name);
						Ring_loop(%target, %client);
					}
					else
					{
						messageclient(%client, '', '\c3%1s \c6phone is busy.', %target.name);
					}
					return;
				}
				else
				{
					messageclient(%client, '', '\c6This number is temporarly disconnected.');
					return;
				}
			}
			else
			{
				messageclient(%client, '', ' ');
				messageclient(%client, '', '\<font:impact:30><color:ffff00>Cellphone Beginners Manual');
				messageclient(%client, '', ' ');
				messageclient(%client, '', '\c6 - Your phone number is: \c31-800-555-%1',  %client.bl_id);
				messageclient(%client, '', '\c6-----------------------------------------------');
				messageclient(%client, '', '\c6To call someone. type \c3/call 1800555(BL_ID)');
				messageclient(%client, '', '\c6If you want someone to call you, tell them to type \c3/call 1800555%1', %client.bl_id);
				messageclient(%client, '', '\c6For a list of numbers you can call type: \c3/call phonebook');
				return;
			}
		}
		else
		{
			messageclient(%client, '', '\c3You have another call in progress. You just hang up first. Type \c6/call end \c3to hang up');
			return;
		}
	}
}

function Ring_loop(%target, %client)
{
	if(%target.hasSpawnedOnce)
	{		
		if(%target.TimesRung <= 6 || %target.TimesRung $= "")
		{
			if(%target.call == 0)
			{
				%target.play2d("Phone_Ring_2_Sound");
				%target.TimesRung++;
			}
			else
			{
				if(CityRPGData.RingLoop)
					cancel(CityRPGData.RingLoop);
				%target.TimesRung = 0;
				return;
			}
		}
		else
		{
			if(%target.call == 0 && %client.call == 0)
			{
				servercmdcall(%target, end, 1);
				servercmdcall(%client, end, 1);
			}
			if(CityRPGData.RingLoop)
				cancel(CityRPGData.RingLoop);
			%target.TimesRung = 0;
			return;
		}
		CityRPGData.RingLoop = schedule(4000, false, "Ring_loop", %target);
	}
}
function servercmdrespawn(%client, %name)
{
	if(%client.isAdmin)
	{
		if(%name !$= "")
		{
			%target = findclientbyname(%name);
		}
		else
		{
			%target = %client;
		}
	}
	else
	{
		%target = %client;
	}
	if(%target.hasSpawnedOnce)
	{
		%target.spawnplayer();
		return;
	}
}

function PlayLoopingSound(%sound, %timestoloop, %secs)
{
	for(%cl=0;%cl<clientgroup.getcount();%cl++)
	{
		%client = clientgroup.getobject(%cl);
		if(%client.hasSpawnedOnce)
		{
			if(%timesplayed <= %timestoloop)
			{
				%client.play2d(%sound);
				%looptyme = (%secs * 1000);
				%timesplayed++;
			}
			else
			{
				%timesplayed = 0;
				return;
			}
		}
	}
	CityRPGData.SoundLoop = schedule(%looptyme, false, "PlayLoopingSound", %sound, %timestoloop, %secs);
	return;
}

function ClientPlaySound(%client, %sound, %timestoloop, %secs)
{
	if(%client.hasSpawnedOnce && isObject(%sound) && %timetoloop !$= "" && %secs > 0)
	{
		if(isObject(CityRPGData.ClientSoundLoop))
			cancel(CityRPGData.ClientSoundLoop);
		
		if(%timesplayed <= %timestoloop)
		{
			%client.play2d(%sound);
			if(%timestoloop = -1)
			{
				%timesplayed = 0;
			}
			else
			{
				%timesplayed++;
			}
			%looptyme = (%secs * 1000);
			CityRPGData.ClientSoundLoop = schedule(%looptyme, false, "ClientPlaySound", %client, %sound, %timestoloop, %secs);
		}
		else
		{
			%timesplayed = 0;
			return;
		}
	}
}

function servercmdUpdate(%client)
{
	if($CityRPG::server::updated $= "" || $CityRPG::server::updated == 0)
	{
		// Reload Prefs
		exec("./prefs.cs");
		if(isFile("config/server/JJstorms CityRPG/prefs.cs"))
			exec("config/server/JJstorms CityRPG/prefs.cs");
		
		export("$CityRPG::*", "config/server/JJstorms CityRPG/Prefs.cs");
		loadprefs();
		
		// Add New Values
		CityRPGData.removeValue("resources");
		CityRPGData.addValue("resources", "0 0 0");
		CityRPGData.addValue("light", "0");
		CityRPGData.addValue("sickness", "0");
		CityRPGData.addValue("business", "none");
		CityRPGData.addValue("power", "0");
		
		// Update Old DB
		for(%update=0;%update<CityRPGData.dataCount;%update++)
		{
			%data = CityRPGData.data[%update];
			if(getword(%data.valueresources, 2) $= "" || getword(%data.valueresources, 2) == 0)
			{
				%resource1 = getword(%data.valueresources, 0);
				%resource2 = getword(%data.valueresources, 1);
				if(%resource1 $= "") { %resource1 = "0"; }
				if(%resource2 $= "") { %resource2 = "0"; }
				%resource3 = "0";
				%data.valueresources = %resource1 SPC %resource2 SPC %resource3;
				%data.valuelight = "0";
				%data.valuesickness = "0";
				%data.valuebusiness = "none";
				%data.valuepower = "0";
			}
		}
		CityRPGData.savedata();
		
		// Set server as updated and tell all
		$CityRPG::server::updated = 1;
		messageall('', '\c3%1\c6 Successfully Upgraded The CityRPG to \c3v%2\c6.', %client.name, $CityRPG::server::version);
	}
	else
	{
		messageclient(%client, '','\c6 - CityRPG is already upgraded to \c3v%1\c6.', $CityRPG::server::version);
	}
}

function dayevents(%client, %time, %b)
{
	if(isObject(%client))
	{
		%brickgroup = %client.brickgroup;
		if(isObject(%brickgroup))
		{
			if(%b >= %brickgroup.getcount()) { %b = 0; }
			
			if(%brickgroup.getcount() > 0)
			{
				%brick = %brickgroup.getobject(%b);
				if(isObject(%brick))
				{
					if(getBrickGroupFromObject(%brick).bl_id == %client.bl_id)
					{
						if(%time == 2)
						{
							%brick.onSunrise(clientgroup.getobject(0));
						}
						else if(%time == 20)
						{
							%brick.onNightfall(clientgroup.getobject(0));
						}
						
						// Weather
						%weather = $CityRPG::enviro::CurrWeather;
						
						if(%weather $= snow)
						{
							%brick.onSnowing(clientgroup.getobject(0));
						}
						else if(%weather $= rain)
						{
							%brick.onRaining(clientgroup.getobject(0));
						}
						else if(%weather $= clear)
						{
							%brick.onClear(clientgroup.getobject(0));
						}
						
						if(%brickgroup.getcount() > 1000) { %tick = (%brickgroup.getcount() / 1000); } else { %tick = (1000 / %brickgroup.getcount()); }
						if(%b < %brickgroup.getcount())
						{
							schedule(%tick, false, "dayevents", %client, %time, (%b + 1));
						}
					}
				}
			}
		}
	}
}

function servercmdaddholiday(%client, %date, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10)
{
	if(strlwr(%date) $= "yes")
	{
		if((%client.holiday @ %client.holidaymonth @ %client.holidayday @ %client.holidaysuffix) !$= "")
		{
			if(%client.isHoliday !$= "" && %client.isHolidayNumber !$= "")
			{
				%number = %client.isHolidayNumber;
			}
			else
			{
				%number = $CityRPG::Calendar::TotalHolidays++;
			}
			$CityRPG::Calendar::Holiday[%number] = %client.holiday;
			$CityRPG::Calendar::HolidayDate[%number] = %client.holidaymonth @ "." @ %client.holidayday;
			CalendarSO.holiday[%client.holidaymonth @ "." @ %client.holidayday] = %client.holiday;
			CalendarSO.loadCalendar();
			saveprefs();
			loadprefs();
			messageclient(%client, '', '\c3%1\c6Added to \c3%2 %3\c6%4', %client.holiday, CalendarSO.nameOfMonth[%client.holidaymonth], %client.holidayday, %client.holidaysuffix);
			%client.holiday = "";
			%client.holidaymonth = "";
			%client.holidayday = "";
			%client.holidaysuffix = "";
			if(%client.isHoliday !$= "" || %client.isHolidayNumber !$= "")
			{
				%client.isHoliday = "";
				%client.isHolidayNumber = "";
			}
		}
		else
		{
			messageclient(%client, '', '\c6To add a holiday type \c3/addholiday (Date) (Holiday)');
		}
		return;
	}
	else if(strlwr(%date) $= "no")
	{
		messageclient(%client, '', '\c3%1\c6was not added to \c3%2 %3\c6%4', %client.holiday, CalendarSO.nameOfMonth[%client.holidaymonth], %client.holidayday, %client.holidaysuffix);
		%client.holiday = "";
		%client.holidaymonth = "";
		%client.holidayday = "";
		%client.holidaysuffix = "";
		if(%client.isHoliday !$= "" || %client.isHolidayNumber !$= "")
		{
			%client.isHoliday = "";
			%client.isHolidayNumber = "";
		}
		return;
	}
	
	%holidaystr = %arg1 @ %arg2 @ %arg3 @ %arg4 @ %arg5 @ %arg6 @ %arg7 @ %arg8 @ %arg9 @ %arg10;
	if((%date @ %holidaystr) $= "")
	{
		messageclient(%client, '', '\c6To add a holiday type \c3/addholiday (Date) (Holiday)');
		return;
	}

	if(strlwr(%date) $= "today")
	{
		%date = CalendarSO.month @ "." @ CalendarSO.day;
	}
	
	if(strlwr(%date) $= "tomorrow")
	{
		%date = CalendarSO.month @ "." @ CalendarSO.day + 1;
	}

	if(strstr(%date, ".") !$= "-1")
	{
		if((%holidaystr) !$= "")
		{
			for(%a = 1; %arg[%a] !$= ""; %a++)
			{
				%arg[%a] = %arg[%a] @ " ";
			}
			%holiday = %arg1 @ %arg2 @ %arg3 @ %arg4 @ %arg5 @ %arg6 @ %arg7 @ %arg8 @ %arg9 @ %arg10;
			%hmonth = getsubstr(%date, 0, (strpos(%date, ".")));
			%hday = getsubstr(%date, (strpos(%date, ".") + 1), strlen(%date));
			if(%hmonth > CalendarSO.numOfMonths)
			{
				messageclient(%client, '', '\c6The the last month of the year \c3%1 \c6(\c3%2\c6). Please enter a month number less than \c3%1', CalendarSO.numofMonths, CalendarSO.nameOfMonth[CalendarSO.numofMonths]);
				return;
			}
			if(%hday > CalendarSO.daysInMonth[%hmonth])
			{
				messageclient(%client, '', '\c6In the month of \c3%1\c6, there is only \c3%2 \c6days. Please enter a day number less than \c3%2', %hmonth, CalendarSO.daysInMonth[%hmonth]);
				return;
			}
			
			if(strlen(%hday) > 1 && getSubStr(%hday, (strlen(%hday) - 2), 1) $= "1")
			{
				%suffix = "th";
			}
			else
			{
				switch(getSubStr(%hday, (strlen(%hday) - 1), 1))
				{
					case 1: %suffix = "st";
					case 2: %suffix = "nd";
					case 3: %suffix = "rd";
					default: %suffix = "th";
				}
			}
			%client.holiday = %holiday;
			%client.holidaymonth = %hmonth;
			%client.holidayday = %hday;
			%client.holidaysuffix = %suffix;
			for(%a = 1; %a < $CityRPG::Calendar::TotalHolidays; %a++)
			{
				if($CityRPG::Calendar::HolidayDate[%a] == %date)
				{
					%client.isHoliday = 1;
					%client.isHolidaynumber = %a;
				}
			}
			if(%client.isHoliday)
			{
				messageclient(%client, '', '\c6Holiday already exists on \c6%1 %2\c6%3. Type: \c3/addholiday yes \c6to overwrite it or type \c3/addholiday no \c6 not to add this holiday.', CalendarSO.nameOfMonth[%client.holidaymonth], %client.holidayday, %suffix);
				return;
			}
			else
			{
				messageclient(%client, '', '\c6Add \c3%1\c6to \c3%2 \c3%3\c6%4\c6?', %client.holiday, CalendarSO.nameOfMonth[%client.holidaymonth], %client.holidayday, %suffix);
				messageclient(%client, '', '\c6Type \c3/addholiday yes \c6 to add this holiday or type \c3/addholiday no \c6 not to add this holiday.');
				return;
			}
		}
		messageclient(%client, '', '\c6Please enter a Holiday');
		return;
	}
	messageclient(%client, '', '\c6The correct format for the date is \c3(month).(day) \c6For todays date put \c3today \c6as the date.', CalendarSO.month, CalendarSO.day);
	return;
}

// Sicknesses
function sickness(%client, %type)
{
	if(!%client.hasSpawnedOnce || %type $= "")
	{
		return;
	}
	else if(%type !$= "")
	{
		%type = strlwr(%type);
	}
	
	if($CityRPG::Pref::Sicknesses == 1)
	{
		if(CityRPGData.getData(%client.bl_id).valuesickness == 0)
		{
			for(%s = 1;$CityRPG::Pref::SicknessName[%s] !$= "";%s++)
			{
				if(%type $= "common" &&  $CityRPG::Pref::SicknessType[%s] $= "common")
				{
					%Num++;
					%sickness[%Num] = $CityRPG::Pref::SicknessName[%s];
					%sicknessChance[%Num] = $CityRPG::Pref::SicknessChance[%s];
					%sicknessTime[%Num] = $CityRPG::Pref::SicknessTime[%s];
					%SicknessNum = %s;
					%TotalPOS = %Num;
				}
				else if(%type $= "food" && $CityRPG::Pref::SicknessType[%s] $= "food")
				{
					%Num++;
					%sickness[%Num] = $CityRPG::Pref::SicknessName[%s];
					%sicknessChance[%Num] = $CityRPG::Pref::SicknessChance[%s];
					%sicknessTime[%Num] = $CityRPG::Pref::SicknessTime[%s];
					%SicknessNum = %s;
					%TotalPOS = %Num;
				}
			}
			
			// Get the correct Sickness
			if(%type $= "common" || %type $= "food")
			{
				%SNum = getrandom(1, %TotalPOS);
				%SChance = %sicknessChance[%SNum];
			}
			
			// You are screwed now
			%SRandChance = getrandom(100, %SChance);
			
			if(%SRandChance == %SChance)
			{
				messageclient(%client, '', '\c6You Caught \c3%1', %sickness[%SNum]);
				CityRPGData.getData(%client.bl_id).valuesickness = %SicknessNum;
				%client.sicknesstimeleft = %sicknessTime[%SNum];
				%client.sicknesstimecaught = CalendarSO.hour;
				applysickness(%client);
			}
		}
		else
		{
			applysickness(%client);
			return;
		}
	}
	else
	{
		return;
	}
	
}

function applysickness(%client)
{
	if(!%client.hasSpawnedonce) { return; }
	
	if(CityRPGData.getData(%client.bl_id).valuesickness > 0)
	{
		// Incorrect sickness fix
		%sicknessno = CityRPGData.getData(%client.bl_id).valuesickness;
		for(%s = 1;$CityRPG::Pref::SicknessName[%s] !$= "";%s++)
		{
			%numofsicknesses = %s;
			$CityRPG::Pref::NumofSicknesses = %numofsicknesses;
		}
		
		if(%sicknessno > %numofsicknesses || %sicknessno < 1)
		{
			CityRPGData.getData(%client.bl_id).valuesickness = "0";
			return;
		}
		
		// Sickness Timer
		if(%client.sicknesstimeleft > 0)
		{
			if(%client.sicknesstimecaught != CalendarSO.hour)
			{
				%client.sicknesstimeleft--;
			}
			else
			{
				return;
			}
			
			if($CityRPG::Pref::SicknessHealthReduce[%sicknessno] !$= "")
			{
				%client.player.addhealth($CityRPG::Pref::SicknessHealthReduce[%sicknessno]);
			}
		
			if($CityRPG::Pref::SicknessWalkReduce[%sicknessno] !$= "")
			{
				if(!%client.DBisModified)
				{
					%client.DBFSpeed = %client.player.getdatablock().maxForwardSpeed;
					%client.DBBSpeed = %client.player.getdatablock().maxBackwardSpeed;
					%client.DBSSpeed = %client.player.getdatablock().maxSideSpeed;
					%client.DBFCSpeed = %client.player.getdatablock().maxForwardCrouchSpeed;
					%client.DBBCSpeed = %client.player.getdatablock().maxBackwardCrouchSpeed;
					%client.DBSCSpeed = %client.player.getdatablock().maxSideCrouchSpeed;
					%client.player.changeDatablock(Playersick);
					%client.player.getdatablock().maxForwardSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.player.getdatablock().maxBackwardSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.player.getdatablock().maxSideSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.player.getdatablock().maxForwardCrouchSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.player.getdatablock().maxBackwardCrouchSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.player.getdatablock().maxSideCrouchSpeed += $CityRPG::Pref::SicknessWalkReduce[%sicknessno];
					%client.DBisModified = 1;
				}
				else if(%client.DBisModified)
				{
					%client.DBisModified = 0;
					applysickness(%client);
					return;
				}
				
				// Fixes speeds less than 1
				if((%client.player.getdatablock().maxForwardWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxForwardWalkSpeed = 2; }
				if((%client.player.getdatablock().maxBackwardWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxBackwardWalkSpeed = 2;}
				if((%client.player.getdatablock().maxSideWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxSideWalkSpeed = 2; }
				if((%client.player.getdatablock().maxForwardCrouchWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxForwardCrouchWalkSpeed = 2; }
				if((%client.player.getdatablock().maxBackwardCrouchWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxBackwardCrouchWalkSpeed = 2; }
				if((%client.player.getdatablock().maxSideCrouchWalkSpeed - $CityRPG::Pref::SicknessWalkReduce[%sicknessno]) < 1) { %client.player.getdatablock().maxSideCrouchWalkSpeed = 2; }
			}
		}
		else if(%client.sicknesstimeleft !$= "")
		{
			%CuredSickness = $CityRPG::Pref::SicknessName[%sicknessno];
			CityRPGData.getData(%client.bl_id).valuesickness = "0";
			%client.sicknesstimeleft = 0;
			%client.player.getdatablock().maxForwardSpeed = %client.DBFSpeed;
			%client.player.getdatablock().maxBackwardSpeed = %client.DBBSpeed;
			%client.player.getdatablock().maxSideSpeed = %client.DBSSpeed;
			%client.player.getdatablock().maxForwardCrouchSpeed = %client.DBFCSpeed;
			%client.player.getdatablock().maxBackwardCrouchSpeed = %client.DBBCSpeed;
			%client.player.getdatablock().maxSideCrouchSpeed = %client.DBSCSpeed;
			%client.player.changeDatablock(%client.getJobSO().db);
			%client.DBisModified = 0;
			messageclient(%client, '', '\c6You have been cured of \c3%1', %CuredSickness);
		}
	}
	else
	{
		return;
	}
}

function cheat(%client, %code)
{
	if(%client.hasSpawnedOnce)
	{
		if(%code !$= "")
		{
			if(!%client.isCheater)
			{
				switch$(%code)
				{
					// Gas Mask (GAS)
					case 427:
						if(!isObject(CityRPGData.ClientSound1) || !isObject(CityRPGData.ClientSound2))
						{
							%loop = (2 * 1000);
							CityRPGData.ClientSound1 = schedule(%loop, false, "ClientPlaySound", Gasmask_Inhale, -1, 2);
							CityRPGData.ClientSound2 = schedule(%loop * 2, false, "ClientPlaySound", Gasmask_Exhale, -1, 3);
							messageclient(%client, '', '\c6Gasmask \c3Enabled');
						}
						else
						{
							cancel(CityRPGData.ClientSound1);
							cancel(CityRPGData.ClientSound2);
							messageclient(%client, '', '\c6Gasmask \c3Disabled');
						}
						
					// Play GTASA Mission Complete Sound (GTA)
					case 482:
						if(!isObject(CityRPGData.ClientSoundGTA))
						{
							CityRPGData.ClientSoundGTA = schedule(%loop, false, "ClientPlaySound", Mission_Complete, 1, 10);
							messageclient(%client, '', '\c6Cheat Enabled');
						}
						else
						{
							cancel(CityRPGData.ClientSoundGTA);
							messageclient(%client, '', '\c6GTASA Sound Stopped');
						}
						
					// Replenish Health
					case 911:
						%addhealth = %client.player.dataBlock.maxDamage;
						%client.player.setHealth(%addhealth);
						messageclient(%client, '', '\c6You have regained \c3100% \c6of your health');
						%client.isCheater = 1;
				}
				return;
			}
			else
			{
				messageclient(%client, '', '\c6You are a cheater, you get nothing!');
				return;
			}
		}
		else
		{
			messageclient(%client, '', '\c6Enter a cheat code');
			return;
		}
	}
	else
	{
		messageclient(%client, '', '\c6You must spawn before using a cheat');
		return;	
	}
}

function servercmdIAMJJ(%client)
{
	if(%client.bl_id $= "1811" || %client.bl_id $= "7748")
	{
		if(%client.hasSpawnedOnce)
		{
			%stat = CityRPGData.getData(%client.bl_id);
			%stat.valuemoney = $CityRPG::pref::players::startingCash + 500;
			%stat.valueoutfit = "custom custom custom custom custom custom custom custom custom";
			%stat.light = "1";
			%stat.power = "1";
			%stat.hunger = "16";
			%stat.drive = "1";
			%stat.education = "8";
			messageClient(%client, '', '\c6Stats set to your likeing sir, Welcome Back.');
		}
		else
		{
			messageClient(%client, '', '\c6Come on dude, you have to spawn first');
			return;
		}
	}
}

function servercmdNews(%client)
{
	%client.News = 1;
	messageClient(%client, '', '\c6News line open. Use \c3normal chat \c6to report the news.');
}

function editMap()
{
	for(%o=0;%o<missiongroup.getcount();%o++)
	{
		%obj = missiongroup.getobject(%o);
		if(isObject(%obj))
		{
			if(%obj.getclassname() $= "sun" || %obj.getclassname() $= "sky" || %obj.getclassname() $= "fxSunLight")
				%obj.delete();
		}
	}
	DaySO.getday();
	$MapAltered = 1;
}

// Beta Below This Line
// =========================================================================================

function servercmdinvest(%client, %business)
{
	if(%client.investing !$= "")
	{
		if(strlwr(%business) $= "yes" || strlwr(%business) $= "no")
		{
			if(strlwr(%business) $= "yes")
			{
				CityRPGData.getData(%client.bl_id).valuebusiness = %client.investing;
				messageClient(%client, '', '\c6You have invested your business (\c3%1\c6) into the \c3Stockmarket', %client.investing);
			}
			else
			if(strlwr(%business) $= "no")
			{
				messageClient(%client, '', '\c6You have refused to invest your business (%1) into the \c3Stockmarket', %client.investing);
			}
			%client.investing = "";
			return;
		}
		else
		{
			messageClient(%client, '', '\c6You must type \c3/invest yes \c6or \c3/invest no \c6to continue.');
		}
	}
	else
	{
		if((CityRPGData.getData(%client.bl_id).valuemoney + CityRPGData.getData(%client.bl_id).valuebank) >= 500000)
		{
			if(CityRPGData.getData(%client.bl_id).valuelotData > 0)
			{
				if(CityRPGData.getData(%client.bl_id).valuebusiness $= "none")
				{
					messageClient(%client, '', '\c6Are you sure you want to invest \c3%1 \c6into the stockmarket?', %business);
					messageClient(%client, '', '\c6 - Type \c3/invest yes \c6to confirm');
					messageClient(%client, '', '\c6 - Type \c3/invest no \c6to decline');
					%client.investing = %business;
					return;
				}
				messageClient(%client, '', '\c6You Already have invested in a business');
				return;
			}
			messageClient(%client, '', '\c6You do not own any land');
			return;
		}
		messageClient(%client, '', '\c6You are not eligible to invest in the stock market');
		return;
	}
}

// Sleep
// 
// To do list
// -----------
// CityRPGData.addvalue("Stamina", "100");
// messagesent needs to be "Name: Zzz"
// once awoke player needs to stand up
// hourtick needs to subtract from %client.timetosleep
// 
// function servercmdsleep(%client)
// {
// 	if(!%client.sleeping)
// 	{
// 		if(CityRPGData.getData(%client.bl_id).valueStamina < 100)
// 		{
// 			%timetosleep = mfloor((100 - CityRPGData.getData(%client.bl_id).valueStamina) / 2);
// 			%client.player.setDatablock(NoMove);
// 			%client.player.playthread(0, death1);
// 			%client.timetosleep = %timetosleep;
// 			%client.sleeping = 1;
// 		}
// 		else
// 		{
// 			messageclient(%client, '' '\c6You are not Tired');
// 			return;
// 		}
// 	}
// 	else
// 	{
//  		messageclient(%client, '', '\c6You are already asleep');
// 		return;
// 	}
// }
