// ============================================================
// Project				:	CityRPG
// Author				:	Iban, Jookia, And JJstorm
// Description			:	Datablocks
// ============================================================
// Table of Contents
// 1. Handling Script Start
// 2. Lots
// 2.2 Sale Lots
// 3. Data Bricks
// 4. Spawns
// 5. Resources
// 6. Other
// 7. Decals & Audio
// 8. Player Types
// ============================================================

// ============================================================
// Section 1 : Handling Script Start
// ============================================================
$CityRPG::temp::brickError = forceRequiredAddOn("player_no_jet");

if($CityRPG::temp::brickError)
{
	if($CityRPG::temp::brickError == $error::addOn_disabled)
		playerNoJet.uiName = "";
	
	if($CityRPG::temp::brickError == $error::addOn_notFound)
		return;
}

$CityRPG::loadedDatablocks = true;

if(!$CityRPG::loadedDatablocks)
{
	return;
}

datablock triggerData(CityRPGLotTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};

datablock triggerData(CityRPGInputTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};


// ============================================================
// Section 2 : Lots
// ============================================================
datablock fxDTSBrickData(CityRPGSmallLotBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x16LotIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Lots";
	
	uiName = "Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 16 48";
	trigger = 0;
	
	initialPrice = 100;
	taxAmount = 10;
};

datablock fxDTSBrickData(CityRPGHalfSmallLotBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x32LotIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Lots";
	
	uiName = "Half-Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 32 48";
	trigger = 0;
	
	initialPrice = 350;
	taxAmount = 20;
};

datablock fxDTSBrickData(CityRPGMediumLotBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/32x32LotIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Lots";
	
	uiName = "Medium Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "32 32 64";
	trigger = 0;
	
	initialPrice = 500;
	taxAmount = 35;
};

datablock fxDTSBrickData(CityRPGLargeLotBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/64x64LotIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Lots";
	
	uiName = "Large Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "64 64 128";
	trigger = 0;
	
	initialPrice = 700;
	taxAmount = 45;
};

// Sale Lots
datablock fxDTSBrickData(CityRPGSmallZoneBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x16ZoneIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Zones";
	
	uiName = "Small Zone";

	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGHalfSmallZoneBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x32ZoneIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Zones";
	
	uiName = "Half-Small Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGHalfSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGMediumZoneBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/32x32ZoneIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Zones";
	
	uiName = "Medium Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGMediumLotBrickData;
};

datablock fxDTSBrickData(CityRPGLargeZoneBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/64x64ZoneIcon";
	
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Zones";
	
	uiName = "Large Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGLargeLotBrickData;
};

// ============================================================
// Section 3 : Data Bricks
// ============================================================
exec("./bricks/info/bank.cs");
exec("./bricks/info/police.cs");
exec("./bricks/info/bounty.cs");
exec("./bricks/info/labor.cs");
exec("./bricks/info/realestate.cs");
exec("./bricks/info/school.cs");
exec("./bricks/info/employment.cs");

// ============================================================
// Section 4 : Spawns
// ============================================================
datablock fxDtsBrickData(CityRPGPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Spawns";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDtsBrickData(CityRPGJailSpawnBrickData : brickSpawnPointData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Spawns";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

// ============================================================
// Section 5 : Resources
// ============================================================
exec("./bricks/resources/tree.cs");
exec("./bricks/resources/ore.cs");
exec("./bricks/resources/playerore.cs");

// ============================================================
// Section 6 : Other
// ============================================================
datablock fxDTSBrickData(CityRPGPermaSpawnData : brick2x2FData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Admin";
	
	uiName = "Permaspawn Brick";

	CityRPGBrickAdmin = true;
	CityRPGPermaspawn = 1;
};

datablock fxDTSBrickData(CityRPGPoliceVehicleData : brickVehicleSpawnData)
{
	category = "JJstorms CityRPG";
	subCategory = "JJstorms CityRPG Spawns";
	uiName = "Police Vehicle Spawn";
	CityRPGBrickAdmin = true;
};

// ============================================================
// Section 7 : Decals & Audio
// ============================================================
datablock decalData(JJstormsLogo)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/JJstormsCityRPG";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_1)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x16LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_2)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_3)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/32x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_4)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/64x64LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_1)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x16ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_2)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/16x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_3)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/32x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_4)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/64x64ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Ore_Icon)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/BrickIcons/4x Cube";
	preload = true;
};

datablock decalData(HungerIcon)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/hungericon";
	preload = true;
};

datablock decalData(Bricks)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/plastic";
	preload = true;
};

datablock decalData(Person)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/job";
	preload = true;
};

datablock decalData(Money)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/moneyicon";
	preload = true;
};

datablock decalData(MoneyIcon)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/moneyicon";
	preload = true;
};


datablock decalData(MoneyAddIcon)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/moneyaddicon";
	preload = true;
};

datablock decalData(WantStar)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/star";
	preload = true;
};

datablock decalData(Wantstar2)
{
	textureName = "Add-Ons/GameMode_JJstormsCityRPG/shapes/decals/star2";
	preload = true;
};

// Weather/Day Preloads

datablock PrecipitationData(CityRPG_Rain)
{
	dropTexture = "Add-Ons/Client_JJstormsCityRPG/shapes/Skies/droplet";
	splashTexture = "Add-Ons/Client_JJstormsCityRPG/shapes/Skies/splash";
	dropSize = 0.50;
	splashSize = 0.2;
	useTrueBillboards = false;
	splashMS = 250;
};

datablock decalData(CityRPG_Rain_Texture)
{
	textureName = "Add-Ons/Client_JJstormsCityRPG/shapes/Skies/droplet";
	preload = true;
};

datablock decalData(CityRPG_Splash_Texture)
{
	textureName = "Add-Ons/Client_JJstormsCityRPG/shapes/Skies/splash";
	preload = true;
};

datablock AudioDescription(WeatherSound)
{
	volume = 0.9;
	isLooping = false;
	is3D = false;
	type = $DefaultAudioType;
};

datablock AudioProfile(RainSound)
{
	filename = "Add-Ons/Client_JJstormsCityRPG/sounds/RainSound.wav";
	description = "WeatherSound";
	preload = true;
};

datablock AudioProfile(SnowSound)
{
	filename = "Add-Ons/Client_JJstormsCityRPG/sounds/SnowSound.wav";
	description = "WeatherSound";
	preload = true;
};

datablock AudioProfile(Gasmask_Inhale)
{
	filename = "Add-Ons/Client_JJstormsCityRPG/sounds/gasmask_inhale.wav";
	description = "WeatherSound";
	preload = true;
};

datablock AudioProfile(Gasmask_Exhale)
{
	filename = "Add-Ons/Client_JJstormsCityRPG/sounds/gasmask_exhale.wav";
	description = "WeatherSound";
	preload = true;
};

datablock AudioProfile(Mission_Complete)
{
	filename = "Add-Ons/Client_JJstormsCityRPG/sounds/mission_complete.wav";
	description = "WeatherSound";
	preload = true;
};
// ============================================================
// Section 8 : Player Types
// ============================================================

// Admin Job DB
datablock PlayerData(AdminPlayer : PlayerStandardArmor)
{
   minJetEnergy = 0;
   jetEnergyDrain = 0;
   canJet = 1;

   uiName = "Standard Player 9 Slots";
   showEnergyBar = false;
   maxTools = 9;
   maxWeapons = 9;
};

// Sprinting Player
datablock PlayerData(PlayerSprint : PlayerStandardArmor)
{
	rechargeRate = 0.75;

	runForce = 4320;
	runEnergyDrain = 0.5;
	maxForwardSpeed = "7";
	maxBackwardSpeed = "6";
	maxSideSpeed = "4";

	maxForwardCrouchSpeed = "3";
	maxBackwardCrouchSpeed = "2";
	maxSideCrouchSpeed = "2";

	airControl = 0.1;
	jumpForce = 1080;

	canJet = 0;

	uiName = "Sprinting Player";

	canRide = 1;
	showEnergyBar = 1;
};
datablock PlayerData(PlayerSprintActive : PlayerSprint)
{
	runEnergyDrain = 2.75;
	minRunEnergy = 1;
	maxForwardSpeed = "18";
	maxBackwardSpeed = "18";
	maxSideSpeed = "18";

	maxForwardCrouchSpeed = "9";
	maxBackwardCrouchSpeed = "9";
	maxSideCrouchSpeed = "9";

	airControl = 0;

	uiName = "";

	canRide = 0;
};

package SprintPlayer
{
	function Armor::onTrigger(%data,%player,%slot,%io)
	{
		if(%slot == 4)
		{
			if(%io && %data.getName() $= "PlayerSprint")
			{
				%player.changeDatablock(PlayerSprintActive);
				%tool = %player.currTool;
				servercmdunusetool(%player.client);
				%player.currTool = %tool;
			} else if(!%io && %data.getName() $= "PlayerSprintActive")
			{
				%player.changeDatablock(PlayerSprint);
				servercmduseTool(%player.client,%player.currTool);
			}
		}
		Parent::onTrigger(%data,%player,%slot,%io);
	}
	function Player::mountImage(%player,%image,%slot)
	{
		if(%player.getDatablock().getName() $= "PlayerSprintActive" && %slot == 0)
		{
			return;
		}
		Parent::mountImage(%player,%image,%slot);
	}
	function ServerCmdUseTool(%client,%slot)
	{
		if(isObject(%player = %client.player))
		{
			if(%player.getDatablock().getName() $= "PlayerSprintActive")
			{
				%player.currTool = %slot;
				return;
			}
		}
		Parent::serverCmdUseTool(%client,%slot);
	}
};
activatePackage(SprintPlayer);

// Sickness Player Type

datablock PlayerData(PlayerSick : PlayerSprint)
{
	runForce = 4320;
	runEnergyDrain = 0.5;
	maxForwardSpeed = "7";
	maxBackwardSpeed = "6";
	maxSideSpeed = "4";

	maxForwardCrouchSpeed = "3";
	maxBackwardCrouchSpeed = "2";
	maxSideCrouchSpeed = "2";

	airControl = 0.1;
	jumpForce = 1080;

	canJet = 0;

	maxForwardSpeed = "18";
	maxBackwardSpeed = "18";
	maxSideSpeed = "18";
	
	maxForwardCrouchSpeed = "9";
	maxBackwardCrouchSpeed = "9";
	maxSideCrouchSpeed = "9";
	
	airControl = 0;
	
	uiName = "";
	
	canRide = 0;
};

// No moving player
datablock PlayerData(NoMove : PlayerStandardArmor)
{
	maxForwardSpeed = "0";
	maxBackwardSpeed = "0";
	maxSideSpeed = "0";

	maxForwardCrouchSpeed = "0";
	maxBackwardCrouchSpeed = "0";
	maxSideCrouchSpeed = "0";

	airControl = 0;
	jumpForce = 0;

	canJet = 0;

	uiName = "NoMove";

	canRide = 0;
	showEnergyBar = 0;
};
