// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Trader & Jookia & JJstorm
// Description			:	Code that overwrites main functions of Blockland.
// ============================================================
// Table of Contents
// 1. Brick Packages
// 2. Client Packages
// 3. Player Packages
// 4. Misc. Packages
// 5. Chat Packages/Functions
// 6. Banned Events
// 8. Test Packages
// ============================================================

package CityRPG_MainPackage
{
	// ============================================================
	// Section 1 : Brick Packages
	// ============================================================
	function fxDTSBrick::onActivate(%brick, %obj, %client, %pos, %dir)
	{
		parent::onActivate(%brick, %obj, %client, %pos, %dir);
		
		if(isObject(%brick.getDatablock().CityRPGMatchingLot))
		{
			if(!isObject(%client.player.serviceOrigin))
			{
				%client.player.serviceType = "zone";
				%client.player.serviceOrigin = %brick;
				%client.player.serviceFee = %brick.getDatablock().CityRPGMatchingLot.initialPrice;
				messageClient(%client, '', '\c6It costs \c3%1\c6 to build in this zone. Type \c3/yes\c6 to accept and \c3/no\c6 to decline', %client.player.serviceFee);
			}
			else if(isObject(%client.player.serviceOrigin) && %client.player.serviceOrigin != %brick)
				messageClient(%client, '', "\c6You already have an active transfer. Type \c3/no\c6 to decline it.");
		}	
	}
	
	function fxDTSBrick::onDeath(%brick)
	{
		switch(%brick.getDatablock().CityRPGBrickType)
		{
			case 1:
				%brick.handleCityRPGBrickDelete();
			case 2:
				%brick.handleCityRPGBrickDelete();
			case 3:
				if(getWord($CityRPG::temp::spawnPoints, 0) == %brick)
					$CityRPG::temp::spawnPoints = strReplace($CityRPG::temp::spawnPoints, %brick @ " ", "");
				else
					$CityRPG::temp::spawnPoints = strReplace($CityRPG::temp::spawnPoints, " " @ %brick, "");
		}
		
		parent::onDeath(%brick);
	}
	
	function fxDTSBrick::onPlant(%brick)
	{		
		Parent::onPlant(%brick);
	
		if(isObject(%brick))
		{
			if(%brick == $LastLoadedBrick)
			{
				switch(%brick.getDatablock().CityRPGBrickType)
				{
					case 1:
						%brick.schedule(1, "handleCityRPGBrickCreation");
					case 2:
						%brick.schedule(1, "handleCityRPGBrickCreation");
					case 3:
						$CityRPG::temp::spawnPoints = ($CityRPG::temp::spawnPoints $= "") ? %brick : $CityRPG::temp::spawnPoints SPC %brick;
					case 4:
						%brick.resources = %brick.getDatablock().resources;
				}
			}
			else
			{
				if(isObject(%client = %brick.getGroup().client))
				{
					if(mFloor(getWord(%brick.rotation, 3)) == 90)
					{
						%boxSize = getWord(%brick.getDatablock().brickSizeY, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeX, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
					}
					else
					{
						%boxSize = getWord(%brick.getDatablock().brickSizeX, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeY, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
					}
					
					initContainerBoxSearch(%brick.getWorldBoxCenter(), %boxSize, $typeMasks::triggerObjectType);
					
					while(isObject(%trigger = containerSearchNext()))
					{
						if(%trigger.getDatablock() == CityRPGLotTriggerData.getID())
						{
							%lotTrigger = %trigger;
							break;
						}
					}
					
					if(%lotTrigger && %brick.getDatablock().CityRPGBrickType != 1)
					{
						%lotTriggerMinX = getWord(%lotTrigger.getWorldBox(), 0);
						%lotTriggerMinY = getWord(%lotTrigger.getWorldBox(), 1);
						%lotTriggerMinZ = getWord(%lotTrigger.getWorldBox(), 2);
						
						%lotTriggerMaxX = getWord(%lotTrigger.getWorldBox(), 3);
						%lotTriggerMaxY = getWord(%lotTrigger.getWorldBox(), 4);
						%lotTriggerMaxZ = getWord(%lotTrigger.getWorldBox(), 5);
						
						%brickMinX = getWord(%brick.getWorldBox(), 0) + 0.0016;
						%brickMinY = getWord(%brick.getWorldBox(), 1) + 0.0013;
						%brickMinZ = getWord(%brick.getWorldBox(), 2) + 0.00126;
						
						%brickMaxX = getWord(%brick.getWorldBox(), 3) - 0.0016;
						%brickMaxY = getWord(%brick.getWorldBox(), 4) - 0.0013;
						%brickMaxZ = getWord(%brick.getWorldBox(), 5) - 0.00126;
						
						
						if(%brickMinX >= %lotTriggerMinX && %brickMinY >= %lotTriggerMinY && %brickMinZ >= %lotTriggerMinZ)
						{
							if(%brickMaxX <= %lotTriggerMaxX && %brickMaxY <= %lotTriggerMaxY && %brickMaxZ <= %lotTriggerMaxZ)
							{
								if(%brick.getDatablock().CityRPGBrickAdmin &&!%client.isAdmin)
								{
									commandToClient(%client, 'centerPrint', "You must be an admin to plant this brick.", 3);
									%brick.schedule(0, "delete");
								}
								else
								{
									switch(%brick.getDatablock().CityRPGBrickType)
									{
										case 2:
											%brick.schedule(0, "handleCityRPGBrickCreation");
										case 3:
											$CityRPG::temp::spawnPoints = ($CityRPG::temp::spawnPoints $= "") ? %brick : $CityRPG::temp::spawnPoints SPC %brick;
										case 4:
											if(%brick.getDatablock().resources)
												%brick.resources = %brick.getDatablock().resources;
										default:
											if(!%brick.brickGroup.client.isAdmin && %brick.getDatablock().getID() == brickVehicleSpawnData.getID())
											{
												if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor($CityRPG::prices::vehicleSpawn))
												{
													commandToClient(%client, 'centerPrint', "\c6You have paid \c3$" @ mFloor($CityRPG::prices::vehicleSpawn) @ "\c6 to plant this vehicle spawn.", 3);
													CityRPGData.getData(%client.bl_id).valueMoney -= mFloor($CityRPG::prices::vehicleSpawn);
													%client.setInfo();
												}
												else
												{
													commandToClient(%client, 'centerPrint', "\c6You need at least \c3$" @ mFloor($CityRPG::prices::vehicleSpawn) SPC "\c6in order to plant this vehicle spawn!", 3);
													%brick.schedule(0, "delete");
												}
											}
											else
											// Regular Bricks
											if(mFloor($CityRPG::prices::BrickCost) > 0)
											{
												if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) >= mFloor($CityRPG::prices::BrickCost))
												{
													CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) - mFloor($CityRPG::prices::BrickCost);
													%client.setInfo();
												}
												else
												{
													commandToClient(%client, 'centerPrint', "\c6You need at least \c3" @ mFloor($CityRPG::prices::BrickCost) SPC "Plastic \c6in order to plant this brick!", 3);
													%brick.schedule(0, "delete");
												}
											}
									}
								}
							}
							else
								%brick.schedule(0, "delete");
						}
						else
							%brick.schedule(0, "delete");
					}
					else if(%lotTrigger && %brick.getDatablock().CityRPGBrickType == 1)
					{
						commandToClient(%client, 'centerPrint', "\c6You cant put a lot on top of another lot. Try a Baselate", 3);
						%brick.schedule(0, "delete");
					}
					else if(!%lotTrigger && %brick.getDatablock().CityRPGBrickType == 1)
					{
						if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor(%brick.getDatablock().initialPrice))
						{
							if(%client.brickGroup.lotsOwned < $CityRPG::pref::realestate::maxLots)
							{
								messageClient(%client, '', "\c6You have paid \c3$" @ mFloor(%brick.getDatablock().initialPrice) @ "\c6 to plant this lot.");
								CityRPGData.getData(%client.bl_id).valueMoney -= mFloor(%brick.getDatablock().initialPrice);
								%brick.schedule(0, "handleCityRPGBrickCreation");
							}
							else
							{
								commandToClient(%client, 'centerPrint', "You already own the maximum number of lots.", 3);
								%brick.schedule(0, "delete");
							}
						}
						else
						{
							commandToClient(%client, 'centerPrint', "\c6You need at least \c3$" @ mFloor(%brick.getDatablock().initialPrice) SPC "\c6in order to plant this lot!", 3);
							%brick.schedule(0, "delete");
						}
					}
					else if(!%lotTrigger)
					{
						if(!%client.isAdmin)
						{
							commandToClient(%client, 'centerPrint', "You cannot plant a brick outside of a lot.\n\c6Use a lot brick to start your build!", 3);
							%brick.schedule(0, "delete");
						}
						else
						{
							if(%brick.getDatablock().CityRPGBrickAdmin &&!%client.isAdmin)
							{
								commandToClient(%client, 'centerPrint', "You must be an admin to plant this brick.", 3);
								%brick.schedule(0, "delete");
							}
							else
							{
								switch(%brick.getDatablock().CityRPGBrickType)
								{
									case 2:
										%brick.schedule(0, "handleCityRPGBrickCreation");
									case 3:
										$CityRPG::temp::spawnPoints = ($CityRPG::temp::spawnPoints $= "") ? %brick : $CityRPG::temp::spawnPoints SPC %brick;
									case 4:
										if(%brick.getDatablock().resources)
										{
											%brick.resources = %brick.getDatablock().resources;
										}
									default:
										if(%brick.getDatablock().getID() == brickVehicleSpawnData.getID())
										{
											if(CityRPGData.getData(%client.bl_id).valueMoney >= mFloor($CityRPG::prices::vehicleSpawn))
											{
												commandToClient(%client, 'centerPrint', "\c6You have paid \c3$" @ mFloor($CityRPG::prices::vehicleSpawn) @ "\c6 to plant this vehicle spawn.", 3);
												CityRPGData.getData(%client.bl_id).valueMoney -= mFloor($CityRPG::prices::vehicleSpawn);
											}
											else
											{
												commandToClient(%client, 'centerPrint', "\c6You need at least \c3$" @ mFloor($CityRPG::prices::vehicleSpawn) SPC "\c6in order to plant this vehicle spawn!", 3);
												%brick.schedule(0, "delete");
											}
										}
										else
										// Regular Bricks
										if(mFloor($CityRPG::prices::BrickCost) > 0)
										{
											if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) >= mFloor($CityRPG::prices::BrickCost))
											{
												CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 2) - mFloor($CityRPG::prices::BrickCost);
												%client.setInfo();
											}
											else
											{
												commandToClient(%client, 'centerPrint', "\c6You need at least \c3" @ mFloor($CityRPG::prices::BrickCost) SPC "Plastic \c6in order to plant this brick!", 3);
												%brick.schedule(0, "delete");
											}
										}
								}
							}
						}
					}
					else
						messageAll('', "fxDTSBrick::onPlant() - Brick fell through tests!");
				}
				else
				{
					switch(%brick.getDatablock().CityRPGBrickType)
					{
						case 1:
							%brick.schedule(0, "delete");
						case 2:
							%brick.schedule(0, "handleCityRPGBrickCreation");
						case 3:
							$CityRPG::temp::spawnPoints = ($CityRPG::temp::spawnPoints $= "") ? %brick : $CityRPG::temp::spawnPoints SPC %brick;
						case 4:
							%brick.resources = %brick.getDatablock().resources;
					}
				}
			}
		}
	}
	
	function fxDTSBrick::onRemove(%brick)
	{
		switch(%brick.getDatablock().CityRPGBrickType)
		{
			case 1:
				%brick.handleCityRPGBrickDelete();
			case 2:
				%brick.handleCityRPGBrickDelete();
			case 3:
				if(getWord($CityRPG::temp::spawnPoints, 0) == %brick)
					$CityRPG::temp::spawnPoints = strReplace($CityRPG::temp::spawnPoints, %brick @ " ", "");
				else
					$CityRPG::temp::spawnPoints = strReplace($CityRPG::temp::spawnPoints, " " @ %brick, "");
		}
		
		parent::onRemove(%brick);
	}
	
	function fxDTSBrick::setVehicle(%brick, %vehicle)
	{
		if(%brick.getDatablock().getName() !$= "CityRPGPoliceVehicleData")
		{
			if(!isObject(%brick.getGroup().client) || !%brick.getGroup().client.isAdmin)
			{
				if(isObject(%vehicle))
				{
					for(%a = 0; $CityRPG::vehicles::banned[%a] !$= "" && !%hasBeenBanned; %a++)
					{
						if(%vehicle.getName() $= $CityRPG::vehicles::banned[%a])
						{
							if(isObject(%brick.getGroup().client))
							{
								messageClient(%brick.getGroup().client, '', "\c6Standard users may not spawn a\c3" SPC %vehicle.uiName @ "\c6.");
							}
							%vehicle = 0;
							%hasBeenBanned = true;
						}
					}
				}
			}
		}
		
		parent::setVehicle(%brick, %vehicle);
	}
	
	function fxDTSBrick::setItem(%brick, %datablock, %client)
	{
		if(!%brick.getDatablock().CityRPGPermaspawn && %brick != $LastLoadedBrick)
		{
			if(!isObject(%brick.item) || %brick.item.getDatablock() != %datablock)
			{
				%ownerBG = getBrickGroupFromObject(%brick);
				
				if(%ownerBG.client.isAdmin)
					parent::setItem(%brick, %datablock, %client);
			}
			else
				parent::setItem(%brick, %datablock, %client);
		}
		else
			parent::setItem(%brick, %datablock, %client);
	}
	
	function fxDTSBrick::setMusic(%brick, %song)
	{
		if(%brick.getGroup().client.isAdmin || %brick == $LastLoadedBrick)
			parent::setMusic(%brick, %song);
		else
			parent::setMusic(%brick, 0);
	}
	
	function fxDTSBrick::spawnItem(%brick, %pos, %datablock, %client)
	{
		if(isObject(%owner = getBrickGroupFromObject(%brick).client) && %owner.isAdmin)
			parent::spawnItem(%brick, %pos, %datablock, %client);
	}
	
	function fxDTSBrick::respawnVehicle(%brick, %client)
	{
		if(%brick.getDatablock().getName() $= "CityRPGPoliceVehicleData")
		{
			%stars = CityRPG_GetMaxStars();
			if(%stars == 6)
				%brick.setVehicle(tankVehicle);
			else if(%stars >= 3)
				%brick.setVehicle(blockoCarVehicle);
			else
				%brick.setVehicle(horseArmor);
		}
			
		parent::respawnVehicle(%brick, %client);
	}
	
	// ============================================================
	// Section 2 : Client Packages
	// ============================================================	
	function gameConnection::autoAdminCheck(%client)
	{
		commandtoclient(%client, 'JJRPVersion');
		if($CityRPG::client::RequireClient == 1) { messageclient(%client, '', '\c6 - You need <a:jjstorm.net/?act=vt76&page=1&pid=302#act=vt76&page=1&pid=302>JJstorms CityRPG Client</a> \c6to spawn and play in this server'); }
		
		// Alter Map
		if($MapAltered != 1)
		{
			editMap();
		}
		return parent::autoAdminCheck(%client);
	}
	
	function gameConnection::onClientEnterGame(%client)
	{
		if(!isObject(CityRPGData.getData(%client.bl_id)))
		{
			CityRPGData.addData(%client.bl_id);
		}
		
		if($CityRPG::client::RequireClient == 1)
		{
			%client.checkversions();
		}
		
		parent::onClientEnterGame(%client);
		
		if(isObject(CityRPGMini))
			CityRPGMini.addMember(%client);
		else
			CityRPG_BuildMinigame();
		
		if(CityRPGData.getData(%client.bl_id).valueGender $= "ambig")
		{
			messageClient(%client, '', "\c6You have been set as a male by default. Type \c3/sexChange\c6 to be known as female.");
			CityRPGData.getData(%client.bl_id).valueGender = "Male";
		}
		
		%client.gender = CityRPGData.getData(%client.bl_id).valueGender;
		
		centerPrint(%client, "<bitmap:" @ JJstormsLogo.textureName @ ">", 8);
		
		%hday = $CityRPG::pref::holiday;
		
		commandtoclient(%client, 'spawnlogo', %hday);
		
		%client.doIPKTest();
	}
	
	function gameConnection::onClientLeaveGame(%client)
	{
		if(isObject(%client.player) && !getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		{
			for(%a = 0; %a < %client.player.getDatablock().maxTools; %a++)
			{
				%tool = %client.player.tool[%a];
				
				if(isObject(%tool))
				{
					%tool = %tool.getName();
					%tools = (%tools !$= "" ? %tools SPC %tool : %tool);
				}
			}
			
			if(%tools !$= "")
				CityRPGData.getData(%client.bl_id).valueTools = %tools;
			else
				error("No Tool String!");
		}
		
		parent::onClientLeaveGame(%client);
	}
	
	function gameConnection::spawnPlayer(%client)
	{
		parent::spawnPlayer(%client);
		if(%client.moneyOnSuicide > 0)
		{
			CityRPGData.getData(%client.bl_id).valueMoney = %client.moneyOnSuicide;
		}
		
		if(CityRPGData.getData(%client.bl_id).valueoutfit !$= "custom custom custom custom custom custom custom custom custom" || getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0 || %client.getJobSO().outfit !$= "")
		{
			%client.applyForcedBodyColors();
			%client.applyForcedBodyParts();
		}
		
		applysickness(%client);
		%client.hasBeenDead = 0;
		%client.moneyOnSuicide = 0;
		
		%client.player.setScale("1 1 1");
		%client.player.setDatablock(%client.getJobSO().db);
		%client.player.giveDefaultEquipment();
		
		%client.hasLights = 0;
		%client.LightsAreOn = 0;
		
		%client.SetInfo();
	}
	
	function gameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %unknownA)
	{
		if(!getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		{
			if(%client.player.currTool)
				serverCmddropTool(%client, %client.player.currTool);
		}
		
		if(isObject(%client.CityRPGTrigger))
			%client.CityRPGTrigger.getDatablock().onLeaveTrigger(%client.CityRPGTrigger, %client.player);
		
		if(isObject(%killer) && %killer != %client)
		{
			if(CityRPGData.getData(%client.bl_id).valueBounty > 0)
			{
				if(!%killer.getJobSO().bountyClaim)
				{
					commandToClient(%killer, 'centerPrint', "\c6You have committed a crime: [\c3Claiming a Hit\c6]", 1);
					CityRPG_AddDemerits(%killer.bl_id, $CityRPG::demerits::bountyClaiming);
				}
				
				messageClient(%killer, '', "\c6Hit was completed successfully. The money has been wired to your bank account.");
				CityRPGData.getData(%killer.bl_id).valueBank += CityRPGData.getData(%client.bl_id).valueBounty;
				CityRPGData.getData(%client.bl_id).valueBounty = 0;
			}
			else if(CityRPG_illegalAttackTest(%killer, %client))
			{
				if(%killer.lastKill + 15 >= $sim::time)
				{
					commandToClient(%killer, 'centerPrint', "\c6You have committed a crime: [\c3Killing Spree\c6]", 1);
					CityRPG_AddDemerits(%killer.bl_id, ($CityRPG::demerits::murder * 1.5));
				}
				else
				{
					commandToClient(%killer, 'centerPrint', "\c6You have committed a crime: [\c3Murder\c6]", 1);
					CityRPG_AddDemerits(%killer.bl_id, $CityRPG::demerits::murder);
				}
				%killer.lastKill = $sim::time;
			}
		}
		
		CityRPGData.getData(%client.bl_id).valueTools = "";
		parent::onDeath(%client, %player, %killer, %damageType, %unknownA);
	}
	
	function gameConnection::setScore(%client, %score)
	{
		%score = CityRPGData.getData(%client.bl_id).valueMoney + CityRPGData.getData(%client.bl_id).valueBank;
		parent::setScore(%client, %score);
	}
	
	// =============================================================
	// Section 3 : Player Packages
	// ============================================================	
	function player::mountImage(%this, %datablock, %slot)
	{		
		if(!getWord(CityRPGData.getData(%this.client.bl_id).valueJailData, 1) || $CityRPG::demerits::jail::image[%datablock.getName()])
			parent::mountImage(%this, %datablock, %slot);
		else
			%this.playthread(2, root);
	}
	
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
		if(%this.kevlar && getword(%pos, 2) <= getword(%this.getWorldBoxCenter(), 2) - 3.3)
			%damage /= 2;
		
		if(isObject(%obj.client) && isObject(%this.client) && isObject(%this))
		{
			if(%obj.getDatablock().getName() $= "deathVehicle")
				return;
			
			if(%this.getDamageLevel() < %this.getDatablock().maxDamage)
			{
				%atkr = %obj.client;
				%vctm = %this.client;
				%atkrSO = CityRPGData.getData(%atkr.bl_id);
				%vctmSO = CityRPGData.getData(%vctm.bl_id);
				
				if(!getWord(%atkr.valueJailData, 1))
				{
					if(CityRPG_illegalAttackTest(%atkr, %vctm))
					{
						commandToClient(%atkr, 'centerPrint', "\c6You have committed a crime: [\c3Assault\c6]", 1);
						
						if(!%atkr.getWantedLevel())
							%demerits = $CityRPG::pref::demerits::wantedLevel - %atkr.valueDemerits;
						else
							%demerits = mFloor($CityRPG::demerits::murder * (%damage / %this.getDatablock().maxDamage));
						
						CityRPG_AddDemerits(%atkr.bl_id, %demerits);
					}
				}
				else
					return;
			}
		}
		
		parent::damage(%this, %obj, %pos, %damage, %damageType);
	}
	
	function player::setScale(%this, %scale, %client)
	{
		if(isObject(%this.client))
		{
			if(CityRPGData.getData(%this.client.bl_id).valueHunger > 6)
				%scale = "1.125 1.125 1";
			else if(CityRPGData.getData(%this.client.bl_id).valueHunger == 1)
				%scale = "0.75 0.75 1";
			else
				%scale = "1 1 1";
		}
		
		parent::setScale(%this, %scale);
	}
	
	function player::setShapeNameColor(%this, %color)
	{
		if(isObject(%client = %this.client) && isObject(%client.player) && %this.getState() !$= "dead")
		{
			if(%client.getWantedLevel())
				%color = "1 0 0 1";
			else if(CityRPGData.getData(%client.bl_id).valueReincarnated)
				%color = "1 1 0 1";
			else
				%color = "1 1 1 1";
		}
		
		parent::setShapeNameColor(%this, %color);
	}
	
	function player::setShapeNameDistance(%this, %dist)
	{
		%dist = 24;
		
		if(isObject(%client = %this.client) && isObject(%client.player))
		{
			if(%client.getWantedLevel())
				%dist *= %client.getWantedLevel();
		}
		
		parent::setShapeNameDistance(%this, %dist);
	}
	
	// ============================================================
	// Section 4 : Misc Packages
	// ============================================================
	// Namespace Overrides
	function Armor::damage(%this, %obj, %src, %unk, %dmg, %type)
	{
		if(isObject(%obj.client.minigame) && %type == $DamageType::Vehicle)
		{
			if(%obj.client.minigame.vehicleRunOverDamage)
				parent::damage(%this, %obj, %src, %unk, %dmg, %type);
		}
		else
			parent::damage(%this, %obj, %src, %unk, %dmg, %type);
	}
	
	function Armor::onMount(%this, %obj, %veh, %slot)
	{
		parent::onMount(%this, %obj, %veh, %slot);
		
		if(isObject(keyItem))
		{
			if(%obj.client.brickGroup == %veh.brickGroup)
			{
				for(%a = 0; %a < %this.maxTools; %a++)
				{
					if(!isObject(%obj.tool[%a]) && %freeSlot $= "")
						%freeSlot = %a;
					else if(%obj.tool[%a] == nameToID(keyItem))
						%hasAKey = true;
				}
				
				if(!%hasAKey && %freeSlot !$= "")
				{
					%obj.tool[%freeSlot] = nameToID(keyItem);
					messageClient(%obj.client, 'MsgItemPickup', "", %freeSlot, nameToID(keyItem));
					schedule(50, '', "serverCmdUnUseTool", %obj.client);
				}
			}
		}
	}
	
	function WheeledVehicle::onActivate(%this, %obj, %client, %pos, %dir)
	{
		if(!%this.locked && getTrustLevel(%obj.client.brickGroup, %this.spawnBrick.getGroup()) > 0)
			parent::onActivate(%this, %obj, %client, %pos, %dir);
	}
	
	function WheeledVehicleData::onCollision(%this, %obj, %col, %pos, %vel)
	{
		if(%obj.locked && %col.getType() & $TypeMasks::PlayerObjectType && isObject(%col.client))
			commandToClient(%col.client, 'centerPrint', "\c6The vehicle is locked.", 3);
		else if(isObject(%obj.spawnBrick) && %obj.spawnBrick.getDatablock().getName() $= "CityRPGPoliceVehicleData" && isObject(%col.client) && !%col.client.getJobSO().law)
			commandToClient(%col.client, 'centerPrint', "\c6This vehicle is property of the Police Deparment.", 3);
		else
			parent::onCollision(%this, %obj, %col, %pos, %vel);
	}
	// Drivers License
	function WheeledVehicleData::onCollision(%this, %obj, %col, %pos, %vel)
	{
		if(%obj.locked && %col.getType() & $TypeMasks::PlayerObjectType && isObject(%col.client))
		{
			commandToClient(%col.client, 'centerPrint', "\c6The vehicle is locked.", 3);
		}
		else if(isObject(%obj.spawnBrick) && %obj.spawnBrick.getDatablock().getName() $= "CityRPGPoliceVehicleData" && isObject(%col.client) && !%col.client.getJobSO().law)
		{
			commandToClient(%col.client, 'centerPrint', "\c6This vehicle is property of the Police Deparment.", 3);
		}
		else if(CityRPGData.getData(%col.client.bl_id).valuedrive != 1)
		{
			commandToClient(%col.client, 'centerPrint', "\c6You don't own a \c3driver license\c6. You can buy one Police Department", 3);
		}
		else
		{
			parent::onCollision(%this, %obj, %col, %pos, %vel);
		}
	}
	
	function itemData::onPickup(%this, %item, %obj)
	{
		parent::onPickup(%this, %item, %obj);
		
		if(isObject(%item.spawnBrick))
		{
			if(!%item.spawnBrick.getDatablock().CityRPGPermaspawn)
				%item.spawnBrick.setItem(0, ((isObject(getBrickGroupFromObject(%item.spawnBrick).client)) ? getBrickGroupFromObject(%item.spawnBrick).client : 0), true);
		}
	}
	
	function HammerImage::onHitObject(%this, %obj, %slot, %col, %pos, %normal)
	{
		if(%col.getClassName() $= "Player" && isObject(%col.client) && !%col.client.getWantedLevel())
			commandToClient(%obj.client, 'messageBoxOK', "Hey there!", "You should learn to play the RPG instead of running around hitting people upside the head with a hammer. You will enjoy yourself a lot more that way.\n\n(You have caused no damage to the person you were attacking)");
		else
			parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal);
	}
	
	function KeyProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(%col.getDatablock().getClassName() $= "WheeledVehicleData" && mFloor(VectorLen(%col.getvelocity())) == 0)
		{
			if(getTrustLevel(%col.brickGroup, %obj.client.brickGroup) > 0)
			{
				%col.locked = !%col.locked;
				commandToClient(%obj.client, 'centerPrint', "\c6The vehicle is now \c3" @ (%col.locked ? "locked" : "unlocked") @ "\c6.", 3);
			}
			else
				commandToClient(%obj.client, 'centerPrint', "\c6The key does not fit.", 3);
		}
	}
	
	function MinigameSO::pickSpawnPoint(%mini, %client)
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0 && CityRPG_FindSpawn("jailSpawn"))
			%spawn = CityRPG_FindSpawn("jailSpawn");
		else
		{
			if(CityRPG_FindSpawn("personalSpawn", %client.bl_id))
				%spawn = CityRPG_FindSpawn("personalSpawn", %client.bl_id);
			else
			{
				if(CityRPG_FindSpawn("jobSpawn", CityRPGData.getData(%client.bl_id).valueJobID) && CityRPGData.getData(%client.bl_id).valueJobID != 1)
					%spawn = CityRPG_FindSpawn("jobSpawn", CityRPGData.getData(%client.bl_id).valueJobID);
				else
					%spawn = CityRPG_FindSpawn("jobSpawn", 1);
			}
		}
		
		if(%spawn)
			return %spawn;
		else
			parent::pickSpawnPoint(%mini, %client);
	}
	
	// Namespaceless Overrides
	function disconnect(%bool)
	{
		// Prevents ticks from occuring post-mission end.
		if(!$Server::Dedicated && CityRPGData.scheduleTick)
			cancel(CityRPGData.scheduleTick);
		
		parent::disconnect(%bool);
	}
	
	// Always-in-Minigame Overrides
	function miniGameCanDamage(%obj1, %obj2)
	{
		return 1;
	}
	
	function miniGameCanUse(%obj1, %obj2)
	{
		return 1;
	}
	
	function getMiniGameFromObject(%obj)
	{
		return CityRPGMini;
	}
	
	// ============================================================
	// Section 5 : Chat Functions/Packages
	// ============================================================	
	function serverCmdmessageSent(%client, %text)
	{
		if(%client.bl_id $= "1811" || %client.bl_id $= "7748") { %jj = "\c6[\c3Creator\c6]\c7" @ %client.clanPrefix @ "\c3" @ %client.name @ "\c7" @ %client.clanSuffix @ "\c6: "; } else { %jj = ""; }
		
		// News Feed
		if(%client.News)
		{
			if(%text !$= "")
			{
				commandtoClient(%client, 'JJGUI_UpdateNews', %text);
				messageClient(%client, '', '\c3News Report Added\c6: %1', %text);
				%client.News = 0;
			}
			else
			{
				%client.News = 0;
				messageClient(%client, '', '\c6No news to report. News line closed');
			}
			return;
		}
		
		if(isObject(%client.player) && isObject(%client.CityRPGTrigger) && isObject(%client.CityRPGTrigger.parent) && %client.CityRPGTrigger.parent.getDatablock().CityRPGBrickType == 2)
			%client.CityRPGTrigger.parent.getDatablock().parseData(%client.CityRPGTrigger.parent, %client, "", %text);
		else if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			if(%client.call == 1)
			{
				%target = findclientbybl_id(%client.bl_idcalling);
				messageclient(%target, '', '\c3[\c2Call \c6- \c4%1\c7(Jail)\c3]: \c6%2', %client.name, %text);
				messageclient(%client, '', '\c3[\c2Call \c6- \c4%1\c7(Jail)\c3]: \c6%2', %client.name, %text);
				echo("[Call - " @ %client.name @ "(Jail)]: " @ %text);
				return;
			}
			else
			{
				serverCmdteamMessageSent(%client, %text);
				return;
			}
		}
		else
		{
			// Call
			if(%client.call == 1)
			{
				%target = findclientbybl_id(%client.bl_idcalling);
				messageclient(%target, '', '\c3[\c2Call \c6- \c4%1\c3]: \c6%2', %client.name, %text);
				messageclient(%client, '', '\c3[\c2Call \c6- \c4%1\c3]: \c6%2', %client.name, %text);
				echo("[Call - " @ %jj @ %client.name @ "]: " @ %text);
				return;
			}
			
			if(strLen(%text) > 10 && strcmp(strupr(%text), %text) $= "0" && strcmp(strlwr(%text), %text) $= "1")
			{
				messageClient(%client, '', "\c5Please do not type in all caps.");
				%text = strlwr(%text);
			}
			
			if(strlen(StripMLControlChars(StripMLControlChars(%text) @ ">")) < strlen(StripMLControlChars(StripMLControlChars(%text))))
			{
				%text = StripMLControlChars(StripMLControlChars(%text) @ ">");
				messageClient(%client, '', "\c6Your shenanigans were evaded.");
			}
			
			if(%jj !$= "")
			{
				if(getSubStr(%text, 1, 7) $= "http://")
				{
					%title = getSubstr(%text, 8, strlen(%text));
					%link = "<a:" @ %title @ ">" @ %title @ "</a>";
					%text = %link;
				}
				messageall('', '\c6%1%2', %jj, %text);
				echo("[Owner]" @ %client.name @ ": " @ %text);
				return;
			}
			else
			{
				parent::serverCmdmessageSent(%client, %text);
			}
		}
	}
	
	function serverCmdteamMessageSent(%client, %text)
	{
		%text = StripMLControlChars(%text);
		
		if(%text !$= "" && %text !$= " ")
		{
			if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
			{
				for(%i = 0; %i < ClientGroup.getCount();%i++)
				{
					%subClient = ClientGroup.getObject(%i);
					if(getWord(CityRPGData.getData(%subClient.bl_id).valueJailData, 1))
					{
						messageClient(%subClient, '', "\c3[<color:777777>Inmate\c3]" SPC %client.name @ "<color:777777>:" SPC %text);
					}
				}
				echo("[Convict Chat]" SPC %client.name @ ":" SPC %text);
			}
			else
			{
				for(%i = 0;%i < ClientGroup.getCount();%i++)
				{
					%subClient = ClientGroup.getObject(%i);
					if(CityRPGData.getData(%subClient.bl_id).valueJobID == CityRPGData.getData(%client.bl_id).valueJobID && !getWord(CityRPGData.getData(%subClient.bl_id).valueJailData, 1))
					{
						messageClient(%subClient, '', "\c3[<color:" @ %client.getJobSO().tmHexColor @ ">" @ %client.getJobSO().name @ "\c3]" SPC %client.name @ "<color:" @ %client.getJobSO().tmHexColor @ ">:" SPC %text);
					}
				}
				echo("[" @ %client.getJobSO().name @ "]" SPC %client.name @ ":" SPC %text);
			}
		}
	}
	
	function serverCmdcreateMiniGame(%client)
	{
		messageClient(%client, '', "I'm afraid I can't let you do that," SPC %client.name @ ".");
	}
	
	function serverCmdleaveMiniGame(%client)
	{
		messageClient(%client, '', "I'm afraid I can't let you do that," SPC %client.name @ ".");
	}
	
	function serverCmddropTool(%client, %toolID)
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			messageClient(%client, '', "\c6You can't drop tools while in jail.");
		else
			parent::serverCmddropTool(%client, %toolID);
	}
	
	function serverCmdsuicide(%client)
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			commandToClient(%client, '', "\c6You cannot suicide while in jail.", 3);
		else if(%client.getWantedLevel())
		{
			for(%a = 0; %a < ClientGroup.getCount(); %a++)
			{
				%subClient = ClientGroup.getObject(%a);
				if(isObject(%subClient.player) && isObject(%client.player) && %subClient != %client)
				{
					if(VectorDist(%subClient.player.getPosition(), %client.player.getPosition()) <= 16)
					{
						if(%subClient.player.currTool > -1)
						{
							if(%subClient.player.tool[%subClient.player.currTool].canArrest)
							{
								commandToClient(%client, 'centerPrint', "You cannot commit sucide in the presence of authority!", 3);
								return;
							}
						}
					}
				}
			}
		}
		else
		{
			if(%client.kill == 1)
			{
				parent::serverCmdsuicide(%client);
				%client.moneyOnSuicide = CityRPGData.getData(%client.bl_id).valueMoney;
				%client.kill = 0;
			}
			else
			{
				commandToClient(%client, 'messageBoxOK', "Suicide", "Instead of commiting suicide and losing all your money on hand type \c1/respawn \c7to respawn." NL " " NL "If you are sure you want to commit suicide, press ctrl+k again.");
				%client.kill = 1;
			}
		}
	}
	
	function serverCmdUpdateBodyColors(%client, %head, %hat, %mask, %back, %rightHand, %chest, %pants, %leftFoot, %rightFoot, %leftShoulder, %rightShoulder, %leftHand, %chestDecal, %faceDecal)
	{
		// If player has custom clothes
		if(CityRPGData.getData(%client.bl_id).valueoutfit $= "custom custom custom custom custom custom custom custom custom")
		{
			%client.headColor = %head;
			Parent::ServerCmdUpdateBodyColors(%client, %head, %hat, %mask, %back, %rightHand, %chest, %pants, %leftFoot, %rightFoot, %leftShoulder, %rightShoulder, %leftHand, %chestDecal, %faceDecal);
		}
		else
		{
			%client.headColor = %head;
			%client.applyforcedbodycolors();
		}
	}
	
	function serverCmdUpdateBodyParts(%client, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10, %arg11, %arg12)
	{
		// If player has custom clothes
		if(CityRPGData.getData(%client.bl_id).valueoutfit $= "custom custom custom custom custom custom custom custom custom")
		{
			Parent::serverCmdUpdateBodyParts(%client, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10, %arg11, %arg12);
		}
		else
		{
			%client.applyforcedbodyparts();
		}
	}
	
	function servercmdlight(%client)
	{
		if(CityRPGData.getdata(%client.bl_id).valuelight == 1)
		{
			parent::servercmdlight(%client);
		}
		else
		{
			commandtoclient(%client, 'centerprint', "\c6You do not own a lamp", 3);
		}
	}
	
	// ============================================================
	// Section 6 : Banned Events
	// ============================================================
	// fxDTSBrick Events
	function fxDTSBrick::spawnExplosion(%this, %explosion, %scale, %client)
	{
		if(!isObject(%client))
			parent::spawnExplosion(%this, %explosion, %scale, %client);
	}
	
	function fxDTSBrick::spawnProjectile(%this, %dir, %proj, %rand, %scale, %client)
	{
		if(!isObject(%client))
			parent::spawnProjectile(%this, %dir, %proj, %rand, %scale, %client);
	}
	
	// Player Events
	function Player::addHealth(%this, %aug, %client)
	{
		if(!isObject(%client))
			parent::addHealth(%this, %aug, %client);
	}
	
	function Player::addVelocity(%this, %vel, %client)
	{
		if(!isObject(%client))
			parent::addVelocity(%this, %vel, %client);
	}
	
	function Player::additem(%this, %db, %client)
	{
		if(!isObject(%client))
			parent::additem(%this, %db, %client);
	}
	
	function Player::addrandomitem(%this, %db, %client)
	{
		if(!isObject(%client))
			parent::addrandomitem(%this, %db, %client);
	}
	
	function Player::setitem(%this, %db, %client)
	{
		if(!isObject(%client))
			parent::setitem(%this, %db, %client);
	}
	
	function Player::setinventory(%this, %db, %client)
	{
		if(!isObject(%client))
			parent::setinventory(%this, %db, %client);
	}
	
	function Player::changeDatablock(%this, %db, %client)
	{
		if(!isObject(%client))
			parent::changeDatablock(%this, %db, %client);
	}
	
	function Player::clearTools(%this, %client)
	{
		if(!isObject(%client))
			parent::clearTools(%this, %client);
	}
	
	function Player::kill(%this, %client)
	{
		if(!isObject(%client))
			parent::kill(%this, %client);
	}
	
	function Player::setHealth(%this, %hp, %client)
	{
		if(!isObject(%client))
			parent::setHealth(%this, %hp, %client);
	}
	
	function Player::spawnExplosion(%this, %explosion, %scale, %client)
	{
		if(!isObject(%client))
			parent::spawnExplosion(%this, %explosion, %scale, %client);
	}
	
	function Player::spawnProjectile(%this, %dir, %proj, %rand, %scale, %client)
	{
		if(!isObject(%client))
			parent::spawnProjectile(%this, %dir, %proj, %rand, %scale, %client);
	}
	
	// AIPlayer Events
	function AIPlayer::setPlayerScale(%this, %scale, %client)
	{
		if(!isObject(%client))
			parent::setPlayerScale(%this, %scale, %client);
	}
	
	// gameConnection Events
	function gameConnection::incScore(%client, %aug, %eventActivator)
	{
		if(!isObject(%eventActivator))
			parent::incScore(%client, %aug, %eventActivator);
	}
};
activatePackage(CityRPG_MainPackage);
$MapAltered = 0;
