// ============================================================
// Project				:	CityRPG
// Author				:	Iban & JJstorm
// Description			:	Server Preferences
// ============================================================
// Table of Contents
// 1. Basic Preferences
// 2. Price Preferences
// 2.1 Weapon Price Preferences
// 3. Tick Preferences
// 4. Demerit Preferences
// 5. Vehicle Preferences
// 7. Allowed Inmate 
// 8. Food
// 9. Banned Events
// 10. Hunger Colors and States
// 11. Weather Chances
// 12. Sicknesses
// ============================================================

// ============================================================
// Section 1 : Basic Preferences
// ============================================================
$CityRPG::client::RequireClient = 0;
$CityRPG::client::version = 1.71;
$CityRPG::server::version = 1.61;
$CityRPG::pref::bank::MaxLoan = 5000;
$CityRPG::pref::bank::MaxMoney = 1000000000;
$CityRPG::pref::MaxMoney = 1000000000;
$CityRPG::pref::bank::LoanDayPay = 25;
$CityRPG::pref::demerits::pardonCost = 100;
$CityRPG::pref::demerits::recordShredCost = 5000;
$CityRPG::pref::demerits::demeritCost = 2;
$CityRPG::pref::holiday = "";
$CityRPG::pref::canpicklockadmindoors = 1;
$CityRPG::pref::cancall = 1;
$CityRPG::pref::cancallbricks = 1;
$CityRPG::pref::PowerAdminProof = 1;

$CityRPG::pref::demerits::demoteLevel = 250;
$CityRPG::pref::demerits::wantedLevel = 50;

$CityRPG::pref::demerits::reducePerTick = 30;
$CityRPG::pref::demerits::minBounty = 200;

$CityRPG::pref::resources::tree::regrowTime = 2;
$CityRPG::pref::resources::ore::noOreColorID = 51;
$CityRPG::pref::resources::ore::hasOreColorID = 48;

$CityRPG::pref::realestate::maxLots = 2;

$CityRPG::pref::giveDefaultTools = true;
$CityRPG::pref::defaultTools = "hammerItem printGun wrenchItem keyitem";

$CityRPG::pref::moneyDieTime = 60000;

$CityRPG::pref::players::startingCash = 100;

$CityRPG::pref::lastjobID = 16;

$CityRPG::pref::radioname = "City Radio";
$CityRPG::pref::radiofreq = 103.5;

$CityRPG::pref::idlekicker = 1;

$CityRPG::AutoSaver::SaveFile = "autosave";
$CityRPG::AutoSaver::SaveTime = 10;
$CityRPG::AutoSaver::SaveOwnership = 1;
$CityRPG::AutoSaver::SaveEvents = 1;

// ============================================================
// Section 2 : Price Preferences
// ============================================================
$CityRPG::prices::vehicleSpawn = 2500;
$CityRPG::prices::BrickCost = 0;
$CityRPG::prices::jailingBonus = 25;
$CityRPG::prices::reset = 500;
$CityRPG::prices::resourcePrice = 1;
$CityRPG::prices::DriversLicense = 200;
$CityRPG::prices::Light = 10;
$CityRPG::prices::lights = 200;

// Section 2.1 - Weapon Prices
$CityRPG::prices::weapon::name[$CityRPG::guns] = "keyItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 5;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 0;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "gunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 80;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "taserItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 40;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "akimboGunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 150;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "shotgunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 260;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "rocketLauncherItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 350;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "sniperRifleItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 450;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "PillItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 30;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "crowbarItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 42;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "TommyGunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 180;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "CityRPGLBItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 100;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::guns = "";


// ============================================================
// Section 3 : Tick Preferences
// ============================================================
$CityRPG::tick::interest = 1.50;
$CityRPG::tick::creditInterest = 1.015;
$CityRPG::tick::interestTick = 12;
$CityRPG::tick::speed = 3;
$CityRPG::tick::promotionLevel = 24;

// Holidays
$CityRPG::Calendar::HolidayDate[1] = 1.1;
$CityRPG::Calendar::Holiday[1] = "\c2Happy New Year!";
$CityRPG::Calendar::HolidayDate[2] = 3.20;
$CityRPG::Calendar::Holiday[2] = "<bitmap:" @ hungericon.textureName @ "> \c2It's Cake day!";
$CityRPG::Calendar::HolidayDate[3] = 4.5;
$CityRPG::Calendar::Holiday[3] = "\c3It's Testing Day!";
$CityRPG::Calendar::HolidayDate[4] = 6.6;
$CityRPG::Calendar::Holiday[4] = "\c0IT'S RAGE DAY!";
$CityRPG::Calendar::HolidayDate[5] = 10.31;
$CityRPG::Calendar::Holiday[5] = "<bitmap:" @ hungericon.textureName @ "> \c6It's JJstorms's Birthday! Do What You Want, No Rules!";
$CityRPG::Calendar::HolidayDate[6] = 11.25;
$CityRPG::Calendar::Holiday[6] = "<bitmap:" @ hungericon.textureName @ "> \c6It's Thanksgiving!";
$CityRPG::Calendar::HolidayDate[7] = 12.25;
$CityRPG::Calendar::Holiday[7] = "<bitmap:" @ Bricks.textureName @ "> \c2M\c0e\c2r\c0r\c2y \c2C\c0h\c2r\c0i\c2s\c0t\c2m\c0a\c2s\c0! <bitmap:" @ Bricks.textureName @ ">";

// ============================================================
// Section 4 : Demerit Preferences
// ============================================================
$CityRPG::demerits::hittingInnocents = 10;
$CityRPG::demerits::attemptedMurder = 25;
$CityRPG::demerits::murder = 75;
$CityRPG::demerits::breakingAndEntering = 10;
$CityRPG::demerits::attemptedBnE = 5;
$CityRPG::demerits::bountyPlacing = 250;
$CityRPG::demerits::bountyClaiming = 500;
$CityRPG::demerits::pickpocketing = 25;
$CityRPG::demerits::bankRobbery = 3000;
$CityRPG::demerits::tasingBros = 25;
$CityRPG::demerits::grandTheftAuto = 75;
$CityRPG::demerits::RefuseLoan = 20;

// ============================================================
// Section 5 : Vehicle Preferences
// ============================================================
$CityRPG::vehicles::allowSpawn = true;

$CityRPG::vehicles::banned[0] = "FlyingWheeledJeepVehicle";
$CityRPG::vehicles::banned[1] = "MiniJetVehicle";
$CityRPG::vehicles::banned[2] = "StuntPlaneVehicle";
$CityRPG::vehicles::banned[4] = "MagicCarpetVehicle";
$CityRPG::vehicles::banned[5] = "TankVehicle";
$CityRPG::vehicles::banned[6] = "horseArmor";
$CityRPG::vehicles::banned[7] = "BlackhawkVehicle";

// ============================================================
// Section 7 : Allowed Inmate Items
// ============================================================
$CityRPG::demerits::jail::image["CityRPGLumberjackImage"] = true;
$CityRPG::demerits::jail::image["CityRPGShovelImage"] = true;
$CityRPG::demerits::jail::image["CityRPGPickaxeImage"] = true;

// Inmate Spawn Items
$CityRPG::demerits::jail::item[0] = "CityRPGPickaxeItem";

// ============================================================
// Section 8 : Food
// ============================================================
$CityRPG::portion[1] = "Small";
$CityRPG::portion[2] = "Medium";
$CityRPG::portion[3] = "Large";
$CityRPG::portion[4] = "Extra_Large";
$CityRPG::portion[5] = "Super_Sized";
$CityRPG::portion[6] = "Americanized";

// ============================================================
// Section 9 : Banned Events
// ============================================================
// $CityRPG::bannedEvent[nameSpace, name] = true; results in ban
// Note: This system is archaic.

// AIPlayer
$CityRPG::bannedEvent["AIPlayer", "setPlayerScale"] = true;

// fxDTSBrick
$CityRPG::bannedEvent["fxDTSBrick", "spawnExplosion"] = true;
$CityRPG::bannedEvent["fxDTSBrick", "spawnProjectile"] = true;

// gameConnection
$CityRPG::bannedEvent["gameConnection", "bottomPrint"] = true;
$CityRPG::bannedEvent["gameConnection", "incScore"] = true;
$CityRPG::bannedEvent["gameConnection", "instantRespawn"] = true;

// Player
$CityRPG::bannedEvent["Player", "addVelocity"] = true;
$CityRPG::bannedEvent["Player", "changeDatablock"] = true;
$CityRPG::bannedEvent["Player", "clearTools"] = true;
$CityRPG::bannedEvent["Player", "kill"] = true;
$CityRPG::bannedEvent["Player", "setHealth"] = true;
$CityRPG::bannedEvent["Player", "setPlayerScale"] = true;
$CityRPG::bannedEvent["Player", "spawnExplosion"] = true;
$CityRPG::bannedEvent["Player", "spawnProjectile"] = true;
$CityRPG::bannedEvent["Player", "setVelocity"] = true;

// ============================================================
// Section 10 : Hunger Colors and States
// ============================================================
$CityRPG::food::stateCount = 0;

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF0000";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Starving";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF6600";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Hungry";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFBB00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Content";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Satisfied";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "DDFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Full-up";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "AAFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Overfed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "88FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Stuffed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "66FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bloated";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "44FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Engorged";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "22FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Fat";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "00FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bursting";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFAA00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Disgusting";

// ============================================================
// Section 11 : Weather Chances
// ============================================================

// Chance Of Rain
$CityRPG::enviro::RainMonth1 = 5; // January
$CityRPG::enviro::RainMonth2 = 10; // February
$CityRPG::enviro::RainMonth3 = 15; // March
$CityRPG::enviro::RainMonth4 = 20; // April
$CityRPG::enviro::RainMonth5 = 30; // May
$CityRPG::enviro::RainMonth6 = 40; // June
$CityRPG::enviro::RainMonth7 = 50; // July
$CityRPG::enviro::RainMonth8 = 40; // August
$CityRPG::enviro::RainMonth9 = 30; // September
$CityRPG::enviro::RainMonth10 = 20; // October
$CityRPG::enviro::RainMonth11 = 15; // November
$CityRPG::enviro::RainMonth12 = 0; // December

// Chance Of Snow
$CityRPG::enviro::SnowMonth1 = 30; // January
$CityRPG::enviro::SnowMonth2 = 15; // February
$CityRPG::enviro::SnowMonth3 = 5; // March
$CityRPG::enviro::SnowMonth4 = 0; // April
$CityRPG::enviro::SnowMonth5 = 0; // May
$CityRPG::enviro::SnowMonth6 = 0; // June
$CityRPG::enviro::SnowMonth7 = 0; // July
$CityRPG::enviro::SnowMonth8 = 0; // August
$CityRPG::enviro::SnowMonth9 = 0; // September
$CityRPG::enviro::SnowMonth10 = 5; // October
$CityRPG::enviro::SnowMonth11 = 15; // November
$CityRPG::enviro::SnowMonth12 = 100; // December

// Current Day Type And Current Weather

$CityRPG::enviro::CurrDay = Day;
$CityRPG::enviro::CurrWeather = Clear;

// Times
$CityRPG::temp::calendar::datummin = 1;
$CityRPG::temp::calendar::datumhour = 1;
$CityRPG::temp::calendar::datumday = 1;
$CityRPG::temp::calendar::datummonth = 1;
$CityRPG::temp::calendar::datumyear = 1;

// ============================================================
// Section 12 : Sicknesses
// ============================================================
$CityRPG::Pref::Sicknesses = 1;

$CityRPG::Pref::SicknessName1 = "The Common Cold";
$CityRPG::Pref::SicknessType1 = "common";
$CityRPG::Pref::SicknessChance1 = 5;
$CityRPG::Pref::SicknessTime1 = 5;
$CityRPG::Pref::SicknessHealthReduce1 = -2;
$CityRPG::Pref::SicknessWalkReduce1 = -1;

$CityRPG::Pref::SicknessName2 = "The Flu";
$CityRPG::Pref::SicknessType2 = "common";
$CityRPG::Pref::SicknessChance2 = 2;
$CityRPG::Pref::SicknessTime2 = 30;
$CityRPG::Pref::SicknessHealthReduce2 = -5;
$CityRPG::Pref::SicknessWalkReduce2 = -5;

$CityRPG::Pref::SicknessName3 = "Food Poisoning";
$CityRPG::Pref::SicknessType3 = "food";
$CityRPG::Pref::SicknessChance3 = 5;
$CityRPG::Pref::SicknessTime3 = 5;
$CityRPG::Pref::SicknessHealthReduce3 = -2;
$CityRPG::Pref::SicknessWalkReduce3 = -1;

$CityRPG::Pref::SicknessName4 = "Tape Worms";
$CityRPG::Pref::SicknessType4 = "food";
$CityRPG::Pref::SicknessChance4 = 2;
$CityRPG::Pref::SicknessTime4 = 30;
$CityRPG::Pref::SicknessHealthReduce4 = -10;
$CityRPG::Pref::SicknessWalkReduce4 = -3;
